/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'newSmsCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("newSmsCtrl");
				amoebaDataFactory.setNewSMSCtrlScope($scope);
				
				$scope.factory = amoebaDataFactory;
				$scope.service = amoebaService;

				$scope.allUser = amoebaDataFactory.contactUserData;
				$scope.smsInfo = {};
				$scope.smsUserList = [];

				angular.copy(amoebaDataFactory.smsInfo, $scope.smsInfo);
				angular.copy(amoebaDataFactory.smsUserList, $scope.smsUserList);
			
				$scope.setSmsUserChecked = function(){
	
					if(!angular.equals({}, $scope.smsInfo)){	
						
						var userList = $scope.smsInfo.strary_sms_members_userkey;
						var struserkeyList =[];


						for(var i = 0; i < userList.length; i++){
							if(userList[i] == -1){ // no user key case
								$scope.smsUserList[i].typeName = amoebaService.getSmsType($scope.smsUserList[i].type);
							}
							else{
								for(var j = 0; j < $scope.allUser.length; j++){
									if(userList[i] == $scope.allUser[j].str_user_key.val){
										$scope.smsUserList[i].numberList = amoebaService.getNumberList($scope.allUser[j]);
										$scope.smsUserList[i].typeName = amoebaService.getSmsType($scope.smsUserList[i].type);
										//console.log("smsnumberlist");
										//console.log($scope.smsUserList[i].numberList);
										$scope.$emit('setSmsUserChecked', { "data" : $scope.allUser[j]})
										break;
									}
									if(j == $scope.allUser.length-1){
										struserkeyList.push(userList[i]);
									}
								}
							}

						}
						if(struserkeyList.length >0){
							amoebaDataFactory.getSomeUserInfo(struserkeyList).then(function(item){
								if(item != false){
									//console.log(item);
									for(var idx = 0 ; idx < item.length ; idx++){
										if(item[idx].str_user_key != undefined){
											for(var i = 0; i < $scope.smsUserList.length; i++){
												if($scope.smsUserList[i].id == item[idx].str_user_key.val){
													$scope.smsUserList[i].numberList = amoebaService.getNumberList(item[idx]);
													$scope.smsUserList[i].typeName = amoebaService.getSmsType($scope.smsUserList[i].type);
													//console.log("smsnumberlist2222");
													//console.log($scope.smsUserList[i].numberList);
													$scope.$emit('setSmsUserChecked', { "data" : item[idx]});
													break;
												}
											}
										}
									}
								}
							});
						}

						//obj.numberList = amoebaService.getNumberList(data.strary_sms_members_userkey[i]);
					}
				};
				$scope.setSmsUserChecked();
				
				// sms list 셀렉트박스 ui 디폴트 설정
				$scope.defaultSmsList = function(){
					if($scope.smsUserList.length != 0){
						for(var i = 0; i< $scope.smsUserList.length; i++){
							$scope.smsUserList[i].selNum = false;
							$scope.smsUserList[i].selType = false;
						}
					}
				};
				
				//$scope.defaultSmsList();

				// sms number list opne
				$scope.openSmsNumList = function(data){
					if(data.selNum){
						$scope.defaultSmsList();
					}
					else{
						$scope.defaultSmsList();
						data.selNum = true;
					}

				};
				
				// sms type list opne
				$scope.openSmsTypeList = function(data){
					if(data.selType){
						$scope.defaultSmsList();
					}
					else{
						$scope.defaultSmsList();
						data.selType = true;
					}
					
				};

				$scope.setNumber = function(data, number){
					var users = $scope.smsInfo.strary_sms_members_userkey;
					var numbers = $scope.smsInfo.strary_sms_members_number;

					for(var i=0; i<users.length; i++){
						if(data.id == users[i]){
							numbers[i] = number;
							data.number = number;
							break;
						}
						
					}
					
					$scope.defaultSmsList();
				};
				
				$scope.setType = function(data, type){
					var users = $scope.smsInfo.strary_sms_members_userkey;
					var types = $scope.smsInfo.strary_sms_members_type;
					
					for(var i=0; i<users.length; i++){
						if(data.id == users[i]){
							types[i] = type;
							data.type = type;
							data.typeName = amoebaService.getSmsType(type);
							break;
						}
						
					}
					
					$scope.defaultSmsList();
				};
				
				$scope.deleteSms = function(data){

					for(var j = 0; j<$scope.smsUserList.length; j++){
						
						if($scope.smsUserList[j].id == data.id){

							for(var k = 0; k < $scope.smsInfo.strary_sms_members_userkey.length; k++){
								if($scope.smsUserList[j].id == $scope.smsInfo.strary_sms_members_userkey[k]){
									$scope.smsInfo.strary_sms_members_userkey.splice(k, 1);
									$scope.smsInfo.strary_sms_members_number.splice(k, 1);
									$scope.smsInfo.strary_sms_members_type.splice(k, 1);
									$scope.smsInfo.strary_sms_members_result.splice(k, 1);
									$scope.smsInfo.strary_sms_members_name.splice(k, 1);
									
								}
							}

							$scope.smsUserList.splice(j, 1);
							$scope.$emit('deleteCheckSmsUser', { "data" : data.id});
							break;
						}
					}
				};
				
				// sms send 이벤트
				$scope.sendSms = function(){ // 0224 hyosung
					if($scope.smsUserList.length > 50){
						amoebaDataFactory.showMainFail("R_OVER_50_SMS_USERS");
						return;
					}

					amoebaDataFactory.sendSMS($scope.smsInfo).then(function(item){
						// update the result to ui
						//$scope.smsInfo.str_sms_content.val = $scope.smsInfo.str_sms_content.val.replace(/\n/g, '<br>');
						for(var idx = 0 ; idx < item.length ; idx++){
							if(item[idx]){
								$scope.smsUserList[idx].result = "0";
							}
							else{
								$scope.smsUserList[idx].result = "1";
							}

						}
						$scope.smsInfo.str_sms_content.val = "";
						amoebaDataFactory.showMainSuccess("lang_sms_sent");
					});
				};

	   			// new Sms 버튼 클릭 시
	   			$scope.goNewSms = function(){
	   				$scope.smsInfo = {};
	   				$scope.smsUserList = [];
	   				$scope.service.goPage(15);
	   			};

	   			$scope.$on("isAllCheck", function(event, args){
	   				
	   				var data = args.list;
	   				var check = args.check;
	   				
	   				for(var i in data){	   					
	   					var flag = false;
	   					var info = {};
	   					var id, name;
	   					for(var j in $scope.allUser){
	   						if(data[i].str_user_key.val == $scope.allUser[j].str_user_key.val){
	   							id = data[i].str_user_key.val;
	   							flag = true;
	   						}
	   					}
	   					if(!flag){
	   						id = "p";
	   					}
	   					info.id = id;
	   					info.name = amoebaService.getNameById(id);
						info.check = check;
						info.user = data[i];
	   					$scope.chekedUser(info);
	   				}
	   			});
	   			
	   			// 사용자를 추가한다
				$scope.$on("addNewSmsUser", function(event, args){
					//console.log(args);
					$scope.chekedUser(args);
				});
				
				$scope.chekedUser = function(args){
					//console.log("sms-checkdUser");

					if(angular.equals({}, $scope.smsInfo)){	
						angular.copy(amoebaDataFactory.smsDataBasicTemp, $scope.smsInfo);
					}
					else if(angular.isDefined($scope.smsInfo.str_sms_content) && !angular.isDefined($scope.smsInfo.strary_sms_members_userkey)){
						var text = $scope.smsInfo.str_sms_content.val;
						$scope.smsInfo = {};
						angular.copy(amoebaDataFactory.smsDataBasicTemp, $scope.smsInfo);
						$scope.smsInfo.str_sms_content.val = text;
					}

					// private 유저라면
					if(args.privateCheck){

						var obj = {};
						angular.copy(amoebaDataFactory.smsBasicTemp, obj);
						
						//obj.id = "p";
						obj.id = "-1";
						obj.name = "No information";
						obj.number = args.id;
						obj.numberList = [];
						obj.type = "Station";
						obj.deleteView = true;
						obj.result = 2;
						obj.typeName = amoebaService.getSmsType(obj.type);

						$scope.smsUserList.unshift(obj);
						//idList.unshift(obj.id);
						$scope.smsInfo.strary_sms_members_userkey.unshift(obj.id);
						$scope.smsInfo.strary_sms_members_number.unshift(obj.number);
						$scope.smsInfo.strary_sms_members_type.unshift(obj.type);
						$scope.smsInfo.strary_sms_members_result.unshift(obj.result);
						$scope.smsInfo.strary_sms_members_name.unshift(obj.name);
						
					}
					// private 유저가 아니라면
					else{
						//var all = $scope.allUser;
						var id = args.id;
						var check = args.check;
						var smsUsers = [];
						var user = args.user;

						var obj = {};
						angular.copy(amoebaDataFactory.smsBasicTemp, obj);

						obj.id = user.str_user_key.val;
						obj.name = user.str_first_name.val;
						/*if(id.charAt(0) == 'p'){
							obj.number = user.str_office_telephone.val;
						}
						else{
							obj.number = user.str_desk_phone1.val;
						}*/

						obj.numberList = amoebaService.getNumberList(user);
						obj.number = obj.numberList[0];
						obj.type = "Station";
						obj.deleteView = false;
						obj.result = 2;
						obj.typeName = amoebaService.getSmsType(obj.type);

						var deleteCheck = false;

						// 중복된 값이 있는지 배열에 확인하여 있으면 삭제한다
						for(var j = 0; j<$scope.smsUserList.length; j++){
							if($scope.smsUserList[j].id == user.str_user_key.val){
								deleteCheck = true;

								if(!check){
									for(var k = 0; k < $scope.smsInfo.strary_sms_members_userkey.length; k++){
										if($scope.smsUserList[j].id == $scope.smsInfo.strary_sms_members_userkey[k]){
											$scope.smsInfo.strary_sms_members_userkey.splice(k, 1);
											$scope.smsInfo.strary_sms_members_number.splice(k, 1);
											$scope.smsInfo.strary_sms_members_type.splice(k, 1);
											$scope.smsInfo.strary_sms_members_result.splice(k, 1);
											$scope.smsInfo.strary_sms_members_name.splice(k, 1);

										}
									}
									$scope.smsUserList.splice(j, 1);
								}
							}
						}

						// 중복된 값이 없다면 배열에 값을 추가한다
						if(!deleteCheck){
							$scope.smsUserList.unshift(obj);

							$scope.smsInfo.strary_sms_members_userkey.unshift(obj.id);
							$scope.smsInfo.strary_sms_members_number.unshift(obj.number);
							$scope.smsInfo.strary_sms_members_type.unshift(obj.type);
							$scope.smsInfo.strary_sms_members_result.unshift(obj.result);
							$scope.smsInfo.strary_sms_members_name.unshift(obj.name);
						}
					}
				};

				// sms recipients 리스트 스크롤
	       		$scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
						updateOnContentResize: true,
						autoScrollOnFocus: false
       				},
       				setWidth: '100%',
       				setHeight: $(this).parent().height(),
       				scrollInertia: 500
	       		}
			}
		]
	);
});
