/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'voiceMailManagerCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', '$interval', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, $interval, amoebaService, amoebaDataFactory) {
				//console.log("voiceCtrl");
				amoebaDataFactory.setvoicemailManagerCtrlScope($scope);

				/*
				$scope.$watch('voiceData.play_time', function(){
					//console.log("watch play_time");
				}, true);
				*/

				$scope.factory = amoebaDataFactory;
				$scope.voiceData = amoebaDataFactory.voiceData;
				$scope.volume_pop = false;

				$scope.clickVolumePop = function(){
					//console.log("clickVolumePop");
					if(amoebaDataFactory.stVmState.bIsPlay){
						$scope.volume_pop = !$scope.volume_pop;
					}
					else{
						amoebaDataFactory.showMainFail("lang_control_vm_volume_fail");
					}
				};
				$scope.$on("play_voicemail_end", function(event, args){
					$scope.volume_pop = false;
				});

				if(amoebaDataFactory.currentVoice.play_time == ""){
					angular.forEach($scope.voiceData, function(data){
						data.onData = false;
					});
				}


				// 보이스 메일 삭제
				$scope.deleteVoice = function(data){ // 0201 hyosung
					var voiceData = amoebaDataFactory.voiceData;
					amoebaDataFactory.deleteVoicemail(data.int_unique_id.val).then(function(item){
						if(item !== false){
							if(item.iResult === 0 ) {
								if(item !== false && item !==0){
									//amoebaDataFactory.showMainSuccess("lang_delete_vm_success");
									/*
									for(var i = 0; i < voiceData.length; i++){
										if(voiceData[i].int_unique_id.val == data.int_unique_id.val){
											var iDeletedUniqueId = data.int_unique_id.val;
											voiceData.splice(i, 1);
											if(amoebaDataFactory.currentVoice.int_unique_id.val  == iDeletedUniqueId){
												amoebaDataFactory.initCurrentVoicemail();
											}
											break;
										}
									}
									*/
									/*
									if(amoebaDataFactory.currentVoice.int_unique_id.val  == data.int_unique_id.val){
										amoebaDataFactory.initCurrentVoicemail();
									}
									*/
								}
							}
							else if(item.iResult == "x7003"){
								amoebaDataFactory.showMainFail("lang_vm_occupied_by_other");
							}
							else if(item.iResult == "x7004"){
								amoebaDataFactory.showMainFail("lang_vm_not_monitoring");
							}
							else{
								amoebaDataFactory.showMainFail("lang_delete_vm_fail");
							}
						}
						else{
							amoebaDataFactory.showMainFail("lang_delete_vm_fail");
						}
					});
				};

				$scope.voiceDelete = function(data){
					$scope.$emit('voiceDeletePopup', {"data" : data});
				};

				$scope.$on("deleteVoice", function(event, args){ // 0201 hyosung
					var data = args.data;
					$scope.deleteVoice(data);
				});

				
				// 보이스 메일 전체 삭제
				$scope.voiceAllDelete = function(){ // 0201 hyosung
					$scope.$emit('voiceAllDeletePopup', {});
				};

				$scope.$on("deleteAllVoice", function(event, args){
					if(!amoebaDataFactory.stVmState.bIsPlay){
						amoebaDataFactory.deleteAllVoicemail().then(function(item){
							if(item !== false){
								if(item.iResult === 0 ) {
									//$scope.voiceData = [];
									//amoebaDataFactory.voiceData = [];
									//amoebaDataFactory.initCurrentVoicemail();
								}
								else if(item.iResult == "x7003"){
									amoebaDataFactory.showMainFail("lang_vm_occupied_by_other");
								}
								else if(item.iResult == "x7004"){
									amoebaDataFactory.showMainFail("lang_vm_not_monitoring");
								}
								else if(item.iResult == "x700A"){
									amoebaDataFactory.showMainFail("E_700A");
								}
								else{
									amoebaDataFactory.showMainFail("lang_delete_vm_fail");
								}
							}
							else{
								amoebaDataFactory.showMainFail("lang_delete_vm_fail");
							}
						});
					}
					else{
						amoebaDataFactory.showMainFail("lang_delete_vm_fail");
					}
				});

				$scope.opneVoice = function(data){
					$scope.$emit('voicePlay', {"data" : data});
				};

				$scope.$on('voicePlay', function(event, args){
					var data = args.data;
					if(data.str_conv_log_duration.val == "00:00:00"){
						amoebaDataFactory.showMainFail("lang_play_vm_fail");
					}
					else if(amoebaDataFactory.myStatus.str_phone_status.val == 5|| amoebaDataFactory.myStatus.str_phone_status.val == 4 ||amoebaDataFactory.myStatus.str_phone_status.val == 3){
						amoebaDataFactory.showMainFail("lang_play_vm_fail");
					}
					else if(!amoebaDataFactory.stVmState.bIsPlay){
						data.onData = true;
						amoebaService.openVoicemail(data);
						$scope.playVoice();
					}
					else{
						if(amoebaDataFactory.stVmState.int_unique_id == data.int_unique_id.val){
							$scope.playVoice();
						}
						else{
							amoebaDataFactory.showMainFail("lang_play_vm_fail");
						}

					}
				});

				$scope.playVoice = function(){ // 0215 hyosung
					var data = $scope.factory.currentVoice;
					if(!amoebaDataFactory.stVmState.bIsPlay){
						if(amoebaDataFactory.myStatus.str_phone_status.val == 5|| amoebaDataFactory.myStatus.str_phone_status.val == 4 ||amoebaDataFactory.myStatus.str_phone_status.val == 3){
							amoebaDataFactory.showMainFail("lang_play_vm_fail");
						}
						else{
							amoebaDataFactory.playVisualVoicemail(data).then(function(item){
								if(item !== false){
									if(item.iResult ===0){
										angular.forEach($scope.voiceData, function(data) {
											data.onData = false;
										});
										data.onData = true;

										amoebaDataFactory.stVmState.bIsPlay = true;
										amoebaDataFactory.stVmState.int_unique_id = data.int_unique_id.val;
										amoebaDataFactory.stVmState.stRefVoiceData = data;
										amoebaService.playVoice(data);
									}
									else if(item.iResult == "x7003"){
										$scope.initOnData();
										amoebaDataFactory.showMainFail("lang_vm_occupied_by_other");
									}
									else if(item.iResult == "x7004"){
										$scope.initOnData();
										amoebaDataFactory.showMainFail("lang_vm_not_monitoring");
									}
									else{
										$scope.initOnData();
										amoebaDataFactory.showMainFail("lang_play_vm_fail");
									}
								}
								else{
									$scope.initOnData();
									amoebaDataFactory.showMainFail("lang_play_vm_fail");
								}
							});
						}
					}
					else{
						amoebaDataFactory.replayVisualVoicemail(data).then(function(item){
							amoebaService.playVoice(data);
						});
					}
				};

				$scope.initOnData = function(){
					amoebaDataFactory.stVmState.bIsPlay = false;
					angular.forEach($scope.voiceData, function(data) {
						data.onData = false;
					});
				};
				$scope.stopVoice = function(){ // 0215 hyosung
					if(!amoebaDataFactory.stVmState.bIsPlay){
						return;
					}
					var data = $scope.factory.currentVoice;
					amoebaDataFactory.stopVisualVoicemail(data).then(function(item){
						var stVMInfo = item;
						if(stVMInfo.iResult === 0){
							//$scope.initOnData();
							amoebaService.stopVoice(data);
							amoebaDataFactory.stVmState.bIsPlay = false;
						}
					});
				};

				$scope.pauseVoice = function(){

					var data = $scope.factory.currentVoice;
					amoebaDataFactory.pauseVisualVoicemail(data).then(function(item){
						if(item !== false && item !==0){
							amoebaService.pauseVoice();
						}
					});
				};
				$scope.downVoice = function(data){ // 0215 hyosung
					if(amoebaDataFactory.stVmState.bIsPlay === false){
						amoebaDataFactory.downloadVisualVoicemail(data);
					}
					else{
						amoebaDataFactory.showMainFail("lang_download_vm_disable");
					}
				};

				$scope.openFolder = function(){ // 0215 hyosung
					amoebaDataFactory.openVisualVoicemailFolder();
				};

				amoebaDataFactory.startVoicemailManager();

				if(amoebaDataFactory.chatVoiceData){
					//$scope.voiceData랑 위에서 가져온 데이터를 가지고 비교하셔서...
					//value에 해당 보이스메일 데이터를 담아서
					//$scope.opneVoice(value) 하시면 될거 같습니다.
					var data = amoebaDataFactory.chatVoiceData;
					for(var i = 0; i < $scope.voiceData.length; i++){
						if(data.int_unique_id.val == $scope.voiceData[i].int_unique_id.val){
							$scope.opneVoice($scope.voiceData[i]);
							break;
						}
					}
					amoebaDataFactory.chatVoiceData = null;
				}

				$scope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
					if(fromState.name == "main.voiceMail"){
						//console.log("change state from chatcontent to another");
						amoebaDataFactory.setvoicemailManagerCtrlScope(null);
					}
				});

				$scope.config1 = {
					autoHideScrollbar: true,
					theme : 'minimal-dark',
					advanced : { updateOnContentResize: true },
					setWidth : '100%',
					setHeight : $(this).parent().height(),
					scrollInertia : 500
				};
			}
		]
	);
});