/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'transCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("transCtrl");
			
////////////////////////////////////////////////////////////////// app start
//////////////////////////////////////////////////////////conversation start
				$scope.selected = "none";
				$scope.transData = amoebaDataFactory.TransUser;
				$scope.service = amoebaService;
				$scope.factory = amoebaDataFactory;
				$scope.resultData = [];
				$scope.dimSw = 0;

				if(amoebaDataFactory.callviewInfo != null){
					$scope.$emit("transUserCheck", {"userkey": amoebaDataFactory.callviewInfo.str_user_key.val});
				}

				amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "transuserlist");
				amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, $scope.transData);

				if($scope.transData.length == 0)
				{
					var transUser=[];


						for(var i in amoebaDataFactory.contactUserData)
						{
							if(!amoebaDataFactory.contactUserData[i].str_user_key.val.startsWith("p"))
							{
								transUser.push(amoebaDataFactory.contactUserData[i]);
							}
						}
						transUser = transUser.slice(0,5);
					    for(var i in transUser){
							transUser[i].is_selected = transUser[i].str_desk_phone1.val;
						}
						$scope.transData = transUser;
				}
				else
				{
					$scope.transData = $scope.transData.slice(0,5);
				}

				//내림차순 정렬
				function sortList(data){
					if(data.length == 0)return;

					data.sort(function (a, b) {
						return new Date(b.int_trans_num.val) < new Date(a.int_trans_num.val) ? -1 : new Date(b.int_trans_num.val) > new Date(a.int_trans_num.val) ? 1 : 0;
					});
				}

				$scope.selectTrans = function(data){
					if(amoebaDataFactory.callviewInfo != null){
						if(data.str_user_number.val == amoebaDataFactory.callviewInfo.str_user_number.val)
						{
							for(i in $scope.transData){
								if($scope.transData[i].str_user_key.val == amoebaDataFactory.callviewInfo.str_user_number.val){
									$scope.transData[i].check = true;
								}
							}
							return;
						}
					}

					$scope.selectId = data.str_user_number.val;
					$scope.resultData.length = 0;
					$scope.resultData.push(data)
					$scope.dimSwitch(1);
					data.check = true;
					for(i in $scope.transData){
						if($scope.transData[i].str_user_number.val == $scope.selectId){
							$scope.transData[i].check = true;
						}
						else if($scope.transData[i].str_user_number.val == amoebaDataFactory.callviewInfo.str_user_number.val){
							//$scope.transData[i].check = false;
						}
						else {
							$scope.transData[i].check = false;
						}
					}
					$scope.$emit("transResult", {"data": data});
				};


				// 다이얼로 trans 유저 추가 시
				$scope.$on("addNewTrans", function(event, args){
					var dial = args.data;
					var obj = {};
					angular.copy($scope.factory.basicUserTemp, obj);

					amoebaDataFactory.getUserInfoFromNumber(dial).then(function(item){
						if(item != false)
						{
							obj.str_user_key.val = item[0].str_user_key;
							obj.str_first_name.val = item[0].str_first_name;
							obj.str_desk_phone1.val = dial;
							obj.is_selected = dial;
						}
						else
						{
							obj.str_user_key.val = "p"+moment();
							obj.str_first_name.val = dial;
							obj.str_desk_phone1.val = dial;
							obj.is_selected = dial;
							obj.int_user_type.val =3;
						}

						$scope.resultData.length = 0;
						$scope.resultData.push(obj);
						$scope.dimSwitch(2);

						for(var i in $scope.transData){
							$scope.transData[i].check = false;
						}
						$scope.selectId = obj.str_user_key.val;
						$scope.service.resetCheck(amoebaDataFactory.contactUserData);
						$scope.service.resetCheck(amoebaDataFactory.allUserData);
						$scope.service.resetCheck(amoebaDataFactory.transUserData);
					});
				});
				
				$scope.service.resetCheck(amoebaDataFactory.contactUserData);
				$scope.service.resetCheck(amoebaDataFactory.allUserData);
				$scope.service.resetCheck(amoebaDataFactory.transUserData);
				
				$scope.$on("removeTrans", function(event, args){
					$scope.resetResult();
				});
				
				$scope.resetResult = function(){
					$scope.resultData.length = 0;
					$scope.selectId = "none";
					$scope.dimSwitch(0);
					$scope.service.resetCheck(amoebaDataFactory.transUserData);
					$scope.service.resetCheck(amoebaDataFactory.contactUserData);
					$scope.service.resetCheck(amoebaDataFactory.allUserData);
					$scope.service.resetCheck($scope.searchedUser);
				};
				
				$scope.dimSwitch = function(no){
					$scope.dimSw = no
				};
				
				$scope.UnscreenedTrans = function(){
					var isCalling = true;
					amoebaDataFactory.UnscreenedTrans = $scope.resultData[0];

					// Trans 후 calling 상태
					if(isCalling == true){
						amoebaDataFactory.UnscreenedTrans = $scope.resultData[0];
						$scope.$emit('transOnOff', { "data" : true });
					}
					// Trans 후 바로 끊어짐
					else{
						amoebaDataFactory.UnscreenedTrans = null;

						$scope.$emit("callButtonDefault", {});
						$scope.service.isCallEvent(0);

						$scope.resetResult();
						$scope.$emit('transOnOff', { "data" : false });
					}
				};
				
				$scope.$on('currentTraceUser', function(event, data) {
					var user = data.data;					
					$scope.selectTrans(user);
					if(user.str_user_key.val.charAt(0) == "p"){
						user.is_selected = user.str_office_telephone.val;
					}
					else{
						user.is_selected = user.str_desk_phone1.val;
					}
				});

				$scope.$on("$viewContentLoaded", function(event){
					$timeout(function () {
						amoebaDataFactory.printTrace("transuserpresencenotify");
						var contactUser = amoebaDataFactory.mainCtrlScope.contactUser;
						if($scope.transData != undefined){
							for(var j =0 ; j <$scope.transData.length; j++){
								for(var k in contactUser){
									if($scope.transData[j].str_user_key.val == contactUser[k].str_user_key.val){
										$scope.transData[j].str_phone_status.val = contactUser[k].str_phone_status.val;
										$scope.transData[j].str_im_status.val = contactUser[k].str_im_status.val;
									}
								}
							}
						}
					},1000);
				});


				$scope.UnscreenedTrans = function(){
					var transuserinfo =$scope.resultData[0];
					amoebaDataFactory.transloginfo[0]["int_transfer_log_id"].val =$scope.service.createtransuserId();
					amoebaDataFactory.transloginfo[0]["int_trans_num"].val =1;
					amoebaDataFactory.transloginfo[0]["str_first_name"].val = transuserinfo.str_first_name.val;
					amoebaDataFactory.transloginfo[0]["str_user_number"].val = transuserinfo.is_selected;
					amoebaDataFactory.transloginfo[0]["str_user_key"].val = transuserinfo.str_user_key.val;
					amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "transuserinfo");
					amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, amoebaDataFactory.transloginfo[0]);

					//amoebaDataFactory.TransUser.push(amoebaDataFactory.transloginfo[0]);
					$scope.$emit("callButtonDefault", {});
					if(amoebaDataFactory.ucsStatus == "IN_CALL")  // ring
					{
						amoebaDataFactory.transcall(1, amoebaDataFactory.transloginfo).then(function(item){
							if(item !== false){
								amoebaDataFactory.UnscreenedTrans == null;
								$scope.resetResult();
								$scope.$emit('transOnOff', { "data" : false });
							}
							else{
								amoebaDataFactory.showMainFail("FAILTOTRANSFERCALL");
								amoebaDataFactory.printTrace("transcallFail");
							}
						});
						//$scope.service.goPage(1); // main dashboard .....
					}
					else if(amoebaDataFactory.ucsStatus == "CALL_ING"){
						amoebaDataFactory.transcall(2, amoebaDataFactory.transloginfo).then(function(item){
							if(item != false){
								amoebaDataFactory.printTrace("transcallOK");
								amoebaDataFactory.UnscreenedTrans = $scope.resultData[0];
								$scope.resetResult();
								$scope.$emit('transOnOff', { "data" : false });
							}
							else{
								amoebaDataFactory.showMainFail("FAILTOTRANSFERCALL");
								amoebaDataFactory.printTrace("transcallFail");
							}
						});
					}
				};

				$scope.VoicemailTrans = function(){
					var transuserinfo =$scope.resultData[0];
					amoebaDataFactory.transloginfo[0]["int_transfer_log_id"].val =$scope.service.createtransuserId();
					amoebaDataFactory.transloginfo[0]["int_trans_num"].val =1;
					amoebaDataFactory.transloginfo[0]["str_first_name"].val = transuserinfo.str_first_name.val;
					amoebaDataFactory.transloginfo[0]["str_user_number"].val = transuserinfo.is_selected;
					amoebaDataFactory.transloginfo[0]["str_user_key"].val = transuserinfo.str_user_key.val;
					$scope.$emit("callButtonDefault", {});

					amoebaDataFactory.transcall(0,amoebaDataFactory.transloginfo).then(function(item){
						if(item !== false){
						
						}
						else{
							amoebaDataFactory.showMainFail("FAILTOTRANSFERCALL");
							amoebaDataFactory.printTrace("transcallFail");
						}
					});
				};
			}
		]
	);
});