/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'callmemoCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("callmemoCtrl");

				$scope.factory = amoebaDataFactory;
				$scope.date = amoebaService;
				$scope.currentClass = "bg_blue";
				$scope.currentBdClass = "bd_blue";
				$scope.addData;

		
				var convid = amoebaDataFactory.currentConvId;
				amoebaDataFactory.GetCallMemo(convid).then(function(item){
					if(item != false)
					{
						$scope.memoData = item;
						amoebaDataFactory.memoData = $scope.memoData;
					}
					else
					{
						$scope.memoData=[];
						amoebaDataFactory.memoData = $scope.memoData;
					}
				});
			
				for(var no in $scope.memoData){
					$scope.memoData[no].bool_is_edit.val = false;
					$scope.factory.memoData = $scope.memoData
				}
				
				$scope.setTime = function(){
					var current = amoebaService.chatTime();
					var result = current.date + " " + current.chat;
					return result;
				};
				
				$scope.defaultMemoSet = function(){
						// 최초 메모 입력창
						$scope.defaultMemo = {};
						angular.copy($scope.factory.meomTemp, $scope.defaultMemo);
						$scope.defaultMemo.str_memo_key.val = "defaultMemo";
						$scope.defaultMemo.bool_is_edit.val = true;
						$scope.defaultMemo.int_count = 0;
						$scope.defaultMemo.str_memo_date.val = $scope.setTime();
				};
			
				$scope.defaultMemoSet();

				$scope.deleteMemo = function(data){
					var id = data.str_memo_key.val;
					var data = $scope.memoData;


					amoebaDataFactory.DeleteCallMemo(id);
						for(var i in data){
							if(data[i].str_memo_key.val == id){
								data.splice(i, 1);
							}
						}
						$scope.factory.memoData = $scope.memoData;
				
				};
				/*
				 * call memo 수정 issue151 start
				 * 0.5초 후 글자 수 확인..... 한글 임력시에 최저 속도 기준
				 * 기본 textarea enter 계산
				 */
				var no = 0;
				var keyTime;
				$scope.countRe = function(event, data){
					
					var switchTime = 300;


					if(!angular.isUndefined(keyTime)){
						$timeout.cancel(keyTime);
						keyTime = undefined;
					}

					var krValue = function(){
						$scope.memoMaxLength(event, data);
					}
					
					keyTime = $timeout(krValue, switchTime);
				};

				/*
				 * 추가 저장된 textarea enter에 따른 resize
				 */
				var addKeyTime;
				$scope.resize = function(event, data){

					//issue 172 start
					var id = "#"+data.str_memo_key.val;

					var switchTime = 300;
					
					if(!angular.isUndefined(addKeyTime)){
						$timeout.cancel(addKeyTime);
						addKeyTime = undefined;
					}

					var krValue = function(){
						$(id).css('height','1px');
						$scope.memoMaxLength(event, data);
						var current = $(id).prop("scrollHeight") + 'px';
						$(id).css({'height' : current});
					}
					
					addKeyTime = $timeout(krValue, switchTime);
				};

				/*
				 * 추가된 함수
				 * 0.1 ~ 0.5초 시간 후에 실행되는 함수
				 */
				$scope.memoMaxLength = function(event, data) {

					event.target.blur();
					event.target.focus();

					//issue 172 start 한글 입력시 다시한번 데이터 수정 및 입력
					var id = "#"+data.str_memo_key.val;
					data.str_memo_textarea = $(id).val();
					var brCount = (data.str_memo_textarea.match(/\n/g) || []).length;
					data.str_memo_content.val = data.str_memo_textarea.replace(/\n/g, '<br>');
					
				};

				//200자 체크
				$scope.checkLength = function(data){
					var brCount;
					var count;
					var result;
					if(data.str_memo_textarea == undefined){
						brCount = (data.str_memo_content.val.match(/\n/g) || []).length;
						count = data.str_memo_content.val.length;
					}
					else{
						brCount = (data.str_memo_textarea.match(/\n/g) || []).length;
						count = data.str_memo_textarea.length;
					}
					while(count - brCount > 200){
						count--;
					}
					if(data.str_memo_textarea == undefined){
						result = data.str_memo_content.val.substring(0, count);
					}
					else{
						result = data.str_memo_textarea.substring(0, count);
					}
					//var result = data.str_memo_textarea.substring(0, count);
					data.str_memo_textarea = result;
					return result;
				};

				$scope.addMemo = function(data){
					//저장전에 200자 체크
					//issue 172 start
					var id = "#"+data.str_memo_key.val;
					data.str_memo_textarea = $(id).val();
					var content = data.str_memo_textarea.replace(/\n/g, '<br>');
					data.str_memo_content.val = content;

					if(data.str_memo_content.val == "")
					{
						return;
					}
					if(data.btn == $scope.factory.global.lang_add){

						if($scope.memoData.length > ($scope.factory.memoMaxCnt - 1)){
							$scope.$emit("memoOverCount", {});
							$scope.addData = data;
							return;
						}
						/*
						 * issue151 start
						 *scroll height값을 저장해서 전달
						 */
						$scope.resizeHei = 0;
						$scope.resizeHei = $(id).prop("scrollHeight");
						/*
						 * issue151 end
						 */

						var currenttime  = new Date();
						var time = amoebaDataFactory.currentTime(currenttime).sort;
						data.str_memo_date.val = time;
						data.int_conv_id = {val:amoebaDataFactory.currentConvId};
						amoebaDataFactory.printTrace("callmemolength");
						amoebaDataFactory.printTrace(data.str_memo_content.val.length);
						amoebaDataFactory.SavecallMemo(data).then(function(item){
							if(item != false)
							{
								$scope.addData = undefined;
								var obj = {};
								angular.copy($scope.defaultMemo, obj);
								obj.str_memo_key.val = item;
								obj.int_count = 0;
								obj.str_memo_date.val = time;
								obj.bool_is_edit.val = false;
								$scope.memoData.unshift(obj);
								$scope.factory.memoData = $scope.memoData;
								$scope.defaultMemo.str_memo_content.val = "";
								$scope.defaultMemo.str_memo_key.val = "defaultMemo";
								$scope.defaultMemo.int_count = 0;
								$scope.changeId($scope.defaultMemo);
							}
						});
					}
					else {
						data.bool_is_edit.val = false;
						var currenttime  = new Date();
						var time = amoebaDataFactory.currentTime(currenttime).sort;
						data.str_memo_date.val = time;
						$("#"+data.str_memo_key.val).focus();
						amoebaDataFactory.EditcallMemo(data)
					}
					$scope.factory.memoData = $scope.memoData;

				};
				
				$scope.$on("updateMemo", function(event, args){
						
					var id =$scope.memoData[$scope.memoData.length - 1].str_memo_key.val;
					amoebaDataFactory.DeleteCallMemo(id).then(function(item){
						if(item != false)
						{
							$scope.memoData.splice($scope.memoData.length - 1, 1);
							$scope.factory.memoData = $scope.memoData;
							$scope.addMemo($scope.addData);
						}
					});

				});
				
				$scope.$on("afterAddMemo", function(event, args){
					$scope.addMemo($scope.addData);
				});

				$scope.resizeHei =0;

				$scope.changeId = function(data){
					
					$("#memo").attr("id", data.str_memo_key.val);
					data.btn = $scope.factory.global.lang_add;

					if(data.str_memo_content.val == ""){
						data.str_memo_textarea = "";
						data.count = 0;
					}
					else {
						var content;
						if(data.str_memo_textarea == undefined){
							content = data.str_memo_content.val.replace(/[<]br[>]/gi,'\n');
						}
						else{
							content = data.str_memo_textarea.replace(/[<]br[>]/gi,'\n');
						}
						var arr = (content.split('\n') || []);

						var id = "#"+data.str_memo_key.val;

						if(arr.length > 1){
								$(id).css('height','1px');
								$(id).css('height', arr.length * 19 +'px');
						}
						else {
							if(data.str_memo_key.val != "defaultMemo"){

								if($scope.resizeHei == 0 || !angular.isDefined($scope.resizeHei)){
									$scope.resizeHei = $(id).prop("scrollHeight")
								}
								$timeout(function(){
									if($scope.resizeHei == 0){
										$scope.resizeHei = $(id).prop("scrollHeight");
									}
									$(id).css('height',"1px");
									$(id).css({'height' : $scope.resizeHei+'px'});
									$scope.resizeHei = 0;
								}, 100);
							}
						}
						data.str_memo_textarea = content;
					}
				};

				$scope.editMemo = function(data){
					var id = "#"+data.str_memo_key.val;
					data.bool_is_edit={val:true};
					$(id).focus();
					data.btn = $scope.factory.global.lang_save;
				};

				$scope.sortconvlog = function(data)	{
					if(data.length == 0){
						return;
					}
					data.sort(function (a, b) {
						return new Date(b.str_memo_date.val) < new Date(a.str_memo_date.val) ? -1 : new Date(b.str_memo_date.val) > new Date(a.str_memo_date.val) ? 1 : 0;
					});
				};

				$scope.$watch("factory.ucsStatus", function(){
					if($scope.factory.ucsStatus != "IN_CALL" && $scope.factory.ucsStatus != "OUT_CALL" 
						&& $scope.factory.ucsStatus != "IN_GROUP_CALL" && $scope.factory.ucsStatus != "OUT_GROUP_CALL" 
							&& $scope.factory.ucsStatus != "CALL_ING"){
						$scope.currentBdClass = "bd_blue";
						$scope.currentClass = "bg_blue";
					} else {
						$scope.currentBdClass = "bd_green";
						$scope.currentClass = "bg_green";
					}
				});

				// 콜메모 리스트 스크롤
				$scope.config1 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					axis: 'y',
					setHeight: 'calc(100% - 22.6rem)',
					scrollInertia: 300,
					mouseWheel:{ deltaFactor: 60 }
				}
			}
////////////////////////////////////////////////////////////////////		app end
		]
	);
});
