/**
 * Created by sunyongpark on 2015-10-21.
 */
define(['ucApp'], function(ucApp){
	ucApp.registerService(
		'amoebaService',
		['$state', '$interval', 'amoebaDataFactory', function($state, $interval, amoebaDataFactory){
			var messenger = {
				//페이지 전환
				goPage : function(no){
					if(no > 0){
						var scope = amoebaDataFactory.mainCtrlScope;
						var url = "";

						amoebaDataFactory.currentPage = no;
						scope.isUserList = false;
						scope.dialButtonName = scope.factory.global.lang_add_private;
						scope.allCheck = false;
						scope.isEditShow = false;
						scope.isPopupShow = false;
						scope.isDialdirect = false;
						//scope.showOption = false;

						if(amoebaDataFactory.UnscreenedTrans == null && amoebaDataFactory.currentPage != 8){
							scope.transAct = false;
						}
					}
					amoebaDataFactory.isAction = "CLICK";
					amoebaDataFactory.isDrag = false;
					amoebaDataFactory.isDragEnd = false;
					amoebaDataFactory.isMoveDummy = false;

					// 채팅 검색 초기화
					amoebaDataFactory.searchIndex = 0;
					
					// 보이스 메일 인터벌 객체 초기화
					if(angular.isDefined(amoebaDataFactory.currentPlayVoice)){
						$interval.cancel(amoebaDataFactory.currentPlayVoice);
						amoebaDataFactory.currentPlayVoice = null;
					}

					if($state.current.name == "login" && no === 0){
						this.deleteLoginScroll();
					}
					if($state.current.name.indexOf("main") > -1 && no === -1){
						this.deleteMainScroll();
					}
					if($state.current.name == "main.content" && no !== 1){
						this.deleteContentScroll();
					}
					if($state.current.name == "main.createconversation" && no !== 2){
						this.deleteCreateConversationScroll();
					}
					if($state.current.name == "main.addcontact" && no !== 3 && no !== 18){
						this.deleteAddContactScroll();
					}
					if($state.current.name == "main.chatcontent" && no !== 4){
						this.deleteChatContentScroll();
					}
					if($state.current.name == "main.sms" && no !== 5){
						this.deleteSMSScroll();
					}
					if($state.current.name == "main.voiceMail" && no !== 6){
						this.deleteVoicemailScroll();
					}
					if($state.current.name == "main.file" && no !== 7){
						this.deleteFileScroll();
					}
					if($state.current.name == "main.trans" && no !== 8){
						this.deleteTransScroll();
					}
					if($state.current.name == "main.calling" && no !== 9){
						this.deleteCallingScroll();
					}
					if($state.current.name == "main.deletecontact" && no !== 10 && no !== 14){
						this.deleteDeleteContactScroll();
					}
					if($state.current.name == "main.calendar" && no !== 11){
						this.deleteCalendarScroll();
					}
					if($state.current.name == "main.callmemo" && no !== 12){
						this.deleteCallMemoScroll();
					}
					if($state.current.name == "main.userlist" && no !== 13){// && no !== 20){
						this.deleteUserListScroll();
					}
					if($state.current.name == "main.newSms" && no !== 15){
						this.deleteNewSMSScroll();
					}
					if($state.current.name == "main.record" && no !== 19){
						this.deleteRecordScroll();
					}
					if($state.current.name == "main.addUserlist" && no !== 20){//} && no !== 13){
						this.deleteAddUserListScroll();
					}
					if($state.current.name == "main.addCallUserlist" && no !== 21 && no !== 22 && no !== 23){
						this.deleteAddCallUserListScroll();
					}


					switch (no) {
						case -1:
							amoebaDataFactory.refreshForLoginCtrl().then(function(item){
								$state.go('login');
								amoebaDataFactory.RefreshMemoryData();
							});
							break;
						case 0 :
							url= 'main';
							////console.log("go page : 0");
							break;
						case 1 :
							//메인페이지
							url= 'main.content';
							// $scope.isTopwrap='chat';
							scope.isPageNum = 'home';
							scope.isTopwrap = false;
							scope.isUserList = false;
							scope.isDialdirect = false;
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							this.resetCheck(scope.groupDatas);
							this.resetCheck(scope.organization);
							if(scope.orgUserList != undefined){
								if(scope.orgUserList[0] != undefined){
									this.resetCheck(scope.orgUserList[0].deptMember);
									scope.orgUserList[0].check = false;
								}
							}
							////console.log("go page : 1");
							break;
						case 2 :
							//conversation 등록창
							url= 'main.createconversation';
							amoebaDataFactory.isAction = "NONE";
							scope.isUserList = true;
							scope.isTopwrap = false;
							scope.allCheck = true;
							scope.isDialdirect = false;
							scope.dialButtonName = scope.factory.global.lang_add_member;
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							scope.isPageNum ="";
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							////console.log("go page : 2");
							break;
						case 3 :
							//contact user 등록창
							url= 'main.addcontact';
							scope.isTopwrap='adduser';
							scope.isPageNum='adduser';
							scope.isEditShow = false;
							scope.isDialdirect = false;
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							//this.resetCheck(amoebaDataFactory.multiselectMemberlist);
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							////console.log("go page : 3");
							break;
						case 4 :
							//chat
							url= 'main.chatcontent';
							amoebaDataFactory.isAction = "NONE";
							amoebaDataFactory.isDrag = true;
							scope.isDialdirect = false;
							scope.isTopwrap='chat';
							scope.isPageNum='chat';
							////console.log("go page : 4");
							break;
						case 5 :
							//sms
							url = 'main.sms';
							scope.isTopwrap='smsmanager';
							scope.isPageNum ='smsmanager';
							scope.isDialdirect = false;
							scope.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							scope.resetCheck(scope.groupDatas);
							scope.resetCheck(scope.organization);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							scope.allCheck = true;
							////console.log("go page : 5");
							break;
						case 6 :
							//voiceMail
							url = 'main.voiceMail';
							scope.isTopwrap='voicemailmanager';
							scope.isPageNum ='voicemailmanager';
							scope.isDialdirect = false;
							////console.log("go page : 6");
							break;
						case 7 :
							//file
							url = 'main.file';
							scope.isTopwrap='filemanager';
							scope.isPageNum ='filemanager';
							scope.isDialdirect = false;
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							//this.resetCheck(amoebaDataFactory.multiselectMemberlist);
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							////console.log("go page : 7");
							break;
						case 8 :
							url = 'main.trans';
							scope.isTopwrap='trans';
							scope.isPageNum ='trans';
							amoebaDataFactory.isAction = "CLICK";
							scope.isUserList = true;
							scope.allCheck = false;
							scope.isDialdirect = false;
							scope.dialButtonName = scope.factory.global.lang_add_trans;
							scope.resetCheck(amoebaDataFactory.contactUserData);
							scope.resetCheck(scope.groupDatas);
							scope.resetCheck(scope.organization);
							scope.resetCheck(amoebaDataFactory.multiselectMemberlist);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							amoebaDataFactory.multiselectMemberlist=[];
							//this.resetCheck(amoebaDataFactory.multiselectMemberlist);
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							////console.log("go page : 8");
							break;
						case 9 :
							url = 'main.calling';
							scope.isTopwrap='calling';
							scope.isPageNum ='calling';
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 9");
							break;
						case 10 :
							url = 'main.deletecontact';
							scope.isPageNum='deleteContact';
							scope.isTopwrap=false;
							scope.isUserList = true;
							scope.isEditShow = false;
							scope.isDialdirect = false;
							amoebaDataFactory.isAction = "NONE";
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							amoebaDataFactory.multideptlist=[];
							//this.resetCheck(amoebaDataFactory.multiselectMemberlist);
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							amoebaDataFactory.multiselectMemberlist=[];
							////console.log("go page : 10");
							break;
						case 11 :
							url = 'main.calendar';
							scope.isPageNum='scheduleInfo';
							scope.isTopwrap='scheduleInfo';
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 11");
							break;
						case 12 :
							url = 'main.callmemo';
							scope.isPageNum='callmemo';
							scope.isTopwrap='callmemo';
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 12");
							break;
						case 13 :
							//user list
							url = 'main.userlist';
							scope.isPageNum='userlist';
							scope.isTopwrap='userlist';
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 13");
							break;
						case 14 :
							url = 'main.deletecontact';
							scope.isPageNum='deleteContact';
							scope.isTopwrap=false;
							scope.isUserList = true;
							scope.isEditShow = false;
							scope.isDialdirect = false;
							//scope.allCheck = true;
							scope.allDeptCheck = true;
							amoebaDataFactory.isAction = "NONE";
							this.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							//this.resetCheck(amoebaDataFactory.multiselectMemberlist);
							amoebaDataFactory.multideptlist=[];
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							amoebaDataFactory.multiselectMemberlist=[];
							////console.log("go page : 14");
							break;
						case 15 :
							url = 'main.newSms';
							scope.isPageNum='newSms';
							scope.isTopwrap='newSms';
							scope.isUserList = true;
							scope.tabMenu = 1;
							scope.dialButtonName = scope.factory.global.lang_add_sms;
							amoebaDataFactory.isAction = "NONE";
							scope.isDialdirect = false;
							scope.allCheck = true;
							scope.switchGroupEvent(true);
							scope.resetCheck(amoebaDataFactory.contactUserData);
							this.resetCheck(amoebaDataFactory.searchedUser);
							scope.resetCheck(amoebaDataFactory.multiselectMemberlist);
							scope.resetCheck(scope.groupDatas);
							scope.resetCheck(scope.organization);
							amoebaDataFactory.multideptlist=[];
							//this.resetCheck(amoebaDataFactory.deptmemberlist);
							amoebaDataFactory.multiselectMemberlist=[];
							////console.log("go page : 15");
							break;
						/*
						case 16 :
							// search
							// url = 'main.newSms';
							scope.isPageNum='noInp';
							scope.isTopwrap='search';
							scope.isDialdirect = false;
							// scope.isUserList = true;
							// scope.tabMenu = 1;
							//console.log("go page : 16");
							break;
						case 17 :
							// edit title
							// url = 'main.newSms';
							scope.isPageNum='chat';
							scope.isTopwrap='edit';
							scope.isDialdirect = false;
							// scope.isUserList = true;
							// scope.tabMenu = 1;
							//console.log("go page : 17");
							break;
							*/
						case 18 :
							// dialpad -> add private user
							url= 'main.addcontact';
							scope.isTopwrap='adduser';
							scope.isPageNum='adduser';
							scope.addUser = 2;
							scope.isDialdirect = false;
							scope.saveCellularPhone = scope.dial.number;
							// addContactTmpl에서 addUser==1 ? shared user, addUser == 2 ? private user >> 수정완료
							// 밑에 값 반응 안함 수정 필요.
							////console.log("go page : 18");
							break;
						case 19 :
							// dialpad -> add private user
							url= 'main.record';
							scope.isTopwrap='chat';
							scope.isPageNum='record';
							scope.isDialdirect = false;
							// addContactTmpl에서 addUser==1 ? shared user, addUser == 2 ? private user >> 수정완료
							// 밑에 값 반응 안함 수정 필요.
							////console.log("go page : 19");
							break;
						case 20 :
							//invite
							url = 'main.addUserlist';
							amoebaDataFactory.isAction = "NONE";
							scope.dialButtonName = scope.factory.global.lang_add_member;
							scope.isPageNum='userlist';
							scope.isTopwrap='userlist';
							scope.allCheck = true;
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 20");
							break;
						case 21 :
							//call invite
							url = 'main.addCallUserlist';
							amoebaDataFactory.isAction = "NONE";
							scope.dialButtonName = scope.factory.global.lang_add_member;
							scope.isPageNum='userlist';
							scope.isTopwrap='calling';
							scope.allCheck = true;
							scope.isUserList = false;
							scope.isDialdirect = false;
							scope.chatName = scope.taskTitle;
							////console.log("go page : 21");
							break;
						case 22 :
							url = 'main.addCallUserlist';
							amoebaDataFactory.isAction = "NONE";
							scope.dialButtonName = scope.factory.global.lang_add_member;
							scope.isPageNum='userlist';
							scope.isTopwrap='userlist';
							scope.allCheck = true;
							scope.isUserList = false;
							scope.isDialdirect = false;
							scope.chatName = "";
							////console.log("go page : 22");
							break;
						case 23 :
							url = 'main.addCallUserlist';
							amoebaDataFactory.isAction = "NONE";
							scope.isPageNum='userlist';
							scope.isTopwrap='userlist';
							scope.allCheck = true;
							scope.isUserList = false;
							scope.isDialdirect = false;
							////console.log("go page : 23");
							break;
						case 24 :
							url = 'main.flexButton';
							scope.isTopwrap='flexButtonmanager';
							scope.isPageNum ='flexButtonmanager';
							scope.isDialdirect = false;
							////console.log("go page : 24");
							break;
						case 25:
							url = 'main.testCode';
							scope.isTopwrap='testCode';
							scope.isPageNum ='testCode';
							scope.isDialdirect = false;
							break;
					}
					if(no >= 0){
						$state.go(url);
					}

				},
				chatSet : function(data){
					data.picture = this.currentPic(data);
					var no = data.int_conv_log_type.val;
					var state =  data.int_conv_log_direction.val;
					// {0 : \'notice_msg\',
					//1 : \'in text\', 2 : \'in image\', 3 : \'in file\', 4 : \'in call\', 5 : \'in call\',
					//6 : \'in voice\', 7 : \'in record\',
					//8: \'out text\', 9 : \'out image\', 10 : \'out file\',
					//11 : \'out call\', 12 : \'out call\'
					//13 : \'out voice\', 14 : \'out record\'}[callData.int_conv_UI.val]">'+
					//14:
					//15:

					//16 : callback


//	   				DATA : 1. call 2. missed call, 3. im 4, sms, 5. note 6. adminmsg 7.voicemail 8. picture 9. file, 10. callback
//	   				UI   : 0 : \'recive\', 1 : \'send\', 2 : \'missed\', 3 : \'\', 4 : \'sms\', 5 : \'\', 7 : \'voice\', 8 : \'pic\', 9 : \'clip\' 사용안함.... 위에 새 값으로 교체

					if(state == 1){
						if(no == 6){
							//공지사항
							data.int_conv_UI.val = 1;
						} else if(no == 1){
							// 수신전화
							data.int_conv_UI.val = 5;
						} else if(no == 2){
							// 부재중전화
							data.int_conv_UI.val = 4;
						} else if(no == 3 || no == 4|| no == 5){
							if(data.str_user_key.val == "inviteUser"){
								data.int_conv_UI.val = 15;
							} else {
								data.int_conv_UI.val = 1;
							}
						} else if(no == 7) {
							data.int_conv_UI.val = 6;
						} else if(no == 8){
							data.int_conv_UI.val = 2;
						} else if(no == 9){
							data.int_conv_UI.val = 3;
						} else if(no == 10){
							data.int_conv_UI.val = 16;
						}
					} else if(state == 2){
						if(no == 1){
							// 발신전화
							data.int_conv_UI.val = 12;
						} else if(no == 3 || no == 4 || no == 5){
							if(data.str_user_key.val == "inviteUser"){
								data.int_conv_UI.val = 15;
							} else {
								data.int_conv_UI.val = 8;
							}
						} else if(no == 7){

							data.int_conv_UI.val = 13;
						} else if(no == 8){

							data.int_conv_UI.val = 9;
						} else if(no == 9){

							data.int_conv_UI.val = 10;
						}
					}
				},
				createPhoneData : function(data){
					//console.log("createPhoneData//////////////////////////////////////////////");
					data.phoneArr = [];
					data.selectedPhone;
					if(angular.isDefined(data.str_desk_phone1) && data.str_desk_phone1.val != "" && angular.isDefined(data.str_desk_phone1.val)){
						data.phoneArr.push(data.str_desk_phone1.val);
					}
					if(angular.isDefined(data.str_cellular_phone) && data.str_cellular_phone.val != "" && angular.isDefined(data.str_cellular_phone.val)){
						data.phoneArr.push(data.str_cellular_phone.val);
					}
					if(angular.isDefined(data.str_home_telephone) && data.str_home_telephone.val != "" && angular.isDefined(data.str_home_telephone.val)){
						data.phoneArr.push(data.str_home_telephone.val);
					}
					if(angular.isDefined(data.str_office_telephone) && data.str_office_telephone.val != "" && angular.isDefined(data.str_office_telephone.val)){
						data.phoneArr.push(data.str_office_telephone.val);
					}
					
					data.selectedPhone = data.str_user_number.val;
					data.selectedtype = (data.str_user_key.val == "dummy" ? "MD1-userCard type_10" : "MD1-userCard type_11") 
					
					if(data.str_user_key.val != "dummy" && data.str_user_key.val != "add"){
						
						data.selectedtype = this.selectTypeFunc(data.int_ui_type);
					}
				},
				selectTypeFunc : function(no){
					var result;
					switch(no){
						case 1 :
							result = "MD1-userCard type_1";
							break;
						case 2 :
							result = "MD1-userCard type_2";
							break;
						case 3 :
							result = "MD1-userCard type_3";
							break;
						case 4 :
							result = "MD1-userCard type_4";
							break;
						case 5 :
							result = "MD1-userCard type_5";
							break;
						case 6 :
							result = "MD1-userCard type_6";
							break;
						case 7 :
							result = "MD1-userCard type_7";
							break;
						case 8 :
							result = "MD1-userCard type_8";
							break;
						case 9 :
							result = "MD1-userCard type_9";
							break;
						case 10 :
							result = "MD1-userCard type_10";
							break;
						case 11 :
							result = "MD1-userCard type_11";
							break;
						case 12 :
							result = "MD1-userCard type_12";
							break;
						case 13 :
							result = "MD1-userCard type_13";
							break;
						case 14 :
							result = "MD1-userCard type_14";
							break;
					}
					return result;
				},
				//photo mapping
	   			updatePic : function(datas){
					////console.log("updatePic");
				    ////console.log(amoebaDataFactory.pictureData);
					var scope = amoebaDataFactory.mainCtrlScope;
					var contatctlist = amoebaDataFactory.contactUserData;
	   				var list = [];
	   				var data = [];
	   				var val = "";
	   				//if(typeof datas.str_conv_member_userkey != undefined){
						//amoebaDataFactory.printTrace("userkey");
						//amoebaDataFactory.printTrace(datas);
						//amoebaDataFactory.printTrace(datas.str_user_key.val);
					//}
					if(typeof datas.strary_conv_members_userkey === "undefined" || (datas.bool_is_group.val == false)){
						val = datas.str_conv_member_userkey.val;
						data.push(val);
	   				} else {
	   					val = datas.strary_conv_members_userkey;
	   					data = val;
	   				}
	   				var picDatas = amoebaDataFactory.pictureData;

	   				var convType;

	   				if(angular.isDefined(datas.int_conv_type)){

	   					convType = datas.int_conv_type.val;
	   				} else {

	   					convType = datas.int_conv_log_type.val;
	   				}

	   				if(convType == 6){
					    list.push({"val": amoebaDataFactory.noticeimage[0].str_picture_data.val});
	   				} else {

						if(data == "" || data == null){
							list.push({"val":amoebaDataFactory.defaultimage});
							return list;
						}
						//data.length > 4 ?  data.length = 4 : data.length; // by hycha --> picturelist only used 4 members
						////console.log("picturememberlength");
						////console.log(data.length);
						for(var selNo = 0; selNo < data.length; selNo++){
							for(var no in picDatas){
		   						if(data[selNo] == picDatas[no].str_user_key.val){
		   							list.push({"val" : picDatas[no].str_picture_data.val});
		   							break;
		   						}
								if(data[selNo] == amoebaDataFactory.userInfoData.str_my_key){
									list.push({"val":amoebaDataFactory.userInfoData.str_picture_data.val});
									break;
								}
		   						if(no == picDatas.length - 1){
									for(var i=0; i <contatctlist.length;i++)
									{
										if(data[selNo] == contatctlist[i].str_user_key.val)
										{
											//list.push({val:amoebaDataFactory.defaultimage});
											//break;
										}
										if(i == contatctlist.length -1)
										{
											list.push({"val":amoebaDataFactory.defaultimage});
											////console.log(list);
											break;
										}
									}
		   						}
		   					}
							if(picDatas.length == 0){
								list.push({"val":amoebaDataFactory.defaultimage});
							}

		   				}

	   				}
	   				////console.log("picturedata");
					////console.log(list);
					return list;
	   			},
	   			getNameById : function(data){
				    if(data.indexOf == undefined){
					    return;
				    }
	   				if(data.indexOf("p") > -1){
						return "No information";
					}
					else{
						var all = amoebaDataFactory.contactUserData;
						for(var i in all){
							if(data == all[i].str_user_key.val){
								return  all[i].str_first_name.val;
							}
						}
					}	
	   			},
	   			//conversation status
	   			updateStatus : function(datas) {
	   				var list = [];
//	   				DATA : 1. call 2. missed call, 3. im 4, sms, 5. note 6. adminmsg 7.voicemail 8. picture 9. file 10: callback
//	   				UI   : 0 : \'recive\', 1 : \'send\', 2 : \'missed\', 3 : \'\', 4 : \'sms\', 5 : \'\', 7 : \'voice\', 8 : \'pic\', 9 : \'clip\' 10: im, 11: callback
	   				var type;
	   				var int_conv_direction;

	   				if(angular.isDefined(datas.int_conv_type)){

	   					type = datas.int_conv_type.val;
	   					int_conv_direction = datas.int_conv_direction.val;
	   				} else {

	   					type = datas.int_conv_log_type.val;
	   					int_conv_direction = datas.int_conv_log_direction.val;

	   				}

	   				var result = 0;

	   				if(type == 1){
	   					if(!datas.bool_is_group.val){
		   					if(int_conv_direction == 1){
		   						if(typeof datas.int_conv_position !== "undefined"){
		   							datas.int_conv_position.val = 2;
		   						}
		   						result = 0;
		   					} else {
		   						if(typeof datas.int_conv_position !== "undefined"){
		   							datas.int_conv_position.val = 2;
		   						}
		   						result = 1;
		   					}
	   					} else {
	   						if(typeof datas.int_conv_position !== "undefined"){
	   							datas.int_conv_position.val = int_conv_direction;
	   						}
	   						result = 10;
	   					}
	   				} else if(type == 2){

	   					if(typeof datas.int_conv_position !== "undefined"){
   							datas.int_conv_position.val = 1;
   						}
	   					result = type;

	   				}
				    else if(type == 10){
						result = 11;
				    }
				    else {
	   					if(typeof datas.int_conv_position !== "undefined"){
	   						datas.int_conv_position.val = int_conv_direction;
	   					}
	   					result = type;
	   				}

	   				return result;
	   			},
				//photo mapping
				currentPic : function(datas){
					var data = [];					
					var id;
					if(angular.isDefined(datas.str_group_name)){ // by hyosung
						if(datas.str_group_name.val == "room_conf"){
							return amoebaDataFactory.defaultGroupImage;
						}
					}
					if(angular.isDefined(datas.str_user_key)){
						id = datas.str_user_key.val;
					}
					if(angular.isDefined(datas.str_conv_member_userkey))
					{
						id = datas.str_conv_member_userkey.val;
					}
					var pic = null;

	   				var picDatas = amoebaDataFactory.pictureData;
	   				if(!angular.isDefined(datas.int_conv_log_type)){
	   					if(!angular.isDefined(id)){
	   						pic = picDatas[0].str_picture_data.val;
	   					} else {
	   						for(var no in picDatas){
	   							if(picDatas[no].str_user_key.val == id){
	   								pic = picDatas[no].str_picture_data.val;
	   								break;
	   							}
	   							if(no == picDatas.length - 1){

									if(angular.isDefined(datas.int_user_type)){
										if(datas.int_user_type.val == 2){
											pic = UCAPP.UTILITY.BASE64_DEFAULT_PHONE_IMAGE; // for phone user
										}
										else{
											pic = amoebaDataFactory.defaultimage;
										}
									}
									else{
										pic = amoebaDataFactory.defaultimage;
									}

	   							}
	   						}
							if(picDatas.length == 0)
							{
								pic =amoebaDataFactory.defaultimage;
							}
	   					}
	   				} else {
	   					if(datas.int_conv_log_type.val == 6){
						    pic = amoebaDataFactory.noticeimage[0].str_picture_data.val;
	   					} else {
	   						for(var no in picDatas){
								if(picDatas[no].str_user_key.val == id){
	   								pic = picDatas[no].str_picture_data.val;
	   								break;
	   							}
	   							if(no == picDatas.length - 1){
								    pic = amoebaDataFactory.defaultimage;
	   							}
	   						}
							if(picDatas.length == 0)
							{
								pic =amoebaDataFactory.defaultimage;
							}
							if(id ==""){
								pic =amoebaDataFactory.defaultimage;
							}
	   					}
	   				}
	   				return pic;
	   			},
				//photo mapping
				SearchUserPic : function(datas){
					var data = [];
					var id;
					if(angular.isDefined(datas.str_user_key)){

						id = datas.str_user_key.val;
					}
					var pic = null;
					var picDatas = amoebaDataFactory.searchMemberPicture;
					for(var no in picDatas){
						if(picDatas[no].key == id){
							pic = picDatas[no].picture;
							break;
						}
						if(no == picDatas.length - 1){
							//default image
							pic = amoebaDataFactory.defaultimage
						}
					}
					if(picDatas.length == 0)
					{
						pic = amoebaDataFactory.defaultimage;
					}
					return pic;
				},
	   			nowDate : function(){
	   				return new Date();
	   			},
	   			setTime : function(date){
	   				var currentDate;
	   				//today	   				
	   				var today = this.nowDate();
	   				//yesterday
	   				var yesterday = new Date(today.toDateString());
	   				yesterday.setDate(yesterday.getDate() - 1);	   				
	   				var current = new Date(date);
	   				
	   				if(today.toDateString() == current.toDateString()){
	   					currentDate = amoebaDataFactory.global.Today;
	   				} else if(yesterday.toDateString() == current.toDateString()){	   					
	   					currentDate = amoebaDataFactory.global.Yesterday;
	   				} else {
	   					currentDate = current.toDateString();
	   					var arr = currentDate.split(" ");
	   					var month = current.getMonth();
	   					month += 1;
						arr[0] = this.getDay(arr[0]);
	   					currentDate = arr[0]+" "+month+" "+arr[2];
	   				}
	   				return currentDate;
	   			},
	   			
	   			setConversationTime : function(date){
					var currentDate;
					//today	   				
					var today = this.nowDate();
					//yesterday
					var yesterday = new Date(today.toDateString());
					yesterday.setDate(yesterday.getDate() - 1);
					var current = new Date(date);

					if(today.toDateString() == current.toDateString()){
						currentDate = this.setCurrentTime(current);
					} else if(yesterday.toDateString() == current.toDateString()){
						currentDate = amoebaDataFactory.global.Yesterday;
					} else {
						currentDate = current.toDateString();
						var arr = currentDate.split(" ");
						var month = current.getMonth();
						month += 1;
						arr[0] = this.getDay(arr[0]);
						currentDate = arr[0]+" "+month+" "+arr[2];
					}
					return currentDate;
				},
				setMemoTime : function(date){
					var currentDate;
					//today	   				
					var today = this.nowDate();
					//yesterday
					var yesterday = new Date(today.toDateString());
					yesterday.setDate(yesterday.getDate() - 1);
					var current = new Date(date);

					var arr = date.split(" ");
					var time = this.setCurrentTime(current);
					currentDate = arr[0] + " " + time;
				
					return currentDate;
				},
				setSMSTime : function(date){
					//var currentDate;
					//today
					var today = this.nowDate();
					//yesterday
					var yesterday = new Date(today.toDateString());
					yesterday.setDate(yesterday.getDate() - 1);
					var current = new Date(date);

					var arr = date.split(" ");
					var time = this.setCurrentTime(current);
					//currentDate = time;

					return time;

				},
				getDay : function(day){
					var dayText;
					if(day == "Mon"){
						dayText = amoebaDataFactory.global.Day_Mon;
					}
					else if(day =="Tue"){
						dayText = amoebaDataFactory.global.Day_Tue;
					}
					else if(day == "Wed"){
						dayText = amoebaDataFactory.global.Day_Wed;
					}
					else if(day == "Thu"){
						dayText = amoebaDataFactory.global.Day_Thu;
					}
					else if(day == "Fri"){
						dayText = amoebaDataFactory.global.Day_Fri;
					}
					else if(day == "Sat"){
						dayText = amoebaDataFactory.global.Day_Sat;
					}
					else if (day == "Sun"){
						dayText = amoebaDataFactory.global.Day_Sun;
					}
					return dayText;
				},
	   			setCurrentTime : function(data){
					var hours = new Date(data).getHours();
					var lan = amoebaDataFactory.loginInfo.str_language.val;
					////console.log("hourshours");
					////console.log(lan);
					////console.log( amoebaDataFactory.global);
					
					if(hours >=12){
						if(lan == "KOR"){
							return  amoebaDataFactory.global.lan_PM + " " + moment(new Date(data)).format('hh:mm');
						}
						else if(lan == "ENG"){
							return moment(new Date(data)).format('hh:mm') + " " + amoebaDataFactory.global.lan_PM;
						}
					}
					else{
						if(lan == "KOR"){
							return amoebaDataFactory.global.lan_AM + " " + moment(new Date(data)).format('hh:mm');
						}
						else if(lan == "ENG"){
							return moment(new Date(data)).format('hh:mm') + " " + amoebaDataFactory.global.lan_AM;
						}
					}
					//return moment(new Date(data)).format('hh:mm A');
	   			},
	   			chatTime : function(){
	   				var dt = new Date();
	   				var date = dt.toDateString();

	   				var year = dt.getFullYear();
	   				var month = dt.getMonth();
	   				month = month + 1;
	   				var day = dt.getDate();
	   				var hours = dt.getHours();
	   				var minutes = dt.getMinutes();
	   				var seconds = dt.getSeconds();
				    var strDay = year +'-'+month+'-'+day+' '+hours+':'+minutes+':'+seconds;

	   				var ampm = hours >= 12 ? 'PM' : 'AM';

	   				hours = hours % 12;
	   				hours = hours ? hours : 12; // the hour '0' should be '12'
	   				hours = hours < 10 ? "0"+hours : hours;
	   				minutes = minutes < 10 ? '0'+minutes : minutes;

	   				var strTime =   ampm  + ' ' + hours + ':' + minutes;
	   				
	   				return {"chat" : strTime, "sort" : strDay, "date" : date};
	   			},
	   			smsListTime : function(data){
	   				return moment(new Date(data)).format('YYYY.MM.DD');
	   			},
	   			isCallEvent : function(no, bIsAutoPage){
	   				console.log("isCallEvent");
					var scope = amoebaDataFactory.mainCtrlScope;
					var scope2 = amoebaDataFactory.chatCtrlScope;
					var scope3 = amoebaDataFactory.contentCtrlScope;

					//scope.isPop = (scope.isPop ? false : scope.isPop);

				    if(bIsAutoPage == undefined){
					    bIsAutoPage = true;
				    }
				    //bIsAutoPage = true;
	   				switch(no){
	   					case 0 :
	   						scope.isCalling = 0;
	   						amoebaDataFactory.ucsStatus = "DEFAULT";
							scope.ucsStatus = "DEFAULT";
	   						scope.isUserList = false;
	   						scope.isCallon = false;
	   						//console.log("isCallEvent : 0");
	   						if(bIsAutoPage){
							    this.goPage(1);
						    }
	   						break;
	   					case 1 :
	   						scope.isCalling = 1;
	   						amoebaDataFactory.ucsStatus = "IN_CALL";
	   						amoebaDataFactory.callMes = amoebaDataFactory.global.lang_call_from;
	   						//console.log("isCallEvent : 1");
	   						break;
	   					case 2 :
	   						scope.isCalling = 2;
	   						amoebaDataFactory.ucsStatus = "OUT_CALL";
	   						amoebaDataFactory.callMes = amoebaDataFactory.global.lang_call_to;
	   						//console.log("isCallEvent : 2");
	   						break;
	   					case 3 :
	   						scope.isCalling = 0;
	   						amoebaDataFactory.ucsStatus = "CALL_REJECT";
	   						//console.log("isCallEvent : 3");
	   						break;
	   					case 4 :
	   						scope.isCalling = 0;
	   						amoebaDataFactory.ucsStatus = "MISS_CALL";
	   						scope.isUserList = false;
	   						scope.isCallon = false;
	   						//console.log("isCallEvent : 4");
	   						break;
	   					case 5 :
//	   						scope.isCalling = 1;
	   						amoebaDataFactory.ucsStatus = "CALL_ING";
	   						//console.log("isCallEvent : 5");
						    if(bIsAutoPage){
							    this.goPage(9); // 0412 hyosung - call memo page move after create call log
						    }
	   						break;
	   					case 6 :
//	   						scope.isCalling = 1;
	   						amoebaDataFactory.ucsStatus = "CALL_ING";
	   						//console.log("isCallEvent : 6");
						    if(bIsAutoPage){
							   this.goPage(21);
						    }
	   						break;
						case 7:
							scope.isCalling = 2;
							amoebaDataFactory.ucsStatus = "IN_GROUP_CALL";
							amoebaDataFactory.callMes = amoebaDataFactory.global.lang_call_from;
							scope.ucsStatus = "IN_GROUP_CALL";
							//console.log("isCallEvent : 7");
							//this.goPage(21);
							break;
						case 8:
							scope.isCalling = 2;
							amoebaDataFactory.ucsStatus = "OUT_GROUP_CALL";
							amoebaDataFactory.callMes = amoebaDataFactory.global.lang_call_from;
							//console.log("isCallEvent : 8");
							scope.isCallon = true;
							if(bIsAutoPage){
								this.goPage(21);
							}
							break;
						case 9 :
							// 통화 종료 후 페이지 이동 없음
							scope.isCalling = 0;
							amoebaDataFactory.ucsStatus = "DEFAULT";
							scope.ucsStatus = "DEFAULT";
							scope.isUserList = false;
							scope.isCallon = false;
							//console.log("isCallEvent : 9");
							break;
						case 10:
							scope.isCalling = 2;
							amoebaDataFactory.ucsStatus = "IN_CONF_ROOM_CALL";
							amoebaDataFactory.callMes = amoebaDataFactory.global.lang_room_conference;
							scope.isCallon = true;
							//console.log("isCallEvent : 10");
							break;
					    case 11 :
						    amoebaDataFactory.ucsStatus = "VOICE_MAIL";
						    scope.isUserList = false;
						    scope.isCallon = false;
						    break;
					    case 12 :
						    amoebaDataFactory.ucsStatus = "DEFAULT"; // after stop voicemail, to change orginal color.
						    scope.isUserList = false;
						    scope.isCallon = false;
						    break;
					    case 13:
						    scope.isCalling = 2;
						    amoebaDataFactory.ucsStatus = "IN_PAGING";
						    amoebaDataFactory.callMes = amoebaDataFactory.global.lang_paging;
						    scope.isCallon = true;
						    //console.log("isCallEvent : 13");
						    break;
					    case 14:
						    scope.isCalling = 2;
						    amoebaDataFactory.ucsStatus = "OUT_PAGING";
						    amoebaDataFactory.callMes = amoebaDataFactory.global.lang_paging;
						    scope.isCallon = true;
						    //console.log("isCallEvent : 14");
						    break;
					    case 15:
						    scope.isCalling = 2;
						    amoebaDataFactory.ucsStatus = "OUT_CALL_TRANS";
						    amoebaDataFactory.callMes = amoebaDataFactory.global.lang_call_to;
						    //console.log("isCallEvent : 15");
						    break;



	   				}
	   				scope.status = amoebaDataFactory.ucsStatus;
	   				var switchColor = this.changeColor();
	   				scope.bgClass =  switchColor.btn;
   					scope.iconClass =	switchColor.icon;
   					scope.iconradioClass =	switchColor.iconradio;
   					scope.textClass =	switchColor.text;
   					scope.bdNtextClass =	switchColor.bdNtext;
   					scope.onlybgClass =	switchColor.onlybg;
   					scope.bdClass =	switchColor.bd;

   					if(typeof scope2 !== "undefined" && scope2 != null && scope2.chatClass != null){
   					// 	scope2.onlybgClass = switchColor.onlybg;
   						scope2.flagClass = switchColor.flag;
   					}

   					if(typeof scope3 !== "undefined" && scope3 != null && scope3.textClass != null){

   						scope3.textClass = switchColor.text;
   						scope3.tabTextClass = switchColor.tab;
   					}

   					if(amoebaDataFactory.currentPage == 10 || amoebaDataFactory.currentPage == 14){
   						scope.isUserList = true;
   					}
	   			},

	   			changeColor : function(){
	   				var obj = {};
	   				if(amoebaDataFactory.ucsStatus == "DEFAULT" || amoebaDataFactory.ucsStatus == "MISS_CALL"){
							$('body').removeClass('switchcolor');
	   					obj.flag = false;
	   					obj.btn =  "btn_add bg_blue ";
	   					obj.iconradio =	"bg_blue-c ";
	   					obj.icon =	"icon-ok bg_blue-c ";
	   					obj.onlybg = "bg_blue ";
	   					obj.text = "text_blue ";
	   					obj.bdNtext = "text_blue2 bg_blue2-a ";
	   					obj.tab = "text_blue text_blue2 ";
	   					obj.bd = "bd_blue ";

	   				} else {
							$('body').addClass('switchcolor');
	   					obj.flag = true;
	   					obj.btn = "btn_add bg_green ";
	   					obj.iconradio = "bg_green-c ";
	   					obj.icon = "icon-ok bg_green-c ";
	   					obj.onlybg = "bg_green ";
	   					obj.text = "text_green ";
	   					obj.bdNtext = "text_green2 bg_green2-a ";
	   					obj.tab = "text_green text_green2 ";
	   					obj.bd = "bd_green ";
	   				}
	   				return obj;
	   			},
	   			chatTitleName : function(){
	   				var scope = amoebaDataFactory.mainCtrlScope;
	   				var data = scope.conDatas;
	   				var name = "Conversation";

				    if(amoebaDataFactory.currentConversationData.strary_conv_members_userkey.length > 0)
					{
						for(var i in amoebaDataFactory.currentConversationData.strary_conv_members_userkey)
						{
							if(amoebaDataFactory.currentConversationData.strary_conv_members_userkey[i] == "add")
							{
								amoebaDataFactory.currentConversationData.strary_conv_members_userkey.splice(i,1);
							}
						}
						var num = amoebaDataFactory.currentConversationData.strary_conv_members_userkey.length;
						for(var i in amoebaDataFactory.currentConversationData.strary_conv_members_userkey)
						{

							if(amoebaDataFactory.currentConversationData.strary_conv_members_userkey[i] == amoebaDataFactory.userInfoData.str_my_key)
							{
								break;
							}
							if(i == amoebaDataFactory.currentConversationData.strary_conv_members_userkey.length -1)
							{
								num += 1;
							}
						}
						scope.chatName = amoebaDataFactory.global.lang_group_im + " (" + num + ") - " + amoebaDataFactory.currentConversationData.str_conv_name.val + ","+ amoebaDataFactory.userInfoData.str_first_name.val;
					}
					else
					{
						scope.chatName = amoebaDataFactory.currentConversationData.str_conv_name.val;
					}
					UCAPP.DBMS.DBInterface.get_one_conversation_info(amoebaDataFactory.currentConversationData.int_conv_id.val).then(function(item){
						if(item != false)
						{
							if(item[0].bool_is_group == 1)
							{
								var num = item[0].strary_conv_members_userkey.length + 1;
								if(item[0].str_conv_name == ""){
									scope.chatName = amoebaDataFactory.global.lang_group_im + " (" + num + ") - " + amoebaDataFactory.userInfoData.str_first_name.val;
								}
								else{
									scope.chatName = amoebaDataFactory.global.lang_group_im + " (" + num + ") - " + item[0].str_conv_name + ","+ amoebaDataFactory.userInfoData.str_first_name.val;
								}

								if(item[0].strary_conv_members_userkey.length == 0){
									scope.chatName = amoebaDataFactory.global.lang_group_im + " (" + num + ") - " + amoebaDataFactory.global.lang_no_chat_members;
								}
							}
							else
							{
								scope.chatName = item[0].str_conv_name;
							}
						}
					});
	   			},
				updateContent : function(obj){
					var scope = amoebaDataFactory.mainCtrlScope;
					var id = obj.id;
					var txt = obj.txt;
					var direction = (obj.direction * 1);
					var time = obj.time;
					var sort = obj.sort;
					var type = (obj.type * 1);
					var datas = scope.conDatas;
					var co = -1;
					var count= obj.count;
					var sessionkey = obj.sessionkey;
					var name = null;
					if(typeof obj.name !== undefined){
						if(typeof obj.name === "string"){
							name = obj.name;
						}
					}

					for(var i = 0; i < datas.length; i++){
						if(datas[i].int_conv_id.val == id){
							co = i;
							datas[i].str_conv_content.val = txt;
							datas[i].int_conv_direction.val = direction;
							datas[i].int_conv_type.val = type;
							datas[i].str_conv_datetime.val = time;
							datas[i].int_new.val += count;
							if(sessionkey!== undefined){
								datas[i].str_session_key.val = sessionkey;
							}
							
							if(name !== null){
								datas[i].str_conv_name.val = name;
							}
							
							break;
						}
					}

					if(co != -1){
						var temp = datas[co];
						datas.splice(co, 1);
						//datas.unshift(temp);
						this.saveContentByDateOrder(temp);
					}
					scope.conCount = messenger.setConCount();
				},
				saveContentByDateOrder : function(stConv){
					var scope = amoebaDataFactory.mainCtrlScope;
					var convDatas = scope.conDatas;
					var currentMoment = moment(stConv.str_conv_datetime.val);

					var iLength = convDatas.length;
					var idx;
					for(idx = 0; idx < iLength ; idx++){
						if(currentMoment.isAfter(convDatas[idx].str_conv_datetime.val)){
							break;
						}
					}
					convDatas.splice(idx,0,stConv);
				},
				isTitle : function(){
					var scope = amoebaDataFactory.mainCtrlScope;
					var message = "";
					var time = this.chatTime().chat;
					var name = amoebaDataFactory.userInfoData.str_first_name.val;
					var getTime = new Date();
					var hours = getTime.getHours();
					if(hours >= 5  && hours < 12){
						message = scope.factory.global.lang_good_morning;
					} else if(hours >=12 && hours < 17) {
						message = scope.factory.global.lang_good_afternoon;
					} else if(hours >=17 && hours < 22) {
						message = scope.factory.global.lang_good_evening;
					} else if(hours >= 22 || hours < 5) {
						message = scope.factory.global.lang_good_night;
					} else {
						message = scope.factory.global.lang_good_night;
					}
					message = message +"~!!  "+ name +", "+time;
					return message
				},
				resetCheck : function(data){
					for(i in data){
						data[i].check = false;
					}
				},
				checkedData : function(data, target){
					
					for(i in data){
						for(j in target){
							if(data[i].str_user_key.val == target[j].str_user_key.val){
								data[i].check = target[j].check;
							}
							if(angular.isDefined(target[j].isDim) && amoebaDataFactory.currentPage != 20 && amoebaDataFactory.currentPage != 21){
								delete target[i].isDim;
							}
						}
						if(angular.isDefined(data[i].isDim) && amoebaDataFactory.currentPage != 20 && amoebaDataFactory.currentPage != 21){
							delete data[i].isDim;
						}
					}
				},
				checkedDimData : function(data, target){
					
					for(i in data){
						for(j in target){
							if(data[i].str_user_key.val == target[j].str_user_key.val){
								data[i].isDim = true;
								data[i].check = true;
							}
						}
					}
				},
				checkIMUser : function(data){
					var usertype = data.int_user_type.val;
					var result = true;
					if(usertype != 1){
						result = false;
					}
					return result;
				},
				isRegExp : function(txt, txt2){
					//var re = /^[ㄱ-ㅎ|가-힣|a-z|A-Z|0-9|\*]+$/g;
					var pTxt = txt.toLowerCase();
					var aTxt = txt2.toLowerCase();
					var pattern = new RegExp(pTxt);
					var result = pattern.test(aTxt);
					return result;
				},
				createGroupId : function(){
					amoebaDataFactory.contactGroupMaxId += 1;					
					var id = amoebaDataFactory.contactGroupMaxId;
					return id;
				},
				createtransuserId : function(){
					amoebaDataFactory.translogId += 1;
					var id = amoebaDataFactory.translogId;
					return id;
				},
				isConvPhoto : function(conv){
					var id = conv.int_conv_id.val;
					var data = null;
					
	   				var scope = amoebaDataFactory.mainCtrlScope;
	   				var conDatas = scope.conDatas;
					
					for(var i in conDatas){
						if(id == conDatas[i].int_conv_id.val){
							data = conDatas[i];
						}
					}

					var pictureList = this.updatePic(data);
					var co;
					var result = 0;

					if(angular.isDefined(data.conv_status)){
						data.conv_status.val = this.updateStatus(data);
						if(data.int_conv_user != undefined){
							co = data.int_conv_user.val;
						}
						else{
							co = conv.int_conv_user.val;
						}

					} else {
						data.conv_status = {"val" : this.updateStatus(data)};
						co = pictureList.length;
					}

					switch(co){
					case 0 :
						result = 1;
						break;
					case 1 :
						result = 1;
						break;
					case 2 :
						result = 2;
						break;
					case 3 :
						result = 3;
						break;
					default :
						result = 4;
						break;
					}
					conv.picture_list = pictureList;
					conv.photos = result;	
				},
				isPhoto : function(data) {

					var pictureList = this.updatePic(data);
					var co;
					var result = 0;

					if(angular.isDefined(data.conv_status)){
						data.conv_status.val = this.updateStatus(data);
						co = data.int_conv_user.val;
					} else {
						data.conv_status = {"val" : this.updateStatus(data)};
						co = pictureList.length;
					}

					switch(co){
					case 0 :
						result = 1;
						break;
					case 1 :
						result = 1;
						break;
					case 2 :
						result = 2;
						break;
					case 3 :
						result = 3;
						break;
					default :
						result = 4;
						break;
					}
					data.picture_list = pictureList;
					data.photos = result;
					////console.log("picturedata");
					////console.log(pictureList);
					////console.log(result);
				},

				IsupdateConvPic : function(userkey, conversationlist){
					var userkeylist=[];
					var userkeyArry ={str_user_key:{val:""}};
					if(typeof userkey == 'string'){
						userkeyArry.str_user_key.val = userkey;
						userkeylist.push(userkeyArry);
					}
					else{
						userkeylist= userkey;
					}
					//console.log("updateconpic");
					//console.log(userkeyArry);
					//console.log(userkeylist);
					for(var k in userkeylist){
						for(var i in conversationlist){
							if(conversationlist[i].bool_is_group.val){

								for(var j in conversationlist[i].strary_conv_members_userkey){
									if(conversationlist[i].strary_conv_members_userkey[j] == userkeylist[k].str_user_key.val){
										var pictureList = this.updatePic(conversationlist[i]);
										conversationlist[i].picture_list = pictureList;
										//console.log("updateuserpicture");
										//break;
									}
								}


							}
							else{

								if(conversationlist[i].str_conv_member_userkey.val == userkeylist[k].str_user_key.val){
									var pictureList = this.updatePic(conversationlist[i]);
									conversationlist[i].picture_list = pictureList;
									//break;
								}
							}
						}

					}

				},
				updateChatPic : function(userkey, chatMsg){

					for(var i in chatMsg) {
						chatMsg[i].picture = this.currentPic(chatMsg[i]);
						//console.log(chatMsg[i].picture);
					}
				},
				getNumberList : function(user){
					
					var numberList = [];
					if(user.str_desk_phone1.val != "" && user.str_desk_phone1.val != null){
						numberList.push(user.str_desk_phone1.val);
					}

					if(user.str_cellular_phone.val != "" && user.str_cellular_phone.val != null){
						numberList.push(user.str_cellular_phone.val);
					}

					if(user.str_office_telephone.val != "" && user.str_office_telephone.val != null){
						numberList.push(user.str_office_telephone.val);
					}

					if(user.str_home_telephone.val != "" && user.str_home_telephone.val != null){
						numberList.push(user.str_home_telephone.val);
					}
					return numberList;
				},
				//그룹핑을 하기위해 설정한 값을 초기화
				defaultMemInfo : function(data) {
					if(angular.isDefined(data.memInfo)){
						data.memInfo.number.length = 0;
						data.memInfo.userkey.length = 0;
						delete data.memInfo;
					}
				},
				// 보이스 메일 UI 값 설정
				setVoiceDefault : function(data){
					data.isVoicemail_play = false;
					data.play_time = "00:00:00.0";
				},
				openVoicemail : function(data){
					this.pauseVoice();
					data.play_time = "00:00:00.0";
					data.width = 0;
					data.complete_time = data.str_conv_log_duration.val;
					amoebaDataFactory.currentVoice = data;
					for(i in amoebaDataFactory.currentVoiceRecordTime){
						amoebaDataFactory.currentVoiceRecordTime[parseInt(i)] = 0;
					}
				},
				// 보이스 메일 다운로드
				downVoice : function(data){
					data.bool_conv_log_download.val = true;
				},
				// 보이스 메일 재생
				playVoice_backup : function(data){
					if(amoebaDataFactory.currentVoice.play_time == ""){
						return;
					}
					amoebaDataFactory.currentVoice = data;
					// 혹시라도 다른 데이터를 가져온다면 다시 추가를 하시길 바랍니다.

					var seconds = 0, minutes = 0, hours = 0;

					//data.complete_time = data.str_conv_log_duration.val;
					data.complete_time = data.str_conv_log_duration.val.split('.')[0]; // 20161125 hyosung

					// 최초 interval 초기화
					this.pauseVoice();

					amoebaDataFactory.currentVoice.isVoicemail_play = true;


					//if(amoebaDataFactory.currentVoice.bool_conv_log_download.val != true){
						this.isCallEvent(11);
					//}


					if(amoebaDataFactory.currentVoice.width == 0 || amoebaDataFactory.currentVoice.width == 100){
						// 시작이나 끝인 경우 데이터 초기화
						//amoebaDataFactory.currentVoice.complete_time = amoebaDataFactory.currentVoice.str_conv_log_duration.val;
						amoebaDataFactory.currentVoice.complete_time = amoebaDataFactory.currentVoice.str_conv_log_duration.val.split('.')[0]; // 20161125 hyosung
						this.completeVoice();
					}
					// 총 플레이타임을 sec로 변경
					var cTime = amoebaDataFactory.currentVoice.complete_time.split(":");
					var complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));

					// 각 시분초로 세팅
					//hours	= amoebaDataFactory.currentVoiceRecordTime[0];
					//minutes	= amoebaDataFactory.currentVoiceRecordTime[1];
					//seconds = amoebaDataFactory.currentVoiceRecordTime[2];

					amoebaDataFactory.currentVoice.play_time_sec = new Date().getTime();

					var totalSeconds = moment.duration(amoebaDataFactory.currentVoice.play_time).asSeconds();
					var dateTemp = new Date();
					dateTemp.setSeconds(dateTemp.getSeconds() + totalSeconds);
					amoebaDataFactory.currentVoice.prev_play_time_sec = dateTemp.getTime() - new Date().getTime();

					amoebaDataFactory.currentPlayVoiceIntervalID = setInterval(function(){
						var curentCalltime = new Date().getTime();
						var diff = curentCalltime - amoebaDataFactory.currentVoice.play_time_sec + amoebaDataFactory.currentVoice.prev_play_time_sec;
						//console.log(diff);

						var seconds =  Math.floor((diff)/1000);
						var hours = Math.floor(seconds / (60 * 60));

						var divisor_for_minutes = seconds % (60 * 60);
						var minutes = Math.floor(divisor_for_minutes / 60);

						var divisor_for_seconds = divisor_for_minutes % 60;
						var seconds = Math.ceil(divisor_for_seconds);

						amoebaDataFactory.currentVoice.width = Math.floor(((seconds + (minutes * 60) + ((hours * 60) * 60)) / complete) * 100);
						hours = (hours < 10 ) ? "0" + hours: hours;
						minutes = (minutes < 10) ? "0" + minutes : minutes;
						seconds = (seconds < 10) ? "0" + seconds : seconds;

						amoebaDataFactory.currentVoice.play_time = hours + ":" +  minutes + ":" + seconds;

						if(amoebaDataFactory.currentVoice.play_time == amoebaDataFactory.currentVoice.complete_time){
							clearInterval(amoebaDataFactory.currentPlayVoiceIntervalID);
							amoebaDataFactory.currentPlayVoiceIntervalID = null;
							messenger.pauseVoice();
							messenger.completeVoice();
							messenger.isCallEvent(12);
						}
						//console.log(amoebaDataFactory.currentVoice.play_time);

					}, 1000);
				},
				playVoice : function(data){
					if(amoebaDataFactory.currentVoice.play_time == ""){
						return;
					}
					amoebaDataFactory.currentVoice = data;
					// 혹시라도 다른 데이터를 가져온다면 다시 추가를 하시길 바랍니다.

					var seconds = 0, minutes = 0, hours = 0;

					data.complete_time = data.str_conv_log_duration.val;

					// 최초 interval 초기화
					this.pauseVoice();

					amoebaDataFactory.currentVoice.isVoicemail_play = true;


					//if(amoebaDataFactory.currentVoice.bool_conv_log_download.val != true){
					this.isCallEvent(11);
					//}


					if(amoebaDataFactory.currentVoice.width == 0 || amoebaDataFactory.currentVoice.width == 600){
						// 시작이나 끝인 경우 데이터 초기화
						amoebaDataFactory.currentVoice.complete_time = amoebaDataFactory.currentVoice.str_conv_log_duration.val;
						this.completeVoice();
					}
					// 총 플레이타임을 sec로 변경
					var cTime = amoebaDataFactory.currentVoice.complete_time.split(".")[0].split(":");
					var cTime_m = amoebaDataFactory.currentVoice.complete_time.split(".")[1];
					var complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));
					complete = complete*1000 + cTime_m*100;

					// 각 시분초로 세팅
					//hours	= amoebaDataFactory.currentVoiceRecordTime[0];
					//minutes	= amoebaDataFactory.currentVoiceRecordTime[1];
					//seconds = amoebaDataFactory.currentVoiceRecordTime[2];

					amoebaDataFactory.currentVoice.play_time_sec = new Date().getTime();

					var totalMiliSeconds = moment.duration(amoebaDataFactory.currentVoice.play_time.split(".")[0]).asMilliseconds() + amoebaDataFactory.currentVoice.play_time.split(".")[1] * 100;
					var dateTemp = new Date();
					dateTemp.setMilliseconds(dateTemp.getMilliseconds() + totalMiliSeconds);
					amoebaDataFactory.currentVoice.prev_play_time_sec = dateTemp.getTime() - new Date().getTime();

					amoebaDataFactory.currentPlayVoiceIntervalID = setInterval(function(){
						var curentCalltime = new Date().getTime();
						var diff = curentCalltime - amoebaDataFactory.currentVoice.play_time_sec + amoebaDataFactory.currentVoice.prev_play_time_sec;
						////console.log(diff);

						var miliSeconds = Math.round((diff % 1000)/100)*100;
						////console.log(miliSeconds);

						var seconds =  Math.floor((diff)/1000);
						var hours = Math.floor(seconds / (60 * 60));

						var divisor_for_minutes = seconds % (60 * 60);
						var minutes = Math.floor(divisor_for_minutes / 60);

						var divisor_for_seconds = divisor_for_minutes % 60;
						var seconds = Math.ceil(divisor_for_seconds);


						if(!amoebaDataFactory.bIsVMPlayerDrag){
							amoebaDataFactory.currentVoice.width = Math.floor((((seconds + (minutes * 60) + ((hours * 60) * 60)) * 1000 + miliSeconds) / complete) * 600);
						}

						hours = (hours < 10 ) ? "0" + hours: hours;
						minutes = (minutes < 10) ? "0" + minutes : minutes;
						seconds = (seconds < 10) ? "0" + seconds : seconds;
						miliSeconds = String(miliSeconds).substr(0, 1);
						////console.log(miliSeconds);

						amoebaDataFactory.currentVoice.play_time = hours + ":" +  minutes + ":" + seconds + "." + miliSeconds;

						//if(amoebaDataFactory.currentVoice.play_time == amoebaDataFactory.currentVoice.complete_time){

						if(amoebaDataFactory.currentVoice.width > 600){
							clearInterval(amoebaDataFactory.currentPlayVoiceIntervalID);
							amoebaDataFactory.currentPlayVoiceIntervalID = null;
							//messenger.pauseVoice(); // update by VOICEMAIL_STOP_EVENT
							//messenger.completeVoice();
							//messenger.isCallEvent(12);
						}
						////console.log(amoebaDataFactory.currentVoice.play_time);

						if(amoebaDataFactory.voicemailManagerCtrlScope !== null){
							amoebaDataFactory.voicemailManagerCtrlScope.$apply(function(){

							});
						}
					}, 100);
				},
				pauseVoice : function(){
					if(!angular.isUndefined(amoebaDataFactory.currentPlayVoice)){
						$interval.cancel(amoebaDataFactory.currentPlayVoice);
						amoebaDataFactory.currentPlayVoice = undefined;
					}
					if(amoebaDataFactory.currentPlayVoiceIntervalID != null){
						clearInterval(amoebaDataFactory.currentPlayVoiceIntervalID)
					};
					amoebaDataFactory.currentVoice.isVoicemail_play = false;
				},
				stopVoice : function(data){

					if(amoebaDataFactory.currentVoice.play_time == "") return;

					if(amoebaDataFactory.currentPlayVoiceIntervalID != null){
						clearInterval(amoebaDataFactory.currentPlayVoiceIntervalID);
						amoebaDataFactory.currentPlayVoiceIntervalID = null;
					}
					messenger.pauseVoice();
					messenger.completeVoice();
					messenger.isCallEvent(12);

					amoebaDataFactory.bIsVMPlayerDrag = false;
				},
				completeVoice : function(){
					for(i in amoebaDataFactory.currentVoiceRecordTime){
						amoebaDataFactory.currentVoiceRecordTime[parseInt(i)] = 0
					}
					amoebaDataFactory.currentVoice.play_time = "00:00:00.0";
					amoebaDataFactory.currentVoice.play_time_sec = 0;
					amoebaDataFactory.currentVoice.width = 0;

					if(amoebaDataFactory.currentPlayVoiceIntervalID != null){
						clearInterval(amoebaDataFactory.currentPlayVoiceIntervalID);
						amoebaDataFactory.currentPlayVoiceIntervalID = null;
					}

					amoebaDataFactory.mainCtrlScope.$broadcast('play_voicemail_end', {data: ""});
				},
				voiceMailStart : function(data){
					amoebaDataFactory.chatVoiceData = null;
					amoebaDataFactory.chatVoiceData = data;

					var bFlag = false;
					for(index in amoebaDataFactory.voiceData){
						if(data.int_unique_id.val == amoebaDataFactory.voiceData[index].int_unique_id.val
							&& data.str_conv_log_datetime.val == amoebaDataFactory.voiceData[index].str_conv_log_datetime.val){
							bFlag = true;
							break;
						}
					}
					if(bFlag){
						this.goPage(6);
					}
					else{
						amoebaDataFactory.showMainFail("VM_NOT_EXIST");
					}
				},
				playerDragStartEvnet : function(event, ui){
					//console.log("playerDragStartEvnet");
					if(amoebaDataFactory.currentVoice.play_time == ""){
						return;
					}
					if(!angular.isUndefined(amoebaDataFactory.currentPlayVoice)){

						$interval.cancel(amoebaDataFactory.currentPlayVoice);
						amoebaDataFactory.currentPlayVoice = undefined;
					}
					amoebaDataFactory.bIsVMPlayerDrag = true;
				},
				playerDragStopEvnet : function(event, ui){
					//console.log("playerDragStopEvnet");
					if(amoebaDataFactory.currentVoice.play_time == ""){
						return
					}

					if(!angular.isUndefined(amoebaDataFactory.currentPlayVoice)){
						$interval.cancel(amoebaDataFactory.currentPlayVoice);
						amoebaDataFactory.currentPlayVoice = undefined;
						this.stopVoice();
						return;
					}

					var previous_time = amoebaDataFactory.currentVoice.play_time;

					// 총 플레이타임을 sec로 변경
					var cTime = amoebaDataFactory.currentVoice.complete_time.split(".")[0].split(":");
					var cTime_m = amoebaDataFactory.currentVoice.complete_time.split(".")[1];
					var complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));
					complete = complete*1000 + cTime_m*100;

					var playTotalSeconds = complete;
					var curTotalSeconds = Math.floor((amoebaDataFactory.currentVoice.width / 600) * complete);

					cTime = amoebaDataFactory.currentVoice.play_time.split(".")[0].split(":");
					cTime_m = amoebaDataFactory.currentVoice.play_time.split(".")[1];
					complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));
					complete = complete*1000 + cTime_m*100;
					var preTotalSeconds = complete;

					var timeGap = curTotalSeconds - preTotalSeconds;
					var direction = null; // 0:back, 1:forward
					if(timeGap > 0){
						direction = 1;
					}
					else{
						direction = 0;
					}
					timeGap = Math.abs(timeGap);
					////console.log("timeGap:" + timeGap);
					timeGap = String(Math.floor(timeGap/1000)) + "." + String(Math.round((timeGap % 1000)/100)*100).substr(0,1);
					////console.log("timeGap:" + timeGap);


					amoebaDataFactory.timePlayVoicemail(amoebaDataFactory.stVmState.int_unique_id, direction, timeGap).then(function(item){
						var stVMInfo = item;
						amoebaDataFactory.bIsVMPlayerDrag = false;
						if(stVMInfo.iResult === 0){
							var miliSeconds = Math.round((curTotalSeconds % 1000)/100)*100;
							////console.log(miliSeconds);

							var seconds =  Math.floor((curTotalSeconds)/1000);
							var hours = Math.floor(seconds / (60 * 60));

							var divisor_for_minutes = seconds % (60 * 60);
							var minutes = Math.floor(divisor_for_minutes / 60);

							var divisor_for_seconds = divisor_for_minutes % 60;
							var seconds = Math.ceil(divisor_for_seconds);

							hours = (hours < 10 ) ? "0" + hours: hours;
							minutes = (minutes < 10) ? "0" + minutes : minutes;
							seconds = (seconds < 10) ? "0" + seconds : seconds;
							miliSeconds = String(miliSeconds).substr(0, 1);
							////console.log(miliSeconds);

							//amoebaDataFactory.currentVoice.width = Math.floor((((seconds + (minutes * 60) + ((hours * 60) * 60)) * 1000 + miliSeconds) / playTotalSeconds) * 600);
							amoebaDataFactory.currentVoice.play_time = hours + ":" +  minutes + ":" + seconds + "." + miliSeconds;

							messenger.playVoice(amoebaDataFactory.currentVoice);
						}
						else{
							////console.log("Fail To Timeplay Voicemail");
						}
					});
				},
				playerDragStopEvnet_backup : function(event, ui){
					if(amoebaDataFactory.currentVoice.play_time == ""){
						return
					}
					var previous_time = amoebaDataFactory.currentVoice.play_time;

					// 총 플레이타임을 sec로 변경
					//var cTime = amoebaDataFactory.currentVoice.complete_time.split(".")[0].split(":");
					//var cTime_m = amoebaDataFactory.currentVoice.complete_time.split(".")[1];
					//var complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));
					//complete = complete*1000 + cTime_m*100;

					var cTime = amoebaDataFactory.currentVoice.complete_time.split(":");
					var complete = parseInt((parseInt(cTime[2]) + (parseInt(cTime[1]) * 60) + ((parseInt(cTime[0]) * 60) * 60)));

					var sec = Math.floor((amoebaDataFactory.currentVoice.width / 100) * complete);
					var seconds = 0, minutes = 0, hours = 0;

					if(parseInt(sec / 60) > 0){
						amoebaDataFactory.currentVoiceRecordTime[2] = parseInt(sec % 60);
						var min = parseInt(sec / 60);
						if(parseInt(min / 60) > 0){
							amoebaDataFactory.currentVoiceRecordTime[0] = parseInt(min / 60);
							amoebaDataFactory.currentVoiceRecordTime[1] = parseInt(min % 60);
						} else {
							amoebaDataFactory.currentVoiceRecordTime[0] = 0;
							amoebaDataFactory.currentVoiceRecordTime[1] = min;
						}
					} else {
						amoebaDataFactory.currentVoiceRecordTime[0] = 0;
						amoebaDataFactory.currentVoiceRecordTime[1] = 0;
						amoebaDataFactory.currentVoiceRecordTime[2] = sec;
					}

					hours = parseInt(amoebaDataFactory.currentVoiceRecordTime[0]);
					minutes = parseInt(amoebaDataFactory.currentVoiceRecordTime[1]);
					seconds = parseInt(amoebaDataFactory.currentVoiceRecordTime[2]);

					amoebaDataFactory.currentVoice.play_time = (hours ? (hours > 9 ? hours : "0" + hours) : "00") + ":" + (minutes ? (minutes > 9 ? minutes : "0" + minutes) : "00") + ":" + (seconds > 9 ? seconds : "0" + seconds);

					if(!angular.isUndefined(amoebaDataFactory.currentPlayVoice)){
						$interval.cancel(amoebaDataFactory.currentPlayVoice);
						amoebaDataFactory.currentPlayVoice = undefined;
					}

					//amoebaDataFactory.timePlayVoicemail()

					var preTotalSeconds = moment.duration(previous_time).asSeconds();
					var curTotalSeconds = moment.duration(amoebaDataFactory.currentVoice.play_time).asSeconds();

					var timeGap = curTotalSeconds - preTotalSeconds;

					//console.log(timeGap);
					var direction = null; // 0:back, 1:forward
					if(timeGap > 0){
						direction = 1;
					}
					else{
						direction = 0;
					}

					amoebaDataFactory.timePlayVoicemail(amoebaDataFactory.stVmState.int_unique_id, direction, Math.abs(timeGap)).then(function(item){
						var stVMInfo = item;
						if(stVMInfo.iResult === 0){
							//if(amoebaDataFactory.currentVoice.isVoicemail_play == true){
								messenger.playVoice(amoebaDataFactory.currentVoice);
							//}
						}
						else{
							////console.log("Fail To Timeplay Voicemail");
						}
					});
				},
				// get IM Status Icon Class
				getImStatusIcon : function(n){
					var ImStatusIcon = "icon-ban-circle green";

					if(n == 0 || n == 10 || n ==8 || n==""){
						ImStatusIcon = "icon-circle gray";
					}
					else if(n == 1){
						ImStatusIcon = "icon-circle green";
					}
					else if(n == 2 || n == 9 || n == 98 || n == 6){
						ImStatusIcon = "icon-circle red";
					}
					else if(n == 3 || n == 4 || n == 5 || n== 7){ // 0201 hyosung
						ImStatusIcon = "icon-circle orange";
					}
					else if(n ==11){
						ImStatusIcon = "icon-ban-circle red";
					}
					else{
						ImStatusIcon = "icon-circle gray";
					}

	            	return ImStatusIcon;
				},
				// get IM Status Icon Text
				getImStatusText : function(n){
					
					var scope = amoebaDataFactory.mainCtrlScope;
					var ImStatusText = amoebaDataFactory.global.lang_im_online;
					  
					if(n == 0 || n == 10){
						ImStatusText = amoebaDataFactory.global.lang_im_offline;
					}
					else if(n == 1){
						ImStatusText = amoebaDataFactory.global.lang_im_online;
					}
					else if(n == 2 || n == 9 || n == 98){
						ImStatusText = amoebaDataFactory.global.lang_im_busy;
					}
					else if(n == 3){
						ImStatusText = amoebaDataFactory.global.lang_im_away;
					}
					else if(n == 4){
						ImStatusText = amoebaDataFactory.global.lang_im_back;
					}
					else if(n == 5){
						ImStatusText = amoebaDataFactory.global.lang_im_office;
					}
					else if(n == 6){
						ImStatusText = amoebaDataFactory.global.lang_im_meeting;
					}
					else if(n == 9999){
						ImStatusText = "";
					}
					else{
						ImStatusText = amoebaDataFactory.global.lang_im_dnd;
					}
	            	   
	            	return ImStatusText;
				},
				// get Phone Status Icon // 0201 hyosung
				getPhoneStatusIcon : function(n){
					var scope = amoebaDataFactory.mainCtrlScope;
					var status = n * 1;
					
					var pClass;
					var pText;
					switch (status) {
						case 0: // offile
							pClass = "icon_state state1";
							//status = "icon_state state1";
							pText = amoebaDataFactory.global.lang_icon_offline;
							break;
						case 1: // idle
							pClass = "icon_state state2";
							pText = amoebaDataFactory.global.lang_icon_idle;
							break;
						case 2: // dnd
							pClass = "icon_state state4";
							pText = amoebaDataFactory.global.lang_icon_dnd;
							break;
						case 3:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking; // talk(busy)
							break;
						case 4:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking;
							break;
						case 5:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking;
							break;
						case 6: // forward
						case 7:
						case 8:
						case 9:
						case 10:
						case 11:
						case 12:
						case 13:
						case 14:
							pClass = "icon_state state3";
							pText = amoebaDataFactory.global.lang_icon_forward;
							break;
						default :
							break;
					}

					return pClass;
				},
				getPhoneStatusText : function(n){
					var scope = amoebaDataFactory.mainCtrlScope;
					var status = n * 1;

					var pClass;
					var pText;
					switch (status) {
						case 0: // offile
							pClass = "icon_state state1";
							//status = "icon_state state1";
							pText = amoebaDataFactory.global.lang_icon_offline;
							break;
						case 1: // idle
							pClass = "icon_state state2";
							pText = amoebaDataFactory.global.lang_icon_idle;
							break;
						case 2: // dnd
							pClass = "icon_state state4";
							pText = amoebaDataFactory.global.lang_icon_dnd;
							break;
						case 3:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking; // talk(busy)
							break;
						case 4:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking;
							break;
						case 5:
							pClass = "icon_state state5";
							pText = amoebaDataFactory.global.lang_icon_talking;
							break;
						case 6: // forward
						case 7:
						case 8:
						case 9:
						case 10:
						case 11:
						case 12:
						case 13:
						case 14:
							pClass = "icon_state state3";
							pText = amoebaDataFactory.global.lang_icon_forward;
							break;
						default :
							break;
					}

					return pText;
				},
				getNameFromAry : function(strAryName){
					var strName = "";
					for(var idx = 0 ; idx < strAryName.length ; idx++){
						if(idx + 1 == strAryName.length){
							strName += strAryName[idx];
						}
						else{
							strName += strAryName[idx] + ",";
						}
					}
					return strName;
				},
				getSmsStatus : function(n){
					//var scope = amoebaDataFactory.mainCtrlScope;
					var text = amoebaDataFactory.global.lang_smsreuslt_ready;
					var status = n * 1;
					
					switch (status) {
						case 0: 
							text = amoebaDataFactory.global.lang_smsreuslt_success;
							break;					
						case 1: 
							text = amoebaDataFactory.global.lang_smsreuslt_failure;
							break;
						default :
							text = amoebaDataFactory.global.lang_smsreuslt_ready;
							break;
					}
					
					return text;
				},
				getSmsType : function(n){ // 0227 hyosung

					//var scope = amoebaDataFactory.mainCtrlScope;
					var text = amoebaDataFactory.global.lang_forward_droplist_station;
					var status = n;
					//console.log(n);

					switch (status) {
						case "Station":
							text = amoebaDataFactory.global.lang_forward_droplist_station;
							break;
						case "Outside":
							text = amoebaDataFactory.global.lang_forward_droplist_outside;
							break;
						default :
							text = amoebaDataFactory.global.lang_forward_droplist_station;
							break;
					}

					return text;
				},
				getLicenseType : function(n){
					//var scope = amoebaDataFactory.mainCtrlScope;
					var text = amoebaDataFactory.global.lang_premium;
					var status = n * 1;

					switch (status) {
						case 0:
							text = amoebaDataFactory.global.lang_premium;
							break;
						case 1:
							text = amoebaDataFactory.global.lang_standard;
							break;
						default :
							break;
					}

					return text;
				},
				getCallControlType : function(n){
					//var scope = amoebaDataFactory.mainCtrlScope;
					var text = amoebaDataFactory.global.lang_width_voice;
					var status = n * 1;

					switch (status) {
						case 0:
							text = amoebaDataFactory.global.lang_width_voice;
							break;
						case 1:
							text = amoebaDataFactory.global.lang_no_voice;
							break;
						default :
							break;
					}

					return text;
				},
				getSMSResultType : function(n){
					//var scope = amoebaDataFactory.mainCtrlScope;
					var text = amoebaDataFactory.global.lang_edit;
					var status = n * 1;

					switch (status) {
						case 0: // FROM SMS LIST
							text = amoebaDataFactory.global.lang_edit;
							break;
						case 1: // FROM SMS RESULT
							text = amoebaDataFactory.global.lang_ok;
							break;
						default :
							break;
					}

					return text;
				},
				// Record 실행
				startRecord : function(){
					var playTime = moment().hour(0).minute(0).second(0).millisecond(0);
//					amoebaDataFactory.currentRecordTime = playTime.format("HH:mm:ss");
					amoebaDataFactory.nowRecordTime = playTime.format("HH:mm:ss");
					
					amoebaDataFactory.currentRecord = $interval(function(){
						playTime.add(1, "second");
//						amoebaDataFactory.currentRecordTime = playTime.format("HH:mm:ss");
						amoebaDataFactory.nowRecordTime = playTime.format("HH:mm:ss");
					}, 1000);
				},
				// Record 종료
				stopRecord : function(){
					$interval.cancel(amoebaDataFactory.currentRecord);

					// 0310 hyosung
					amoebaDataFactory.stopRecord("");
				},
				// Record Voice Mail 실행
				startRecordVoice : function(){

					var scope = amoebaDataFactory.mainCtrlScope;
					var playTime = moment().hour(0).minute(0).second(0).millisecond(0);
//					amoebaDataFactory.currentRecordVoiceTime = playTime.format("HH:mm:ss");
					amoebaDataFactory.nowRecordTime = playTime.format("HH:mm:ss");
					scope.startRecord = true;

					amoebaDataFactory.currentRecordVoiceTime = new Date().getTime();
					amoebaDataFactory.currentRecordVoice = $interval(this.recordTimer, 1000);
					
				},
				recordTimer : function() {
					var curentCalltime = new Date().getTime();
					var diff = curentCalltime - amoebaDataFactory.currentRecordVoiceTime;
					var timer = {};
					timer.seconds = Math.floor((diff)/1000);

					var seconds = timer.seconds;
					var hours = Math.floor(seconds / (60 * 60));

					var divisor_for_minutes = seconds % (60 * 60);
					var minutes = Math.floor(divisor_for_minutes / 60);

					var divisor_for_seconds = divisor_for_minutes % 60;
					var seconds = Math.ceil(divisor_for_seconds);


					timer.hours = hours;

					timer.minutes = minutes;

					timer.seconds = seconds;

					timer.hours = (timer.hours < 10 ) ? "0" + timer.hours: timer.hours;
					timer.minutes = (timer.minutes < 10) ? "0" + timer.minutes : timer.minutes;
					timer.seconds = (timer.seconds < 10) ? "0" + timer.seconds : timer.seconds;

					amoebaDataFactory.nowRecordTime = timer.hours + ":" +  timer.minutes + ":" + timer.seconds;
				},

				// Record Voice Mail 종료
				stopRecordVoice : function(){
					var scope = amoebaDataFactory.mainCtrlScope;
					$interval.cancel(amoebaDataFactory.currentRecordVoice);
					amoebaDataFactory.nowRecordTime ="";
					scope.startRecord = false;
				},
				
				// private user인지 확인
				checkPrivate : function(data){
					var result = false;
					
					if(data.indexOf("p") > -1){
						result = true;
					}
					return result;
				},
				setConCount : function(){
					var cnt = 0;
					var scope = amoebaDataFactory.mainCtrlScope;

					for(var i in scope.conDatas){
						cnt += scope.conDatas[i].int_new.val;
					}
					return cnt;
				},
				getConvName : function(convmsg){
					var scope = amoebaDataFactory.mainCtrlScope;
					//var convname
					for(var j in convmsg)
					{
						for(var i in scope.conDatas){

							if(scope.conDatas[i].int_conv_id.val == convmsg[j].int_conv_id.val)
							{
								convmsg[j].str_conv_name.val = scope.conDatas[i].str_conv_name.val;
							}
						}

					}
					return convmsg;
				},
				getFowardDisplayName : function(iType, str, iNumberType){
					var strReturn = "";
					if(iType == 1){
						strReturn = str + "-" + amoebaDataFactory.global.lang_forward_droplist_unconditional;
					}
					else if(iType == 2){
						strReturn = str + "-" + amoebaDataFactory.global.lang_forward_droplist_busy;
					}
					else if(iType == 3){
						strReturn = str + "-" + amoebaDataFactory.global.lang_forward_droplist_noanswer;
					}
					else if(iType == 4){
						strReturn = str + "-" + amoebaDataFactory.global.lang_forward_droplist_busynoanswer;
					}
					else{
						strReturn = str;
						//console.log("error - int_forward_type.val")
					}

					if(iNumberType == 1){
						strReturn = strReturn + "-" + amoebaDataFactory.global.lang_forward_droplist_station;
					}
					else if(iNumberType == 2){
						strReturn = strReturn + "-" + amoebaDataFactory.global.lang_forward_droplist_outside;
					}
					else if(iNumberType == 3){
						strReturn = strReturn + "-" + amoebaDataFactory.global.lang_forward_droplist_station_group;
					}

					return strReturn;
				},
				getFowardTypeName : function(iType){
					var strReturn = "";
					if(iType == 1){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_unconditional;
					}
					else if(iType == 2){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_busy;
					}
					else if(iType == 3){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_noanswer;
					}
					else if(iType == 4){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_busynoanswer;
					}
					else{
						strReturn = "Undefined";
						//console.log("error - int_forward_type.val")
					}
					return strReturn;
				},
				getNumberTypeName : function(iNumberType){
					var strReturn = "";

					if(iNumberType == 1){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_station;
					}
					else if(iNumberType == 2){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_outside;
					}
					else if(iNumberType == 3){
						strReturn = amoebaDataFactory.global.lang_forward_droplist_station_group;
					}
					else{
						strReturn = "Undefined";
						//console.log("error - int_number_type.val")
					}

					return strReturn;
				},
				encodeHTML : function(r) {
					/*
					 \x26 is &ampersand (it has to be first),
					 \x0A is newline,
					 \x22 is ",
					 \x27 is ',
					 \x3c is <,
					 \x3e is >
					 */
					return r.replace(/[\x26\x0A\x3c\x3e\x22\x27]/g, function(r) {
						return "&#" + r.charCodeAt(0) + ";";
					});
				},
				countTextAreaLength : function(str){ // depreciated? --> need to check and delete
					return str.length + (str.split("\n").length - 1);
				},
				countTextNewLineLength : function(str){ // deprecated? --> need to check and delete
					return str.split("\n").length - 1;
				},
				getRingName : function(iRingType, iReqType1, iReqType2){
					var strReturn = "";
					if(iRingType == 0){
						if(iReqType1 == 1){
							strReturn = amoebaDataFactory.global.lang_select_ring;
						}
						else{
							if(iReqType2 == "station"){
								strReturn = amoebaDataFactory.userSetting[2].str_user_selected_station_ring_file_path;
							}
							else{
								strReturn = amoebaDataFactory.userSetting[2].str_user_selected_co_ring_file_path;
							}
						}
					}
					else if(iRingType == 1){
						strReturn = amoebaDataFactory.global.lang_ring1;
					}
					else if(iRingType == 2){
						strReturn = amoebaDataFactory.global.lang_ring2;
					}
					else if(iRingType == 3){
						strReturn = amoebaDataFactory.global.lang_ring3;
					}
					else if(iRingType == 4){
						strReturn = amoebaDataFactory.global.lang_ring4;
					}
					else{
						strReturn = "Undefined";
						////console.log("error - int_number_type.val")
					}

					return strReturn;
				},
				getMeText : function(stConvLog){
					if(!stConvLog.bool_is_group.val){
						if(stConvLog.int_conv_log_type.val == 3 && stConvLog.int_conv_log_direction.val == 2){
							return amoebaDataFactory.global.lang_me;
						}
					}
					else{
						if(stConvLog.str_conv_member_userkey.val == amoebaDataFactory.strMyKey && stConvLog.int_conv_log_type.val == 3 && stConvLog.int_conv_log_direction.val == 2){
							return amoebaDataFactory.global.lang_me;
						}
					}
					return "";
				},
				getRecentActivityName : function(stConv){
					var text = "";

					if(stConv.bool_is_group.val){
						if(stConv.strary_conv_members_userkey.length == 0){
							text = amoebaDataFactory.global.lang_no_chat_members;
						}
						else{
							text = stConv.str_conv_name.val;
						}
					}
					else {
						text = stConv.str_conv_name.val;
					}

					return text;
				},
				deleteLoginScroll : function(){
					////console.log("deleteLoginScroll--------------------")
					$('#loginScrollbar1').mCustomScrollbar("destroy");
					$('#loginScrollbar2').mCustomScrollbar("destroy");
					$('#loginScrollbar3').mCustomScrollbar("destroy");
				},

				deleteMainScroll : function(){
					////console.log("deleteMainScroll--------------------");
					$('#contactList').mCustomScrollbar('destroy');
					$('#deptUserList').mCustomScrollbar('destroy');
					$('#mainScrollbar1').mCustomScrollbar('destroy');
					$('#mainScrollbar2').mCustomScrollbar('destroy');
					$('#mainScrollbar3').mCustomScrollbar('destroy');
					$('#mainScrollbar4').mCustomScrollbar('destroy');
					$('#mainScrollbar5').mCustomScrollbar('destroy');
					$('#mainScrollbar6').mCustomScrollbar('destroy');
					$('#mainScrollbar7').mCustomScrollbar('destroy');
					$('#mainScrollbar8').mCustomScrollbar('destroy');
					$('#mainScrollbar9').mCustomScrollbar('destroy');
					$('#mainScrollbar10').mCustomScrollbar('destroy');
					$('#mainScrollbar11').mCustomScrollbar('destroy');
					$('#mainScrollbar12').mCustomScrollbar('destroy');
					$('#mainScrollbar13').mCustomScrollbar('destroy');
					$('#mainScrollbar14').mCustomScrollbar('destroy');
					$('#mainScrollbar15').mCustomScrollbar('destroy');
					$('#mainScrollbar16').mCustomScrollbar('destroy');
					$('#mainScrollbar17').mCustomScrollbar('destroy');
					$('#mainScrollbar18').mCustomScrollbar('destroy');
					$('#mainScrollbar19').mCustomScrollbar('destroy');
					$('#mainScrollbar20').mCustomScrollbar('destroy');
					$('#mainScrollbar21').mCustomScrollbar('destroy');
					$('#mainScrollbar22').mCustomScrollbar('destroy');
					$('#mainScrollbar23').mCustomScrollbar('destroy');
					$('#mainScrollbar24').mCustomScrollbar('destroy');
					$('#mainScrollbar25').mCustomScrollbar('destroy');
					$('#mainScrollbar26').mCustomScrollbar('destroy');
					$('#mainScrollbar27').mCustomScrollbar('destroy');
					$('#mainScrollbar28').mCustomScrollbar('destroy');
					$('#mainScrollbar29').mCustomScrollbar('destroy');
					$('#mainScrollbar30').mCustomScrollbar('destroy');
					$('#mainScrollbar31').mCustomScrollbar('destroy');
				},

				deleteContentScroll : function(){
					////console.log("deleteContentScroll--------------------");
					$('#contentScrollbar1').mCustomScrollbar('destroy');
				},

				deleteCreateConversationScroll : function(){
					////console.log("deleteCreateConversationScroll--------------------");
					$('#createConvScrollbar1').mCustomScrollbar('destroy');
				},

				deleteAddContactScroll : function(){
					////console.log("deleteAddContactScroll--------------------");
					$('#addContactScrollbar1').mCustomScrollbar('destroy');
				},

				deleteChatContentScroll : function(){
					////console.log("deleteChatContentScroll--------------------");
					$('#chatWrap').mCustomScrollbar('destroy');
				},

				deleteSMSScroll : function(){
					////console.log("deleteSMSScroll--------------------");
					$('#smsScrollbar1').mCustomScrollbar('destroy');
				},

				deleteVoicemailScroll : function(){
					////console.log("deleteVoicemailScroll--------------------");
					$('#voicemailScrollbar1').mCustomScrollbar('destroy');
				},

				deleteFileScroll : function(){
					////console.log("deleteFileScroll--------------------");
					$('#fileScrollbar1').mCustomScrollbar('destroy');
				},

				deleteTransScroll : function(){
					////console.log("deleteTransScroll--------------------");
				},

				deleteCallingScroll : function(){
					////console.log("deleteCallingScroll--------------------");
					$('#callingScrollbar1').mCustomScrollbar('destroy');
				},

				deleteDeleteContactScroll : function(){
					////console.log("deleteDeleteContactScroll--------------------");
					$('#deleteContactScrollbar1').mCustomScrollbar('destroy');
				},

				deleteCalendarScroll : function(){
					////console.log("deleteCalendarScroll--------------------");
					$('#calendarScrolbar1').mCustomScrollbar('destroy');
				},

				deleteCallMemoScroll : function(){
					////console.log("deleteCallMemoScroll--------------------");
					$('#callMemoScrollbar1').mCustomScrollbar('destroy');
				},

				deleteUserListScroll : function(){
					////console.log("deleteUserListScroll--------------------");
					$('#userListScrollbar1').mCustomScrollbar('destroy');
				},

				deleteNewSMSScroll : function(){
					////console.log("deleteNewSMSScroll--------------------");
					$('#newSMSScrollbar1').mCustomScrollbar('destroy');
				},

				deleteRecordScroll : function(){
					////console.log("deleteRecordScroll--------------------");
					$('#recordScrollbar1').mCustomScrollbar('destroy');
				},

				deleteAddUserListScroll : function(){
					////console.log("deleteAddUserListScroll--------------------");
					$('#userListScrollbar1').mCustomScrollbar('destroy');
				},

				deleteAddCallUserListScroll : function(){
					////console.log("deleteAddCallUserListScroll--------------------");
					$('#callUserListScrollbar1').mCustomScrollbar('destroy');
				}
			};
			return messenger;
		}]
	);
});
