/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	
	ucApp.registerController(
		'deleteContactCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("deletecontentCtrl");
				
//////////////////////////////delete user start////////////////////////////////////
				$scope.service = amoebaService;
				$scope.factory = amoebaDataFactory;
				amoebaDataFactory.deletecontactScope = $scope;
				var obj = {};
				var dummy = angular.copy(amoebaDataFactory.basicUserTemp, obj);
				dummy.str_user_key.val="dummy";
				$scope.dummyuser = dummy;

				//삭제될 유저 목록
				$scope.deleteUsersData = [dummy];

				//삭제될 유저수
				$scope.totalNum = 0;

				//shared user search
				$scope.$watch('deleteUsersData', function() {
					$scope.totalNum = $scope.deleteUsersData.length - 1;
				}, true);

				$scope.unSelect = function(user){
					$scope.$emit("unselectDeleteUser", {data : user});
				};
				
				$scope.$on("selectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					var user = args.user;
					deleteSelected(id, groupKey,user);
				});
				
				$scope.$on("unselectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					deleteUnselected(id, groupKey);
				});
				
				function deleteUnselected(id, groupKey) {
					var data = $scope.deleteUsersData;
					if(data.length == 0) {
						return;
					}
					for(var i in data){
						
						if(data[i].str_user_key.val == id && data[i].int_group_id.val == groupKey){							
							data.splice(i, 1);
							break;
						}
					}
				}
				
				function deleteSelected(id, groupKey, user) {
					var data = amoebaDataFactory.contactUserData;
					user.int_ui_type = 4;
					$scope.deleteUsersData.unshift(user);
				}

				//유저 이동
				$scope.moveUsers = function(){
					var deleteData = $scope.deleteUsersData;
					var data = [];
					angular.copy(deleteData, data);
					//data.splice(data.length - 1, 1);
					$scope.$emit("moveUserResult", {"data" : data});
					//resetMem();
				};

				$scope.$on("moveUserComplete", function(event, args){
					resetMem();
				});

				//유저 삭제
				$scope.deleteUserPage = function(){
					$scope.currentAction = "deleteuser";
					//var message =$scope.factory.global.lang_msg_delete_user;
					var flag = amoebaDataFactory.mainCtrlScope.deleteUserPage();
					if(!flag){
						//$scope.deleteUsers();
					}
				};

				$scope.deleteUsers = function(){
					var deleteData = $scope.deleteUsersData;
					var conData = amoebaDataFactory.contactUserData;
					var length = conData.length;
					var result = false;
					var deleteuserlist =[];
					var i = 0;
					for(i in deleteData){
						if((deleteData[i].int_ucs_user.val === 1  && deleteData[i].str_user_key.val != "dummy" && deleteData[i].bool_is_contact_member.val === 1)
							|| deleteData[i].int_user_type.val == 3 ) { //외부 DB 사용자는 삭제할 수 없음, ucs 사용자와 개인 사용자만 삭제 가능
							deleteuserlist.push(deleteData[i]);
						}

					}
					if(deleteuserlist.length >0){
						amoebaDataFactory.DeleteUser(deleteuserlist).then(function(item){
							if(item != false){

								var stAryuserpicturelist =[];
								stAryuserpicturelist.push({str_user_key:deleteuserlist, str_picture_data:amoebaDataFactory.defaultimage});
								amoebaDataFactory.broadcastUIEvent("CHANGED_USER_PICTURE",stAryuserpicturelist);
								for (var i in deleteuserlist){
									if (deleteuserlist[i].str_user_key.val != "dummy" ){
										for (var j in conData) {
											if (deleteuserlist[i].str_user_key.val == conData[j].str_user_key.val && deleteuserlist[i].int_group_id.val == conData[j].int_group_id.val) {
												conData.splice(j, 1);
												break;
											}
										}
									}
									if (i == deleteuserlist.length - 1) {
										if (conData.length == (length - (deleteuserlist.length))) {
											result = true;
										} else {
											result = false;
										}
									}
								}
								$scope.deleteUsersData.length = 0;
								$scope.deleteUsersData.push($scope.dummyuser);
								$scope.$emit("deleteUserResult", {rel: result});
							}
							else{
							}
						});
					}
					else{
						/*$scope.deleteUsersData.length = 0;
						$scope.deleteUsersData.push($scope.dummyuser);
						$scope.$emit("deleteUserResult", {rel: true});*/
						//console.log("can not delete contact members.");
					}

				};
				
				function resetMem(){
					$scope.deleteUsersData.length = 0;
					$scope.deleteUsersData.push(dummy);
				}

/////////////////////////////////delete user end///////////////////////////////////    	

				$scope.isPresence1 = false;
				$scope.isPresence2 = false;

				/*홈화면 missedcall, newvoicemail, new im*/

				var missedCall_tableN = $('.missedCall_table tbody tr').length;
				var newVoicemail_tableN = $('.newVoicemail_table tbody tr').length;
				var newIm_tableN = $('.newIm_table tbody tr').length;

                // $scope.vCount = 0;
				// $scope.vCount = 3;
				$scope.cCount = missedCall_tableN;
				$scope.vCount =newVoicemail_tableN;
				$scope.iCount = newIm_tableN;

				// $scope.new_area_cTableNum_1=1;
				// $scope.cCount = Math.floor(missedCall_tableN);
				// $scope.cCount = Math.floor(newVoicemail_tableN);
				// $scope.cCount = Math.floor(newIm_tableN);

				$scope.new_area_cTableNum=Math.ceil(missedCall_tableN/4);
				$scope.new_area_vTableNum=Math.ceil(newVoicemail_tableN/4);
				$scope.new_area_iTableNum= Math.ceil(newIm_tableN/4);
				// $scope.missedCall_table = $('.missedCall_table').length();
				// $scope.new_area_cTableNum_2 = $scope.missedCall_table;


				// recent activity 소식 갯수
				var recent_tableN = $('.recent_table tbody tr').length;
				var notice_tableN = $('.notice_table tbody tr').length;
				// $scope.recentCount=4;

				// notice Area 소식 갯수
				$scope.recentCount=recent_tableN;
				$scope.noticeCount=notice_tableN;

				$scope.recent_area_tableNum= Math.ceil(recent_tableN/4);
				$scope.isPageNum_test= function (a,b) {
                    /*리셋*/
                    $scope.isAddedMemList=false;
                    $scope.isSetting=false;
                    $scope.isPageNum=false;
                    $scope.isUserList=false;
                    $scope.isChatAct=false;
                    if(a==1){
                    /*홈화면*/
                        $scope.isPageNum=1;
                    }else if(a==2){
                    /*채팅화면*/
                        $scope.isPageNum=2;
                            //탑웹
                        $scope.isImChatSetting=false;

                        if(b==1){
                        /*채팅화면 중 세팅액션*/
                            //user list

                        $scope.isSetting=1;
                            //탑웹
                            //컨텍리스트
                        $scope.tabMenu=1;

                        } else if (b == 2) {
                            //invite user

                            //컨텍리스트
                            $scope.isSetting=1;
                            $scope.tabMenu = 1;
                            $scope.isUserList = true;
                        } else if (b == 3) {
                            //search
                            $scope.isChatAct='search';

                        } else if (b == 4) {
                            //edit title
                            $scope.isChatAct='edit';
                        } else if (b == 5) {
                            //callmemo
                            $scope.isSetting=5;
                            $scope.isChatAct='callmemo';
                        }

                    }else if(a==3){

                    }
                };
//팝업 
				$scope.conversation_list=2
				$scope.isGroup1 = false;
				$scope.isGroup2 = false;
				$scope.isGroup3 = false;
	               
				$scope.isEditGroup2 = false;
				$scope.isEditGroup3 = false;
	
				$scope.tabMenu = 1;
				$scope.isEdit2 = false;
				$scope.contactSearchFocus = false;
				$scope.isDialSearchView = false;
				$scope.isDialSearchExpandExpand = true;
	
				$scope.alert = function () {
					alert($scope.isEdit2);
				};

				$scope.config1 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: '100%',
					axis: 'y',
					scrollInertia: 500
				};

				$scope.config2 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: '100%',
					axis: 'y',
					scrollInertia: 1000,
					mouseWheel:{ deltaFactor: 60 },
				};

				$scope.config3 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					height:'10px',
					setWidth: '100%',
					setHeight: '100%',
					scrollInertia: 500
				};

				$scope.config4 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: $(this).parent().height(),
					scrollInertia: 500
				};

				$scope.config5 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: '100%',
					scrollInertia: 500
				};

				var $setBtns = $('.set-btn'), $editBtnLayers = $('.edit-btn-layer');

				$scope.onlyOneOpen = function (e, data) {
					e.stopPropagation();
                    var $this = $(e.currentTarget);
                    if ($setBtns.is('.active') && !$this.is('.active')) {
                       $setBtns.removeClass('active');
                       $editBtnLayers.removeClass('on');
                       for (var i = 1; i < 4; i++) {
                           data.isEditGroup = false;
                       }
                       $this.prev().addClass('on');
                   }
                   $this.toggleClass('active');
                   data.isEditGroup = !data.isEditGroup;
                };
	
	   			$scope.resetPage = function (e) {
	   				var $isPopupShow = $scope.isPopupShow;
	   				if($isPopupShow) {
					    $scope.isPopupShow = !$isPopupShow;
				    }
	   				$scope.closeGroupList();
	   			};

	   			$scope.closeGroupList = function () {
	   				if (!$setBtns.is('.active')) {
	   					return;
	   				}
	   				else {
	   					$setBtns.filter('.active').removeClass('active');
	   					$editBtnLayers.each(function (i) {
	   						if ($scope['isEditGroup' + (i + 1)] == true) {
	   							$scope['isEditGroup' + (i + 1)] = false;
	   							//$scope.isPopupShow = false;
	   						}
	   					});
	   					$editBtnLayers.filter('.on').removeClass('on');
	   				}
	   			};

	   			$scope.new_area_click = function (a) {
	   				if(a==1){
	   					if ($scope.cCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   						// alert('dd')
	   					}else{
	   						$scope.isNew_area1=1;
	   						$scope.isNew_area2=$scope.isNew_area3=false;
	   					}
	   				}else if(a==2){
	   					if ($scope.vCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}else{
	   						$scope.isNew_area2=1;
	   						$scope.isNew_area1=$scope.isNew_area3=false;
	   					}
	   				}else{
	   					if ($scope.iCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}else{
	   						$scope.isNew_area3=1;
	   						$scope.isNew_area1=$scope.isNew_area2=false;
	   					}
	   				}
	   			};

	   			$scope.new_area_start = function(){

	   				if($scope.cCount!=0 && $scope.vCount!=0 && $scope.iCount!=0){
	   					// alert('ddddd')
		   			$scope.isNew_area1=1;
	   				}
	   			};

	   			$scope.menuToggle = function(e){
	   				e.stopPropagation();
	   				$scope.isPopupShow = !$scope.isPopupShow;
	   			};

	   			$scope.profileToggle = function () {
	   				if ($scope.isProfileShow) {
	   					$scope.isProfileShow = false;
	   					$('#profile_layer').fadeOut(200);
	   				} else {
	   					$scope.isProfileShow = true;
	   					$('#profile_layer').fadeIn(250);
	   				}
	   			};
	
				$scope.editGroupName = function (id) {
					var _id = "#"+id
					$(_id).prop('contenteditable', true).focus();
					$('.set-btn.active').removeClass('active');
				};

				$scope.closeGroupName = function (data, id) {
					var _id = "#"+id;
					data.isEdit = false;
				};

				$scope.dialSearchExpandToggle = function () {
					$scope.isDialSearchExpand = !$scope.isDialSearchExpand;
				};
	               
				$scope.settingEdit_1 = function (id) {
					$(id).prop('autofocus', true).focus();
				};
				$scope.settingEdit_2 = function (id) {
					$(id).prop('contenteditable', true).focus();
				};
				$scope.closeSetting_1 = function (id) {
					$(id).prop('autofocus', false);
					// $scope.isGroup2 = false;
				};
				$scope.closeSetting_2= function (id) {
					$(id).prop('contenteditable', false);
					// $scope.isGroup2 = false;
				};

				// Add Shared User 검색 결과 리스트
	            $scope.config1 = {
                    autoHideScrollbar: true,
                    theme: 'minimal-dark',
                    advanced:{
                        updateOnContentResize: true
                    },
                    setWidth: '100%',
                    setHeight: $(this).parent().height(),
                    scrollInertia: 500
	            }
			}
////////////////////////////////////////////////////////////////////		app end
		]
	);
});