/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'chatContentCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', '$interval', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, $interval, amoebaService, amoebaDataFactory) {
				//console.log("chatContentCtrl");

				$scope.chatTxt = "";
				$scope.chatDatas = amoebaDataFactory.currentChatData;
				$scope.status = amoebaDataFactory.ucsStatus;
				
				$scope.factory = amoebaDataFactory;
				amoebaDataFactory.chatCtrlScope = $scope;
				var switchColor = amoebaService.changeColor();
				$scope.chatClass = switchColor.chat;
				$scope.flagClass = switchColor.flag;
				$scope.service = amoebaService;
				$scope.showChats = [];

				newCheck();
				$scope.chatKey=amoebaDataFactory.currentConversationData.str_conv_member_userkey.val;

				function newCheck(){
					var data = amoebaDataFactory.currentChatData;
					for( var i in data){
						data[i].bool_conv_log_new.val = false;
					}
					if(data.length == 0){
						$scope.showChats.length == 0;
					}
				}

				function trim(str) {
					return str.replace(/(^\s*)|(\s*$)/gi, "");
				}

				function setFocus(){
					setTimeout(function(){
            		   	$('.chatInput').prop('autofocus', true).focus();
	   				},600);
				}

				// 채팅방(IM창)의 스크롤
				$scope.config1 = { // 0304 hyosung
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					setWidth: '100%',
					scrollInertia: 550,
					setHeight: $(this).parent().height(),
					mouseWheel:{
						deltaFactor: 60,
						normalizeDelta: true
					},
					axis: 'y',
					advanced:{
						updateOnContentResize: true
					},
					callbacks : {
						onInit: function(){
							$(this).mCustomScrollbar("scrollTo", "bottom");
						}
						, onTotalScrollBack:function(){
							////console.log("시작");
							$timeout(function(){
								$scope.pageingUp();
							});
						
						}
						, onTotalScroll:function(){
							////console.log("끝");
								$timeout(function(){
									$scope.pageingDown();
								});
						}
						, onUpdate : function(){
							$timeout(function(){
								if(amoebaDataFactory.bIsGettingConvLogInfo){
									//console.log("Updating Scroll #################");
									////console.log(amoebaDataFactory.iNumGettingConvLog);
									//amoebaDataFactory.iChatTop
									//$('#chatWrap').mCustomScrollbar('scrollTo', $("p:eq(4)"));
									$('#chatWrap').mCustomScrollbar('scrollTo', "-=350");
									//$('#chatWrap').mCustomScrollbar('scrollTo', $("p:eq(amoebaDataFactory.iNumGettingConvLog)"));
									//var moveTarget = document.getElementsByClassName("#chatHtml" + amoebaDataFactory.iChatTop);
									//$('#chatWrap').mCustomScrollbar('scrollTo', moveTarget);
									//$('#chatWrap').mCustomScrollbar('scrollTo','50%');
									//$('#chatWrap').mCustomScrollbar('scrollTo',"#chat-" + amoebaDataFactory.iChatTop);
									//var val = document.getElementById("chat-" + amoebaDataFactory.iChatTop);
									////console.log(val);
									//$('#chatWrap').mCustomScrollbar('scrollTo',val);
									amoebaDataFactory.bIsGettingConvLogInfo = false;
								}
								else if(amoebaDataFactory.bIsPageingChat){
									$('.task-wrap .hasScrollbar').mCustomScrollbar('scrollTo','bottom');
									//window.scrollTo(0, document.body.scrollHeight);
									//document.body.scrollTop = document.body.scrollHeight;
									amoebaDataFactory.bIsPageingChat = false;
								}

							});
						}
						,onOverflowY:function(){
							$timeout(function(){
								window.scrollTo(0, document.body.scrollHeight);
							}, 100);
						}
					}
				};

				$scope.waitScroll = false;

				$scope.chatSize = 20;
				$scope.chatPosition = 0;
				var realSize = $scope.chatSize * 2;
				
				// 채팅 
				$scope.pageingChat = function(){ // 0304 hyosung
					amoebaDataFactory.bIsGettingConvLogInfo = false; // important
					amoebaDataFactory.iNumGettingConvLog = -1;
					amoebaDataFactory.iCntScrollUpdate = 0;

					$scope.showChats = !angular.isDefined($scope.showChats) ? [] : $scope.showChats;

					var data = [];
					if(amoebaDataFactory.addUserData.length > 0){
						var addLine = $scope.createAddUserLine();
						//amoebaDataFactory.currentChatData.push(addLine);
					}

					angular.copy(amoebaDataFactory.currentChatData, data);

					var start = data.length - realSize;
					var end = start + realSize;
					
					if(start <= 0){
						start = 0;
						end = data.length;
					}
					
					// //console.log("크기 : "+data.length+" /  시작 : "+start+" / 끝 : "+end);
					data = data.slice(start, end);

					// by hycha
					if(data.length == 0){
						$scope.chatPosition = 1;
					} else {
						$scope.chatPosition = data[0].int_conv_log_order.val;
					}

					if(data.length > 0){
						amoebaDataFactory.bIsPageingChat = true;
					}
					$scope.addNowTime(data);
					$scope.showChats = data;

					//$scope.setNowTime();
					//scrollbarUpdate(); // 0328 hyosung
				};

				$scope.pageingUp = function(){
					if(amoebaDataFactory.bIsGettingConvLogInfo === false){
						amoebaDataFactory.bIsGettingConvLogInfo = true;

						//$scope.waitScroll = true;
						var reqConvId = -1;
						var reqConvOrder = -1;
						var reqConvTime = 0;
						if($scope.showChats[0].int_conv_log_type.val == 0){
							reqConvId = $scope.showChats[1].int_conv_id.val;
							reqConvOrder = $scope.showChats[1].int_conv_log_order.val;
							reqConvTime = $scope.showChats[1].str_conv_log_datetime.val;
						}
						else{
							reqConvId = $scope.showChats[0].int_conv_id.val;
							reqConvOrder = $scope.showChats[0].int_conv_log_order.val;
							reqConvTime = $scope.showChats[0].str_conv_log_datetime.val;
						}

						amoebaDataFactory.iCntScrollUpdate = 0;
						//amoebaDataFactory.GetAddedConversationLogInfo(reqConvId, reqConvOrder).then(function(item){
						amoebaDataFactory.GetAddedConversationLogInfoByTime(reqConvId, reqConvTime).then(function(item){
							amoebaDataFactory.iNumGettingConvLog = -1;
							//var top = $scope.showChats[0].int_conv_log_order.val;
							amoebaDataFactory.iChatTop = reqConvOrder;
							if(item !== false && item.length !== 0){
								amoebaDataFactory.iNumGettingConvLog = item.length;
								$scope.addNowTime(item);
								Array.prototype.unshift.apply($scope.showChats, item);
								$scope.chatPosition = $scope.showChats[0].int_conv_log_order.val;
								//$scope.setNowTime();
							}
							else{
								amoebaDataFactory.bIsGettingConvLogInfo = false;
							}
						});
					}
					else{
						//console.log("NO ACTION ###############")
						//amoebaDataFactory.bIsGettingConvLogInfo = false;
					}
				};
				
				$scope.pageingDown = function(){

				};
	
	
				$scope.indexOf = function(arr, search){
				    for (var i = 0; i < arr.length; i++) {
				        if (arr[i].int_conv_log_order.val == search){
				            return i;
				        }
				    }
				    return -1;
				};
				
				$scope.setNowTime = function(){
					var startTime = -1;
					var data = $scope.showChats;
					var obj;
					for(var i = 0; i < data.length; i++){
						if(i == 0){
							if(data[i].int_conv_log_type.val != 0){
								obj = $scope.createTimeLine(data[i]);
								data.unshift(obj);
							}
							startTime = data[i].str_conv_log_datetime.val
						} else {
							var chatTime = new Date(data[i].str_conv_log_datetime.val).toDateString();
							var time = new Date(startTime).toDateString();
							if(chatTime != time){
								if(data[i].int_conv_log_type.val != 0){
									obj = $scope.createTimeLine(data[i]);
									data.splice(i, 0, obj);
								}
								startTime = data[i].str_conv_log_datetime.val;
							}
						}
					}
				};

				$scope.addNowTime = function(aryStChatData){
					var startTime = -1;
					var data = aryStChatData;
					var obj;
					for(var i = 0; i < data.length; i++){
						if(i == 0){
							if(data[i].int_conv_log_type.val != 0){
								obj = $scope.createTimeLine(data[i]);
								data.unshift(obj);
							}
							startTime = data[i].str_conv_log_datetime.val
						} else {
							var chatTime = new Date(data[i].str_conv_log_datetime.val).toDateString();
							var time = new Date(startTime).toDateString();
							if(chatTime != time){
								if(data[i].int_conv_log_type.val != 0){
									obj = $scope.createTimeLine(data[i]);
									data.splice(i, 0, obj);
								}
								startTime = data[i].str_conv_log_datetime.val;
							}
						}
					}
				};
				
				$scope.currentTime = function(data){
					var time = $scope.service.setCurrentTime(data);
					return time;
				};
				
				$scope.createTimeLine = function(data){
					var obj = {};
					angular.copy(amoebaDataFactory.chatBasicTemp, obj);
					obj.int_conv_log_type.val = 0;
					obj.str_conv_log_datetime.val = data.str_conv_log_datetime.val;
//					obj.str_conv_log_datetime.val = $scope.service.setTime(time);
//					obj.str_conv_log_sort_time.val = data.str_conv_log_sort_time.val;
					return obj;
				};
				
				$scope.createAddUserLine = function(){
					var message = [" into this IM room", "invited ", " left this IM room"];
					var content;
					var data = amoebaDataFactory.addUserData;
					var con = amoebaDataFactory.currentConversationData;
					var name;
					for(no in data){
						angular.isDefined(name) ? name += ", " + data[no].str_first_name.val : name = data[no].str_first_name.val; 
					}
					var obj = {};
					angular.copy(amoebaDataFactory.chatBasicTemp, obj);
					obj.str_user_key.val = "inviteUser";
					obj.int_conv_log_type.val = 3;
					obj.int_conv_log_direction.val = 2;
					if(amoebaDataFactory.currentChatData.length == 0){
						content = name + message[0];
					} else {
						content = message[1] + name;
					}

					obj.str_conv_log_content.val = content;
					obj.str_conv_log_datetime.val = amoebaService.chatTime().sort;
					obj.str_conv_member_number.val = amoebaDataFactory.currentConversationData.str_conv_member_number.val;
					obj.str_conv_member_userkey.val = amoebaDataFactory.currentConversationData.str_conv_member_userkey.val;
					obj.strary_conv_members_number.val = amoebaDataFactory.currentConversationData.strary_conv_members_number.val;
					obj.strary_conv_members_userkey.val = amoebaDataFactory.currentConversationData.strary_conv_members_userkey.val;
					obj.int_conv_id.val = amoebaDataFactory.currentConversationData.int_conv_id.val;
					amoebaDataFactory.addUserData.length = 0;
					return obj;
				};

				$scope.pageingChat();

				function checkCon(id){
					var data = amoebaDataFactory.conversationData;

					var result;
					for(i in data){
						if(data[i].int_conv_id.val == id){
							result = data[i];
							break;
						}
					}
					return result;
				}
				

				function setChatPk(array){
					
					if(0 < array.length ){
						return array[array.length-1].int_conv_log_order.val + 1;
					}
					else{
						return 1;
					}
				}
				
				// 이모티콘 동작 시작
				initEmojiPicker();
				
				// 채팅 영역에서 엔터 입력 시
				$("#emojiArea").on("keypress", function(event){

					var keyCode = event.keyCode;
					var shift = event.shiftKey;

					// 쉬프트 누르지 않고 엔터 입력 시 채팅 전송
					if(keyCode === 13 && shift == false){
						event.preventDefault();
						$scope.$apply(function(){
							$scope.chatTxt = $("#emojiArea").val();
							$scope.addMessage();
							$("#emojiArea").val("");
						});
					}
					else if(keyCode === 13 && shift == true){
						event.preventDefault();
						var newline = $("#emojiArea").val() + "\n";
						$("#emojiArea").val(newline);
						return false;
					}

				});

				var emoticon = EmojiPickerSettings.icons;
				var emoticonKey = Object.keys(emoticon);
				
				// 이모티콘 Javascript Escape를 유니코드로 변경
				$scope.removeEmoticon = function(message){
					for(var i in emoticonKey){	
						message = message.replace(new RegExp(emoticon[emoticonKey[i]], 'g'), emoticonKey[i]);
					}
					return message;
				};

				// 유니코드를 이모티콘 Javascript Escape로 변경
				$scope.changeEmoticon = function(message){
					var ranges = [
						'\ud83c[\udf00-\udfff]', // U+1F 300 to U+1F3FF
						'\ud83d[\udc00-\ude4f]', // U+1F 400 to U+1F64F
						'\ud83d[\ude80-\udeff]',  // U+1F 680 to U+1F6FF
						'\ud83c[\ud83c-\uddff]\ud83c[\ud83c-\uddff]'  // U+1F1E6 to U+1F1FC

					];
					message = message.replace(
						new RegExp(ranges.join('|'), 'g'),
						'$&' + ' ');


					//message = message.replace(/'\u003F'/g, '');

					//message = message.replace(/\uFFFD/g, '');

					return message;
				};
				
				// 채팅 데이터 추가
				$scope.addMessage = function(){
					var message = $scope.chatTxt;
					if(message.length > 0){
						$scope.chatKey = amoebaDataFactory.currentConversationData.str_conv_member_userkey.val;
						var members= amoebaDataFactory.currentConversationData.strary_conv_members_userkey;
						var sessionkey = amoebaDataFactory.currentConversationData.str_session_key.val;
						var txt = $scope.chatTxt;
						for(var i in members)
						{
							if(members[i] == amoebaDataFactory.userInfoData.str_my_key)
							{
								members.splice(i,1);
							}
						}
						if(members.length > 0 && sessionkey =="")
						{
							amoebaDataFactory.CreateGroupChat(members,txt);
						}

						else if (members.length > 0 && sessionkey !="")
						{
							var txt = $scope.chatTxt;
							amoebaDataFactory.sendChatMessage(sessionkey, 0, txt); // by hycha
						}
						else if(members == 0)
						{
							if( $scope.chatKey == "NoUserKey"){
								amoebaDataFactory.showMainFail("CannotChatWithMember");
							}
							else{
								amoebaDataFactory.sendChatMessage(0, $scope.chatKey, txt);
							}

						}
					}
					$scope.chatTxt = "";
					setFocus();
					$scope.setNowTime();
				};


				$scope.addReceivedMessage = function(convlogmsg)
				{
					//console.log("addReceivedMessage");
					//console.log(convlogmsg);
					//scrollbarUpdate();
					var txt = convlogmsg.str_conv_log_content.val;
					var data = {"txt" : txt, "id" : amoebaDataFactory.currentConvId, "direction" : convlogmsg.int_conv_log_direction.val, "type" : convlogmsg.int_conv_log_type.val,
						"time" : convlogmsg.str_conv_log_datetime.val, "sort" : convlogmsg.str_conv_log_datetime.val, "count": convlogmsg.bool_conv_log_new.val};

					// by hyosung - delete over chat
					if($scope.showChats.length > 20){
						$scope.showChats.splice(0, $scope.showChats.length - 20);
					}

					$scope.$apply(function() {
						$scope.chatDatas.push(convlogmsg);
						$scope.showChats.push(convlogmsg);
						$scope.$emit('completed', {data : data});
						scrollbarUpdate();
					});

					setFocus();
					$scope.setNowTime();
				}; //end

				$scope.updateMissedLog = function(stConvlog){
					var iLength = $scope.showChats.length;
					for(var idx = 0 ; idx < iLength; idx++){
						if($scope.showChats[idx].int_conv_log_type.val == 2){
							$scope.showChats[idx].int_conv_log_type.val = 10;
							$scope.showChats[idx].int_conv_UI.val = 16;
							//var tmpConvlog = {};
							//angular.copy($scope.showChats[idx], tmpConvlog);
							//$scope.showChats.splice(idx, 1, tmpConvlog);
						}
					}
				};

				$scope.updatechattime = function(convlogmsg)
				{
					var txt = convlogmsg.str_conv_log_content.val;
					var data = {"txt" : txt, "id" : convlogmsg.int_conv_id.val, "direction" : convlogmsg.int_conv_log_direction.val, "type" : convlogmsg.int_conv_log_type.val,
						"time" : convlogmsg.str_conv_log_datetime.val, "sort" : convlogmsg.str_conv_log_datetime.val, "count": convlogmsg.bool_conv_log_new.val, "sessionkey":convlogmsg.str_session_key.val}

					// by hyosung - delete over chat
					if($scope.showChats.length > 20){
						$scope.showChats.splice(0, $scope.showChats.length - 20);
					}

					$scope.$apply(function() {
						//$scope.chatDatas.push(convlogmsg); // 0304 hyosung
						$scope.showChats.push(convlogmsg);
						$scope.$emit('completed', {data : data});
						scrollbarUpdate();

					});
				};
				
				$scope.addChatUser = function(){
					if(amoebaDataFactory.memberLevel == "PREMIUM"){
						var obj = {};
						if(amoebaDataFactory.isMoveDummy){
							amoebaDataFactory.isMoveDummy = false;
							
							if($scope.factory.dragData.str_user_key.val == $scope.ownerInfo.str_user_id.val){
								amoebaDataFactory.isMoveDummy = undefined;
								return;
							}
							
							var allUser = amoebaDataFactory.contactUserData;
							var currentConv = amoebaDataFactory.currentConversationData;
							var addUser = $scope.factory.dragData;
							var userList = [];
							//1 : 1 or 1 : N
							if(currentConv.bool_is_group.val){
								userList = currentConv.strary_conv_members_userkey; 
							} else {
								userList.push(currentConv.str_conv_member_userkey.val); 
							}
							//이미 포함된 사용자인지
							var index = userList.indexOf(addUser.str_user_key.val)
							if(index > -1){
								return alert("이미 속해있는 유저입니다.");
							}
							
							
							var arr = [];
							if(userList.length > 1){
								addUser.selectedPhone = addUser.str_desk_phone1.val;
								arr.push(addUser);
								angular.copy(arr, amoebaDataFactory.addUserData);
								
								$scope.$emit("inviteToGroup", {"data" : arr});
								
							} else {
								userList.push(addUser.str_user_key.val);
								for(j in userList){
									for(i in allUser){
										if(allUser[i].str_user_key.val == userList[j]){
											arr.push(allUser[i]);
											break;
										}
									}
								}
								angular.copy(arr, amoebaDataFactory.addUserData);
								$scope.$emit("createConversation", {"data" : arr, "bool": false});
							}
						}
					}
				};
				
				$scope.addCall = function(){
					if(message.length > 0){
						var obj ={};
						var id = amoebaDataFactory.currentConvId
						var conversation = checkCon(id);
						angular.copy(amoebaDataFactory.chatBasicTemp, obj);
						obj.int_conv_id.val = id;
						obj.int_conv_log_type.val = 3;
						obj.int_conv_log_direction.val = 2;
						obj.str_conv_log_datetime.val = amoebaService.chatTime().sort;
//						obj.str_conv_log_sort_time.val = amoebaService.chatTime().sort;
						obj.str_conv_log_content.val = $scope.chatTxt;
						obj.bool_is_group.val = conversation.bool_is_group.val;
						obj.strary_conv_members_number = conversation.strary_conv_members_number;
						obj.strary_conv_members_userkey = conversation.strary_conv_members_userkey;
						obj.str_conv_member_number.val = conversation.str_conv_member_number.val;
						obj.str_conv_member_userkey.val = conversation.str_conv_member_userkey.val;
						obj.int_conv_log_order.val = setChatPk($scope.showChats);
						
						$scope.chatDatas.push(obj);
						$scope.showChats.push(obj);
						
						scrollbarUpdate();
						var txt = $scope.chatTxt;
						var data = {txt : txt, id : amoebaDataFactory.currentConvId, direction : 2, type : 3, "time" : obj.str_conv_log_datetime.val, "sort" : obj.str_conv_log_datetime.val}
						$scope.$emit('completed', {data : data});
					}
					setFocus();
					$scope.setNowTime();
				};

				$scope.chatSet = function(data){
					$scope.service.chatSet(data);
				};

				$scope.$on('currentChat', function(event, args) {
					//var id = data.id;
					$scope.chatDatas = amoebaDataFactory.currentChatData;
					newCheck();
					
					$scope.pageingChat();
					scrollbarUpdate();
	                setFocus();
					$("#emojiArea").focus();
				});
				
				// 채팅 삭제
				$scope.$on('deleteChat', function(event, args) {
					$scope.factory.searchIndex = 0;
					$scope.chatPosition = 0;
					$scope.showChats = [];
				});
				
				// 채팅 검색
				$scope.$on('chatSearch', function(event, args) {
					
					var data = [];
					angular.copy(amoebaDataFactory.currentChatData, data);	
					
					var search = args.data;
					var target = null;
					
					for(var i = $scope.factory.searchIndex; i < $scope.chatDatas.length; i++) {
					    if ($scope.chatDatas[i].str_conv_log_content.val.indexOf(search) > -1) {
					    	target = $scope.chatDatas[i];
					        break;
					    }
					}
					
					if(target == null){
						alert("검색 결과가 없습니다.");
						return;
					}
					
					//console.log("아이디 : "+target.int_conv_log_order.val);
					
					// $scope.chatPosition 이 부분 확인해야할것 같음
					$scope.chatPosition = 0;
					var now = target.int_conv_log_order.val;
					
					if(now == 0){
						return;
					}

					var start = now - $scope.chatSize;
					var end = start + realSize;

					if(start <= 0){
						start = 0;
						end = realSize;
					}

					data = data.slice(start, end);
					$scope.chatPosition = data[0].int_conv_log_order.val;
					$scope.factory.searchIndex = now;
					$scope.showChats = data;
					$scope.setNowTime();
				});

				// 채팅창 유저 사진 클릭 시 프로필
				$scope.openProfile = function(data){
					if(amoebaDataFactory.memberLevel == "PREMIUM"){
						$scope.$emit("openChatProfile", {"id" : data.str_conv_member_userkey.val});
					}
					else{
						$scope.$emit("openChatProfile", {"id" : amoebaDataFactory.currentConversationData.str_conv_member_userkey.val});
					}

				};

				$scope.$on("$viewContentLoaded", function(event){
					$timeout(function () {
						amoebaDataFactory.printTrace("chattingroomnotify");
						var contactUser = amoebaDataFactory.mainCtrlScope.contactUser;
						var currentConv = amoebaDataFactory.currentConversationData;
						if(currentConv.bool_is_group.val === false){
							//for(var j =0 ; j <$scope.transData.length; j++){
								for(var k in contactUser){
									if(currentConv.str_conv_member_userkey.val == contactUser[k].str_user_key.val){
											amoebaDataFactory.mainCtrlScope.userImstatus = contactUser[k].str_im_status.val;
											amoebaDataFactory.mainCtrlScope.userPhonestatus = contactUser[k].str_phone_status.val;
									}
								}
							//}
						}
					},1000);
				});
//////////////////////////////////////////////////////////conversation end

				$scope.isPresence1 = false;
				$scope.isPresence2 = false;

				/*홈화면 missedcall, newvoicemail, new im*/
				var missedCall_tableN = $('.missedCall_table tbody tr').length;
				var newVoicemail_tableN = $('.newVoicemail_table tbody tr').length;
				var newIm_tableN = $('.newIm_table tbody tr').length;
				// $scope.vCount = 0;
				// $scope.vCount = 3;
				$scope.cCount = missedCall_tableN;
				$scope.vCount =newVoicemail_tableN;
				$scope.iCount = newIm_tableN;

				// $scope.new_area_cTableNum_1=1;
				// $scope.cCount = Math.floor(missedCall_tableN);
				// $scope.cCount = Math.floor(newVoicemail_tableN);
				// $scope.cCount = Math.floor(newIm_tableN);

				$scope.new_area_cTableNum=Math.ceil(missedCall_tableN/4);
				$scope.new_area_vTableNum=Math.ceil(newVoicemail_tableN/4);
				$scope.new_area_iTableNum= Math.ceil(newIm_tableN/4);
				// $scope.missedCall_table = $('.missedCall_table').length();
				// $scope.new_area_cTableNum_2 = $scope.missedCall_table;


				// recent activity 소식 갯수
				var recent_tableN = $('.recent_table tbody tr').length;
				var notice_tableN = $('.notice_table tbody tr').length;

				// notice Area 소식 갯수
				$scope.recentCount=recent_tableN;
				$scope.recent_area_tableNum= Math.ceil(recent_tableN/4);

				//팝업
				$scope.conversation_list=2;
				$scope.isGroup1 = false;
				$scope.isGroup2 = false;
				$scope.isGroup3 = false;

				$scope.isEditGroup2 = false;
				$scope.isEditGroup3 = false;

				$scope.tabMenu = 1;
				$scope.isEdit2 = false;
				$scope.contactSearchFocus = false;
				$scope.isDialSearchView = false;
				$scope.isDialSearchExpandExpand = true;

				function scrollbarUpdate(){
					setTimeout(function(){
						$('.task-wrap .hasScrollbar').mCustomScrollbar('scrollTo','bottom');
					},100);
				}

	   			$scope.resetPage = function (e) {
	   				var $isPopupShow = $scope.isPopupShow;
	   				if($isPopupShow) $scope.isPopupShow = !$isPopupShow;

	   				$scope.closeGroupList();
	   			};

	   			$scope.closeGroupList = function () {
	   				if (!$setBtns.is('.active')) {
	   					return;
	   				}
	   				else {
	   					$setBtns.filter('.active').removeClass('active');
	   					$editBtnLayers.each(function (i) {
	   						if ($scope['isEditGroup' + (i + 1)] == true) {
	   							$scope['isEditGroup' + (i + 1)] = false;
	   							//                            $scope.isPopupShow = false;
	   						}
	   					});
	   					$editBtnLayers.filter('.on').removeClass('on');
	   				}
	   			};

	   			$scope.new_area_click = function (a) {
	   				if(a==1){
	   					if ($scope.cCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   						// alert('dd')
	   					}else{
	   						$scope.isNew_area1=1;
	   						$scope.isNew_area2=$scope.isNew_area3=false;
	   					}
	   				}else if(a==2){
	   					if ($scope.vCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}else{
	   						$scope.isNew_area2=1;
	   						$scope.isNew_area1=$scope.isNew_area3=false;
	   					}
	   				}else{
	   					if ($scope.iCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}else{
	   						$scope.isNew_area3=1;
	   						$scope.isNew_area1=$scope.isNew_area2=false;
	   					}
	   				}

	   			};

	   			$scope.new_area_start = function(){

	   				if($scope.cCount!=0 && $scope.vCount!=0 && $scope.iCount!=0){
	   					// alert('ddddd')
		   			$scope.isNew_area1=1;
	   				}
	   			};

	   			$scope.menuToggle = function(e){
	   				e.stopPropagation();
	   				$scope.isPopupShow = !$scope.isPopupShow;
	   			};

	   			$scope.profileToggle = function () {
	   				if ($scope.isProfileShow) {
	   					$scope.isProfileShow = false;
	   					$('#profile_layer').fadeOut(200);
	   				} else {
	   					$scope.isProfileShow = true;
	   					$('#profile_layer').fadeIn(250);
	   				}
	   			};

				$scope.editGroupName = function (id) {
					var _id = "#"+id
					$(_id).prop('contenteditable', true).focus();
					$('.set-btn.active').removeClass('active');
				};

				$scope.closeGroupName = function (data, id) {
					var _id = "#"+id;
					data.isEdit = false;
					$(_id).prop('contenteditable', false);
					// $scope.isGroup2 = false;
				};

				$scope.dialSearchExpandToggle = function () {
					$scope.isDialSearchExpand = !$scope.isDialSearchExpand;
				};

				$scope.settingEdit_1 = function (id) {
					$(id).prop('autofocus', true).focus();
				};

				$scope.settingEdit_2 = function (id) {
					$(id).prop('readonly', false);
				};

				$scope.closeSetting_1 = function (id) {
					$(id).prop('autofocus', false);
					// $scope.isGroup2 = false;
				};

				$scope.closeSetting_2= function (id) {
					$(id).prop('contenteditable', false);
					// $scope.isGroup2 = false;
				};

				$scope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
					if(fromState.name == "main.chatcontent"){
						//console.log("change state from chatcontent to another");
						amoebaDataFactory.DeleteNotStartedConv();
					}
				});
				
				/*$scope.$on("updateChatPicture", function (event, args) {
					console.log("allchattingMsg");
					var userkey = args.userkey;
					console.log(userkey);
					console.log($scope.showChats);
					amoebaService.updateChatPic(userkey,$scope.showChats);
				});*/
				// chat content 사진 업데이트
				$scope.$on("CHANGED_USER_PICTURE", function(event, args){
					var userkey = args[0].str_user_key;
					//var userpicture = args[0].str_picture_data;
					amoebaService.updateChatPic(userkey,$scope.showChats);
					

				});
				
				/*$scope.$on("DeleteMemberPicture", function(event, args){
					
					var userkey = args[0].userkey;
					amoebaService.updateChatPic(userkey, $scope.showChats)
					
				})*/

				/*
				$scope.$on("DeleteCurrentIMConvLog", function(event, args){
					console.log("DeleteCurrentIMConvLog");
					console.log($scope.showChats);
					var iLength = $scope.showChats.length;
					for(var idx = 0 ; idx < iLength ; idx++){
						if($scope.showChats[idx].int_conv_log_type.val == 3){
							$scope.showChats.splice(idx, 1);
						}
						iLength--;
						idx--;
					}
				});
				*/
			}
		]
	);
});
