/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'contentCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', '$interval', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, $interval, amoebaService, amoebaDataFactory) {
				////console.log("contentCtrl");

				amoebaDataFactory.contentCtrlScope = $scope;
				$scope.service = amoebaService;
				$scope.factory = amoebaDataFactory;// ctrl에서 선언 후

				var t = new Date();
				////console.log(t.getMonth());


				var switchColor = $scope.service.changeColor();
				$scope.textClass =	switchColor.text;
				$scope.tabTextClass = switchColor.tab;
				$scope.ContactUser = amoebaDataFactory.contactUserData;
				$scope.chatData = amoebaDataFactory.chatData;

				// new voicemail standard 
				$scope.voicemail_server_cnt=false;

//				$scope.service.contentSetData();
				$scope.allDatas = [];
				$scope.noticeDatas =[];
				$scope.missedDatas = [];
				$scope.voiceMailDatas = [];
				$scope.IMDatas = [];
				$scope.customDatas = [];
				$scope.recentDatas = [];
				$scope.customAllDatas = [];
				$scope.noticeCount = $scope.noticeDatas.length;
				$scope.cCount = $scope.missedDatas.length;
				$scope.vCount = $scope.voiceMailDatas.length;
				$scope.iCount = $scope.IMDatas.length;
				$scope.recentCustomDatas = [];
				$scope.recentCurrentPageNum = 1;

				$scope.setPic = function(data){
					return amoebaService.currentPic(data);
				};
				
				$scope.changeSort = function(name) {
					$scope.recentSortVal = name;
					amoebaDataFactory.recentSortVal = name;
					$scope.recentDrop = name;

					switchSort(name);
				};
				
				function openTab(no){
					$scope.isNew_area1=false;
					$scope.isNew_area2=false;
					$scope.isNew_area3=false;
					$scope.new_area_click(no);
				}
				
				$scope.currentTime = function(data){
					var time = $scope.service.setCurrentTime(data);
					return time;
				};
				
				$scope.currentDate = function(data){
					var date = $scope.service.setTime(data);
					return date;
				};
				
				$scope.$on('updateContent', function (event, args) {
					var result = args.val;
					$scope.setContent();
				});


				//recent activity dropdown menu
				$scope.recentDropDown = [];
                
                // 드랍박스 생성
                $scope.getDropList = function(){
					$scope.recentDropDown.push($scope.factory.global.lang_droplist_all);
					$scope.recentDropDown.push($scope.factory.global.lang_droplist_call);
					$scope.recentDropDown.push($scope.factory.global.lang_droplist_voice);
					$scope.recentDropDown.push($scope.factory.global.lang_droplist_im);
                };

				
				$scope.getDropList();
				// by hycha , keep recentdroplist after moving page
				if(amoebaDataFactory.recentSortVal == null){
					$scope.recentSortVal =$scope.recentDropDown[0];
					$scope.recentDrop = $scope.recentSortVal;
				}
				else{
					$scope.recentSortVal = amoebaDataFactory.recentSortVal;
					$scope.recentDrop = $scope.recentSortVal;
				}

				$scope.switchRecent = 4;

				$scope.setContent = function(){
					////console.log("setContent");
					$scope.cCount = amoebaDataFactory.missedCallCount;
					$scope.iCount = amoebaDataFactory.newIMDataCount;
					$scope.vCount = amoebaDataFactory.newvoicemailCount;
					if($scope.isNew_area1 == 1)
					{
						////console.log("misssedcall");
						moveToPageNum($scope.factory.global.lang_default, 0, $scope.currentPageNum);

					}
					else if($scope.isNew_area2 ==  1)
					{
						////console.log("voicemail");
						moveToPageNum($scope.factory.global.lang_default, 1,$scope.currentPageNum);
					}
					else if($scope.isNew_area3 == 1)
					{
						////console.log("newimimimiim");
						moveToPageNum($scope.factory.global.lang_default, 2,$scope.currentPageNum);
					}

					var int_type = sortActivity($scope.recentDrop);

					amoebaDataFactory.getTotalDashboardActivity(int_type,4).then(function(item){
						if(item != false)
						{
							$scope.recentCount =1;
							$scope.recentCurrentPageNum = 1;
							$scope.recentAllPageNum = item;
							//amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "RecentData");
							//amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, $scope.recentCurrentPageNum);
							amoebaDataFactory.getSomeDashboardActivity(int_type, $scope.recentCurrentPageNum,4).then(function(item){

								item = UCAPP.UC.DATA.Conversation.getRecentActivities(item);
								//item = $scope.service.getConvName(item); // self referencing!!!!!!! it causes memory leak,
								$scope.service.getConvName(item);
								$scope.recentCustomDatas = item;
								amoebaDataFactory.recentList = item;
								amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG,"RecentDataList");
								amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG,amoebaDataFactory.recentList);
							});
						}
						else
						{
							$scope.recentCount =0;
						}
					});
					amoebaDataFactory.getAdminMsg().then(function(item){
						if(item != false)
						{
							$scope.noticeDatas = item;
							$scope.cutArray($scope.noticeDatas,3);
							amoebaDataFactory.noticeData = $scope.noticeDatas;
							$scope.noticeCount = $scope.noticeDatas.length;
						}
						else{
							$scope.noticeCount =0;
						}
					});
				};

				function cutArray(data, num){
					if(num < data.length){
						data.splice(num, data.length - num);
					}
				}

				$scope.cutArray = function(data,num)
				{
					if(num < data.length){
						data.splice(num, data.length - num);
					}
				};

				//missed call, voice mail, im 분류
				function restructureData(data){
					for(var i = 0; i < data.length; i++){
						if(data[i].bool_conv_log_new.val == true){
							var type = data[i].int_conv_log_type.val;
							if(type == 2){

								$scope.missedDatas.push(data[i]);
							} else if(type == 7) {

								$scope.voiceMailDatas.push(data[i]);
							} else {

								$scope.IMDatas.push(data[i]);
							}
						}
					}
				}

				//내림차순 정렬
				function sortList(data){
					if(data.length == 0)return;

					data.sort(function (a, b) {
						return new Date(b.str_conv_log_datetime.val) < new Date(a.str_conv_log_datetime.val) ? -1 : new Date(b.str_conv_log_datetime.val) > new Date(a.str_conv_log_datetime.val) ? 1 : 0;
					});
				}

				$scope.sortconvlog = function(data){
					if(data.length == 0)return;

					data.sort(function (a, b) {
						return new Date(b.str_conv_log_datetime.val) < new Date(a.str_conv_log_datetime.val) ? -1 : new Date(b.str_conv_log_datetime.val) > new Date(a.str_conv_log_datetime.val) ? 1 : 0;
					});

				};

				function equalCheck(data){
					var noArr = [];
					var no = 0
					for(no; no < data.length; no++){
						if(no + 1 < data.length){
							if((data[no].str_user_key.val == data[no + 1].str_user_key.val) &&
									(data[no].int_conv_log_type.val == data[no + 1].int_conv_log_type.val) &&
									(data[no].int_conv_log_direction.val == data[no + 1].int_conv_log_direction.val) &&
									(data[no].int_conv_id.val == data[no + 1].int_conv_id.val)){
									noArr.push(no+1);
									data.splice(no+1, 1);
									data[no].int_plus_Count = noArr.length + 1;
									no -= 1;
							}  else {
								noArr.length = 0;
								if(!angular.isDefined(data[no].int_plus_Count)){
									data[no].int_plus_Count = 0;
								}
							}
						} else {
							if(!angular.isDefined(data[no].int_plus_Count)){
								data[no].int_plus_Count = 0;
							}
						}
					}
				}

			    $scope.equalCheck = function(data){
					var noArr = [];
					var no = 0
					for(no; no < data.length; no++){
						if(no + 1 < data.length){
							if((data[no].str_conv_member_userkey.val == data[no + 1].str_conv_member_userkey.val) &&
								(data[no].int_conv_log_type.val == data[no + 1].int_conv_log_type.val) &&
								(data[no].int_conv_log_direction.val == data[no + 1].int_conv_log_direction.val) &&
								(data[no].int_conv_id.val == data[no + 1].int_conv_id.val)){
								noArr.push(no+1);
								data.splice(no+1, 1);
								data[no].int_plus_Count = noArr.length + 1;
								no -= 1;
							}  else {
								noArr.length = 0;
								if(!angular.isDefined(data[no].int_plus_Count)){
									data[no].int_plus_Count = 0;
								}
							}
						} else {
							if(!angular.isDefined(data[no].int_plus_Count)){
								data[no].int_plus_Count = 0;
							}
						}
					}
					return data;
				};

				$scope.switchSortEKR = function(str){
					var obj = [];
					var data = $scope.allDatas;
					$scope.recentDatas.length = 0;
					$scope.switchRecent = 5;
					if(str == "Call"){

						for(var i = 0; i < data.length; i++){
							if(data[i].int_conv_log_type.val == 1 || data[i].int_conv_log_type.val == 2){
								$scope.recentDatas.push(data[i]);
							}
						}
						obj = $scope.recentDatas;
					} else if(str == "Voice Mail"){
						for(var i = 0; i < data.length; i++){
							if(data[i].int_conv_log_type.val == 7){

								$scope.recentDatas.push(data[i]);
							}
						}
						obj = $scope.recentDatas;
					} else if(str == "IM"){
						for(var i = 0; i < data.length; i++){
							if(data[i].int_conv_log_type.val != 1 && data[i].int_conv_log_type.val != 2 && data[i].int_conv_log_type.val != 7){
								$scope.recentDatas.push(data[i]);
							}
						}
						obj = $scope.recentDatas;
					} else {
						if(amoebaDataFactory.memberStorageLevel == "CM"){
							for(var i = 0; i < data.length; i++){
								if(data[i].int_conv_log_type.val != 7){
									$scope.recentDatas.push(data[i]);
								}
							}
							obj = $scope.recentDatas;
						} else {
							obj = data;
						}
						$scope.switchRecent = 4;
					}

					$scope.recentCount = obj.length;
					setRecentPageNum(obj);
					moveToPage($scope.factory.global.lang_default, obj, $scope.switchRecent);
				};

				$scope.setContent();

				//데이터 선택
				function setPageData(no){
					var data = null;
					switch(no){
						case 1 :
							data = $scope.missedDatas;
							break;
						case 2 :
							data = $scope.voiceMailDatas;
							break;
						case 3 :
							data = $scope.IMDatas;
							break;
						case 4 :
							data = $scope.allDatas;
							break;
						case 5 :
							data = $scope.recentDatas;
							break;
					}
					return data;
				}
				
				//prev 페이지
				$scope.prev = function(no){
					no = no-1;
					moveToPageNum($scope.factory.global.lang_default, no ,$scope.currentPageNum -1);
				};
				
				//next 페이지
				$scope.next = function(no){
					no = no-1;
					moveToPageNum($scope.factory.global.lang_default, no ,$scope.currentPageNum+1);
				};

				$scope.recentDataNext = function(){
					//console.log("recentDataNext");
					var int_type = sortActivity($scope.recentDrop);
					var no = $scope.recentCurrentPageNum +1;
					$scope.recentCurrentPageNum +=1;
					amoebaDataFactory.getSomeDashboardActivity(int_type,no ,4).then(function(item){
						item = UCAPP.UC.DATA.Conversation.getRecentActivities(item);
						$scope.service.getConvName(item);
						$scope.recentCustomDatas=item;
					});
				};

				$scope.recentDataPre = function(){
					//console.log("recentDataPre");
					var int_type = sortActivity($scope.recentDrop);
					var no = $scope.recentCurrentPageNum -1;
					$scope.recentCurrentPageNum -=1;
					amoebaDataFactory.getSomeDashboardActivity(int_type,no ,4).then(function(item){
						item = UCAPP.UC.DATA.Conversation.getRecentActivities(item);
						$scope.service.getConvName(item);
						$scope.recentCustomDatas = item;
					});
				};
				
				//페이지 전환에 따른 데이터 재조립
				function moveToPage(txt, data, switchNo){
					var plus = 1;
					var no;
					var custom;
					var all;
					if(switchNo != 4 && switchNo != 5){
						no = $scope.currentPageNum;
						current = $scope.currentPageNum;
						all = $scope.allPageNum;
						angular.copy(data, $scope.customDatas);
						custom = $scope.customDatas;
					}
					else {
						all = $scope.recentAllPageNum;
						angular.copy(data, $scope.recentCustomDatas);
						custom = $scope.recentCustomDatas;
					}
					
					if(txt.indexOf($scope.factory.global.lang_prev) > -1){
						plus *= -1
					} else if(txt.indexOf($scope.factory.global.lang_default) > -1){
						plus = 0;
					}

					no += plus;

					if(no >= all){
						var rel = custom.length % 4;
						var allLength = custom.length;
						var lastNum = rel == 0 ?  allLength - 4 : allLength - rel;
						current = all;
						custom.splice(0, lastNum);
					}
					else if(no <= 1 ){
						current = 1;
						custom.splice(4, custom.length - 4);
					}
					else {
						var length = 4 * no;
						current = no;
						custom.splice(0, length - 4);
						custom.splice(4, custom.length);
					}

					if(switchNo != 4 && switchNo != 5){

						$scope.currentPageNum = current;
						$scope.customDatas = custom;
						$scope.allPageNum = all;
						
						for(var i in $scope.customDatas){
							$scope.customDatas[i].isVoicemail_drop = false;
							$scope.customDatas[i].isVoicemail_play = false;
							$scope.customDatas[i].play_time = "00:00";
						}
						
					}
				}

				//페이지 전환에 따른 데이터 재조립
				function moveToPageNum(txt, int_type, no){
					var plus = 1;
					var custom;
					var all;
					$scope.currentPageNum = no;

					amoebaDataFactory.getTotalNewconvPage(int_type,4).then(function(item){
						if(item != false)
						{
							$scope.allPageNum = item;
							//console.log("allpagenum");
							//console.log(item);
							amoebaDataFactory.getsomenewConvlogInfo(int_type,no,4).then(function(item){
								if(item != false)
								{
									console.log("somenewconvlgo");
									console.log(item);
									$scope.customDatas = item;
									custom = $scope.customDatas;
									//setPageNum(custom);
									all = $scope.allPageNum;
									if(txt.indexOf($scope.factory.global.lang_prev) > -1){
										plus *= -1
									} else if(txt.indexOf($scope.factory.global.lang_default) > -1){
										plus = 0;
									}

									for(var i in $scope.customDatas){
										$scope.customDatas[i].isVoicemail_drop = false;
										$scope.customDatas[i].isVoicemail_play = false;
										$scope.customDatas[i].play_time = "00:00";
									}
								}
							});
						}
					});
				}

				function sortActivity(str){
					var int_type =0;
					if(str == $scope.factory.global.lang_droplist_call)
					{
						int_type = 1;
					}
					else if(str == $scope.factory.global.lang_droplist_voice)
					{
						int_type = 2;
					}
					else if (str == $scope.factory.global.lang_droplist_im)
					{
						int_type =  3;
					}
					else if(str == $scope.factory.global.lang_droplist_all)
					{
						int_type = 0;
					}
					return int_type;
				}

				function switchSort(str){
					//console.log("switchSort");
					var obj = [];
					var data = $scope.allDatas;
					$scope.recentDatas.length = 0;
					$scope.switchRecent = 5;

					if(str == $scope.factory.global.lang_droplist_call)
					{
						str = 1;
					}
					else if(str == $scope.factory.global.lang_droplist_voice)
					{
						str = 2;
					}
					else if (str == $scope.factory.global.lang_droplist_im)
					{
						str =  3;
					}
					else if(str == $scope.factory.global.lang_droplist_all)
					{
						str = 0;
					}
					amoebaDataFactory.getTotalDashboardActivity(str,4).then(function(item){
						if(item != false)
						{
							$scope.recentCount =1;
							$scope.recentCurrentPageNum = 1;
							$scope.recentAllPageNum = item;
							amoebaDataFactory.getSomeDashboardActivity(str, $scope.recentCurrentPageNum,4).then(function(item){
								item = UCAPP.UC.DATA.Conversation.getRecentActivities(item);
								//item= $scope.service.getConvName(item);
								$scope.service.getConvName(item); // self referencing!! it cause mery leak.
								$scope.recentCustomDatas = item;
							});
						}
						else
						{
							$scope.recentCount =0;
						}
					});
				};

				//페이지 초기설정
				function setPageNum(data){
					var obj = pageNumber(data);
					 $scope.currentPageNum=  1;
					$scope.allPageNum = obj.result2 > 0 ? obj.result1 + 1 : obj.result1;
				};

				//recent 페이지 초기설정
				function setRecentPageNum(data){
					var obj = pageNumber(data);
					$scope.recentCurrentPageNum =  1;
					$scope.recentAllPageNum = obj.result2 > 0 ? obj.result1 + 1 : obj.result1;
					moveToPage($scope.factory.global.lang_default, $scope.allDatas, 4);
				};

				$scope.setRecentPageNum = function(data){
					var obj = pageNumber(data);
					$scope.recentCurrentPageNum =  1;
					$scope.recentAllPageNum = obj.result2 > 0 ? obj.result1 + 1 : obj.result1;
					moveToPage($scope.factory.global.lang_default, $scope.allDatas, 4);
				};

				function pageNumber(data){
					var no = data.length;
					//var no = data
					var result1 = parseInt(no / 4);
					var result2 =  no % 4;
					var obj = {"result1" : result1, "result2" : result2};
					return obj
				}

				function searchUser(userData){
					var user = userData;
					var data = $scope.ContactUser;

					var id = user.str_user_key.val;
					for( var i in data){
						if(data[i].str_user_key.val == id){
							user.str_im_status = {"val" : data[i].str_im_status.val};
							user.str_phone_status = {"val" : data[i].str_phone_status.val};
							user.str_desk_phone1 = {"val" : data[i].str_desk_phone1.val};
							break;
						}
					}
				}

				$scope.goToCall = function(data, bool){
					console.log("goToCall");
					var obj = {};
					angular.copy(data, obj);
					
					console.log(data);
					
					if(obj.bool_is_group.val){
						
						obj.memInfo = {"number": [], "userkey": []};
						obj.memInfo.number = obj.strary_conv_members_number;
						obj.memInfo.userkey = obj.strary_conv_members_userkey;
						obj.str_conv_member_number.val = "";
						obj.str_conv_member_userkey.val = "";
					}
					
					$scope.$emit("missedCall", {"data" : obj});
				};

				//총 사진 갯수
				$scope.isPhoto = function(data){
					$scope.service.isPhoto(data);
				};

				//////////////////////////////////////////////////////////content end

				/*홈화면 missedcall, newvoicemail, new im*/
				var missedCall_tableN = $('.missedCall_table tbody tr').length;
				var newVoicemail_tableN = $('.newVoicemail_table tbody tr').length;
				var newIm_tableN = $('.newIm_table tbody tr').length;

				$scope.new_area_cTableNum=Math.ceil(missedCall_tableN/4);
				$scope.new_area_vTableNum=Math.ceil(newVoicemail_tableN/4);
				$scope.new_area_iTableNum= Math.ceil(newIm_tableN/4);

				// recent activity 소식 갯수
				var recent_tableN = $('.recent_table tbody tr').length;
				var notice_tableN = $('.notice_table tbody tr').length;

				$scope.recent_area_tableNum= Math.ceil(recent_tableN/4);
				$scope.currentPageNum =1;
	   			$scope.new_area_click = function (a) {
		   			var table = $('.missedCall_table,.newVoicemail_table,.newIm_table');
					$scope.customDatas = [];
					if(a==1){
	   					if ($scope.cCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}
					    else{
							moveToPageNum($scope.factory.global.lang_default, 0 , 1);

	   						//page number and list end
	   						if($scope.isNew_area1==false&&$scope.isNew_area2==false&&$scope.isNew_area3==false){
								$scope.isNew_area1=1;
								// $scope.animation1='first';
	   						}
						    else if($scope.isNew_area1==false){
	   							$scope.isNew_area1=1;
							    // 	$scope.animation1='second';
		   						$scope.isNew_area2=$scope.isNew_area3=false;
	   						}
						    else{
	   							// table.slideUp('1000');
							    $scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
			                    // 		$scope.animation1='last';
			                    // 		$timeout(function(){
			                    // 		$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
										// 		},1000)
	   						}
	   					}
	   				}
					else if(a==2){
	   					if ($scope.vCount==0) {
	   						if($scope.factory.memberStorageLevel=="UCP"){
	   						    $scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
		   					}
						    else{
		   						if($scope.isNew_area2==false){
			                        $scope.isNew_area2=1;
			                        $scope.isNew_area1=$scope.isNew_area3=false;
			   					}
							    else{
		   						    $scope.isNew_area2=false;
			   					}
		   					}
	   					}
					    else{
	   						//page number and list start
	   						//setPageNum($scope.voiceMailDatas);
	   						moveToPageNum($scope.factory.global.lang_default, 1,1);
	   						//page number and list end
	   						if($scope.isNew_area1==false&&$scope.isNew_area2==false&&$scope.isNew_area3==false){
								$scope.isNew_area2=1;
								// $scope.animation1='first';
	   						}
						    else if($scope.isNew_area2==false){
	   							$scope.isNew_area2=1;
							    // 		$scope.animation1='second';
		   						$scope.isNew_area1=$scope.isNew_area3=false;
	   						}
						    else{
							    // 		$scope.animation1='last';
							    $scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
			                    // 		$timeout(function(){
			                    // 		$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
							    // 		},1000)
	   						}
	   					}
	   				}
					else{
	   					if ($scope.iCount==0) {
	   						$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
	   					}
					    else{
	   						//page number and list start
	   						//setPageNum($scope.IMDatas);
							//setPageNum($scope.iCount);
							//moveToPage($scope.factory.global.lang_default, $scope.IMDatas);
							moveToPageNum($scope.factory.global.lang_default, 2,1);
	   						//page number and list end
	   						if($scope.isNew_area1==false&&$scope.isNew_area2==false&&$scope.isNew_area3==false){
								$scope.isNew_area3=1;
								// $scope.animation1='first';
	   						}
						    else if($scope.isNew_area3==false){
	   							$scope.isNew_area3=1;
									// 		$scope.animation1='second';
		   						$scope.isNew_area1=$scope.isNew_area2=false;
	   						}
						    else{
									$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
									// 		$scope.animation1='last';
									// 		$timeout(function(){
									// 		$scope.isNew_area1=$scope.isNew_area2=$scope.isNew_area3=false;
								// 		},1000)
	   						}
	   					}
	   				}
	   			};

	   			$scope.connVoiceServer = function(){
				    amoebaDataFactory.connectToCMVoicemail();
	   			};
	   			
	   			// Recent Activity 클릭 시 채팅방으로 이동
	   			$scope.moveToGroup = function(data){
	   				$scope.$emit('moveToChat', { "data" : data });
	   			};
				// Recent actvity 사진 업데이트
				$scope.$on("CHANGED_USER_PICTURE", function(event, args){
					var userkey = args[0].str_user_key;
					amoebaService.IsupdateConvPic(userkey,amoebaDataFactory.recentList);

				})

	   			
	   			// 메인 대쉬보드 영역 스크롤
                $scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
       					updateOnContentResize: true
       				},
       				setWidth: '100%',
       				setHeight: '100%',
       				axis: 'y',
       				scrollInertia: 1000,
       				mouseWheel:{ deltaFactor: 60 }
	       		};

				$scope.$on("$viewContentLoaded", function(event){ // 0224 hyosung
					////console.log("contentCtrl Content Loaded")
				});
			}
		]
	);
});
