/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'callUserlistCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("calluserlistCtrl");
				
				$scope.factory = amoebaDataFactory;
				$scope.userListTitle = $scope.factory.global.lang_groupcall_list;
				$scope.btnName = $scope.factory.global.lang_start_call;
				$scope.ConversationUsersData = [];
				$scope.totalNum;
				$scope.defaultData = [];
				$scope.callArr = [1, 0, 0, 1];

				var defaultUserType = 3;
				var addUserType = 3;
				var dummyType = 10;
				var dummyName = "dummy";
				var currentUserProfile;
			
				amoebaDataFactory.callingUserlistCtlscope = $scope;
				if(amoebaDataFactory.currentConversationData != null){
					$scope.totalNum = amoebaDataFactory.currentConversationData.strary_conv_members_userkey.length +1;
				}

				$scope.$watch('ConversationUsersData', function() {
					if(typeof  $scope.ConversationUsersData != 'undefined')
					{
						$scope.totalNum = $scope.ConversationUsersData.length -1;
					}

				}, true);
				
				$scope.checkConversation = function(){
					var current = amoebaDataFactory.currentConversationData;
					var profile = currentUserProfile;
					var result = true;
					var count = 0;
					if(angular.isDefined(profile)){
						if(angular.isDefined(profile.memInfo)){
							if(current.strary_conv_members_userkey.length == profile.memInfo.userkey.length){
								for(i in current.strary_conv_members_userkey){
									if(current.strary_conv_members_userkey[i] == profile.memInfo.userkey[i] && current.strary_conv_members_number[i] == profile.memInfo.number[i]){
										result = true;
									}
									else {
										result = false;
										break;
									}
								}
							}
							else {
								result = false;
							}
						}
						else {
							result = true;
						}
					}

					return result;
				};
				
				$scope.conversationUserList = function(){
					var iLoginMode = amoebaDataFactory.loginInfo.int_license_type.val; // 0: premium , 1: standard
					$scope.ConversationUsersData.length = 0;
					var profile = currentUserProfile;
					var allUser = amoebaDataFactory.contactUserData;
					var current = amoebaDataFactory.currentConversationData;
					//console.log("currentconversation");
					//console.log(amoebaDataFactory.currentConversationData.strary_conv_members_userkey);
					//console.log(amoebaDataFactory.currentConversationData);
					var memNum;
					var memUsers;
					var memArr = [];
					
					if($scope.checkConversation()){
						if(current != undefined){
							if(current.strary_conv_members_number.length > 0 || current.strary_conv_members_userkey.length >0){
								memNum = current.strary_conv_members_number;
								if(memNum.length == 0)
								{
									for(var i in current.strary_conv_members_userkey)
									{
										for(var j in allUser)
										{
											if(current.strary_conv_members_userkey[i] == allUser[j].str_user_key.val)
											{
												memNum.push(allUser[j].str_user_number.val);
												j =0;
												break;
											}
											if(j == allUser.length -1){
												memNum.push(0);
												j=0;
											}
										}
									}
								}
								memUsers = current.strary_conv_members_userkey;
							}
							else {
								memNum = [];
								memUsers = [];
								if(current.str_conv_member_number.val != "")
								{
									memNum.push(current.str_conv_member_number.val);
								}
								if(current.str_conv_member_userkey.val != "")
								{
									memUsers.push(current.str_conv_member_userkey.val);
								}
							}
						}
						else {
							if(profile != undefined){
								memNum = profile.memInfo.number;
								memUsers = profile.memInfo.userkey;
							}
						}
							
						if(amoebaDataFactory.currentPage == 21){
							defaultUser = 5;
							addUserType = 2;
							dummyType = 11;
							dummyName = "add";
						} else  if(amoebaDataFactory.currentPage == 23){
							defaultUser = 5;
							addUserType = 2;
							dummyType = 10;
							dummyName = "dummy";
						} else {
							if(amoebaDataFactory.ucsStatus ==  "OUT_GROUP_CALL")
							{
								defaultUser = 5;
								addUserType = 2;
								dummyType = 11;
								dummyName = "add";
							}
							else
							{
								defaultUser = 3;   // by hycha  userlist card type
								addUserType = 3;
								dummyType = 10;
								dummyName = "dummy";
							}
						}
						if(amoebaDataFactory.ucsStatus == "IN_GROUP_CALL"){
							defaultUser = 1;
							addUserType = 2;
							dummyType = 11;
							dummyName = "add";
						}

						if(iLoginMode == 1) {

							//console.log("userkeylastone");
							//console.log(memUsers);
							var userlist =[];
							angular.copy(memUsers,userlist);
							for(var i in userlist)
							{
								if(userlist[i] == userlist[i] == "dummy" || userlist[i] == amoebaDataFactory.userInfoData.str_my_key || userlist[i] == "add") // by nouserkey
								{
									userlist.splice(i,1);
								}
							}
							for(var i in memNum)
							{
								if(memNum[i] == amoebaDataFactory.userInfoData.str_desk_phone1.val) // by nouserkey
								{
									memNum.splice(i,1);
								}
							}
							//console.log("usernumlist");
							//console.log(memNum);
							if(userlist.length >0){
								for (var j = 0; j < userlist.length; j++) {
									var flag = false;
									if(userlist[j] != amoebaDataFactory.userInfoData.str_my_key)
									{
										for (var i in allUser) {
											if (allUser[i].str_user_key.val == userlist[j]) {
												var obj = {}
												angular.copy(allUser[i], obj);
												obj.str_user_number.val = memNum[j];
												obj.selectedPhone = memNum[j];
												obj.int_ui_type = defaultUser;
												obj.check = true;
												obj.callStatus = 0;
												//obj.showNum = true;
												//obj.isnew = 1;   // for groupcall
												memArr.push(obj);
												flag = true;
												break;
											}

										}
										if (!flag) {
											var obj = {};
											angular.copy(amoebaDataFactory.basicUserTemp, obj);
											obj.str_user_number.val = memNum[j];
											obj.int_ui_type = defaultUser;
											obj.str_first_name.val = memNum[j];
											obj.check = true;
											obj.callStatus = 0;
											//obj.showNum = true;
											//obj.isnew = 1;  // for groupcall
											memArr.push(obj);
										}
									}

								}
								//console.log("alluserlist");
								//console.log(memArr);
								angular.copy(memArr, $scope.defaultData);
								$scope.$emit("callUserSet", {data :  $scope.defaultData});
								var myData = [];
								var addUser = {};
								angular.copy(amoebaDataFactory.basicUserTemp, addUser);

								addUser.str_user_key.val = dummyName;
								addUser.int_ui_type = dummyType;

								//myData.push(amoebaDataFactory.myProfile.str_user_id.val);
								var arr;
								var userpicture;

								arr= amoebaDataFactory.userInfoData;
								arr.str_user_number={val:arr.str_desk_phone1.val};
								arr.str_user_key ={val:arr.str_my_key};
								arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
								arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
								arr.int_ui_type = 1;
								if(typeof obj  != 'undefined')
								{
									obj.callStatus = 1;
								}

								if(amoebaDataFactory.ucsStatus == "IN_GROUP_CALL"){
									arr.int_ui_type = 13;
									memArr.push(arr);
								}
								else{
									memArr.unshift(arr);
									memArr.push(addUser);
								}
								//$scope.defaultData.length = 0;
								currentUserProfile = undefined;
								if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

								}
								else{
									var userpicture ={
										"str_picture_data":{val:null},
										"str_user_key":{val:null}
									};
									userpicture["str_user_key"].val = arr.str_my_key;
									userpicture["str_picture_data"].val = arr.str_picture_data.val;
									amoebaDataFactory.pictureData.push(userpicture);
								}

								//console.log("groupcallmemberstandard");
								//console.log(memArr);
								return memArr;
							}
							else{

								//angular.copy(memArr, $scope.defaultData);
								//$scope.$emit("callUserSet", {data :  $scope.defaultData});
								//var myData = [];
								var addUser = {};
								angular.copy(amoebaDataFactory.basicUserTemp, addUser);

								addUser.str_user_key.val = dummyName;
								addUser.int_ui_type = dummyType;

								//myData.push(amoebaDataFactory.myProfile.str_user_id.val);
								var arr;
								arr= amoebaDataFactory.userInfoData;
								arr.str_user_number={val:arr.str_desk_phone1.val};
								arr.str_user_key ={val:arr.str_my_key};
								arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
								arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
								arr.int_ui_type = 1;
								if(amoebaDataFactory.ucsStatus == "IN_GROUP_CALL"){
									arr.int_ui_type = 13;
									memArr.push(arr);
								}
								else{
									memArr.unshift(arr);
									memArr.push(addUser);
								}
								//$scope.defaultData.length = 0;
								currentUserProfile = undefined;
								//console.log("groupcallmemberstandard");
								//console.log(memArr);
								return memArr;
							}
						}
						else if(iLoginMode == 0)
						{
							//console.log(memUsers);
							var userlist =[];
							angular.copy(memUsers,userlist);
							for(var i in userlist)
							{
								if(userlist[i] == "dummy" || userlist[i] == amoebaDataFactory.userInfoData.str_my_key || userlist[i] == "add") // "NoUserKey 제외 , 국선 사용자 정보 찾을때"
								{
									userlist.splice(i,1);
								}
							}
							for(var i in memNum)
							{
								if(memNum[i] == amoebaDataFactory.userInfoData.str_desk_phone1.val) // by nouserkey
								{
									memNum.splice(i,1);
								}
							}
							//console.log("usernumlist");
							//console.log(memNum);

							if(userlist.length >0){
								amoebaDataFactory.getSomeUserInfo(userlist).then(function(item){
									if(item != false){
										//console.log("userlistallmember");
										//console.log(userlist);
										//console.log(item);
										for(var j = 0; j < userlist.length; j++){
											var flag = false;
											for(var i in item) {
												//for (var j in memUsers) {
												if (item[i].str_user_key.val == userlist[j]) {
													item[i].int_ui_type = defaultUser;
													item[i].check = true;
													item[i].callStatus = 0;
													item[i].onmute = false;
													if(memNum[j] != 0 && IsCallNumber(memNum[j],item[i]) == true){
														//console.log("numlist");
														item[i].selectedPhone = memNum[j];
													}
													else{

													}

													//item[i].showNum = true;
													//item[i].showOut = true;
													memArr.push(item[i]);
													flag = true;
													break;
												}
												//}
											}
											if(!flag){
												var obj = {};
												angular.copy(amoebaDataFactory.basicUserTemp, obj);
												obj.str_user_number.val = memNum[j];
												obj.str_desk_phone1.val = memNum[j];
												obj.int_ui_type = defaultUser;
												obj.str_first_name.val = memNum[j];
												obj.str_user_key.val = "NoUserKey";
												obj.check = true;
												obj.callStatus = 0;
												obj.onmute = false;
												//item[i].showOut = true;
												memArr.push(obj);
											}

										}
										amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "userlist");
										amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, item);
										//memArr = item;
										angular.copy(memArr, $scope.defaultData);
										//console.log("userlist");
										amoebaService.checkedDimData(allUser, $scope.defaultData);
										//amoebaService.checkedDimData(contact, $scope.defaultData);
										//$scope.$emit("callUserSet", {data :  $scope.defaultData});   // by hyeonyeong cha
										var myData = [];
										var addUser = {};
										angular.copy(amoebaDataFactory.basicUserTemp, addUser);

										addUser.str_user_key.val = dummyName;
										addUser.int_ui_type = dummyType;
										//myData.push(amoebaDataFactory.myProfile.str_user_id.val);
										var arr;
										//var userpicture;
								
										arr= amoebaDataFactory.userInfoData;
										arr.str_user_number={val:arr.str_desk_phone1.val};
										arr.selectedPhone=arr.str_desk_phone1.val;
										arr.str_user_key ={val:arr.str_my_key};
										arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
										arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
										arr.int_ui_type = 1;
										if(typeof obj  != 'undefined'){
											obj.callStatus = 1;
										}
										if(amoebaDataFactory.ucsStatus == "IN_GROUP_CALL"){
											arr.int_ui_type = 13;
											memArr.push(arr);
										}
										else{
											memArr.unshift(arr);
											memArr.push(addUser);
										}
										
										currentUserProfile = undefined;
										if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

										}
										else{
											var userpicture ={
												"str_picture_data":{val:null},
												"str_user_key":{val:null}
											};
											userpicture["str_user_key"].val = arr.str_my_key;
											userpicture["str_picture_data"].val = arr.str_picture_data.val;
											amoebaDataFactory.pictureData.push(userpicture);
										}
							
										//console.log("groupcallmember");
										//console.log(memArr);
										$scope.ConversationUsersData = memArr;
										return memArr;


									}
									else{

										var addUser = {};
										angular.copy(amoebaDataFactory.basicUserTemp, addUser);
										addUser.str_user_key.val = dummyName;
										addUser.int_ui_type = dummyType;
										if(memNum.length >0){
											var obj = {};
											angular.copy(amoebaDataFactory.basicUserTemp, obj);
											obj.str_user_number.val = memNum[0];
											obj.str_desk_phone1.val = memNum[0];
											obj.int_ui_type = defaultUser;
											obj.str_first_name.val = memNum[0];
											obj.str_user_key.val = "NoUserKey";
											obj.check = true;
											obj.callStatus = 0;
											memArr.push(obj);
										}
										else{

										}

										arr= amoebaDataFactory.userInfoData;
										arr.str_user_number={val:arr.str_desk_phone1.val};
										arr.selectedPhone=arr.str_desk_phone1.val;
										arr.str_user_key ={val:arr.str_my_key};
										arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
										arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
										arr.int_ui_type = 1;
										if(typeof obj  != 'undefined'){
											obj.callStatus = 1;
										}
										if(amoebaDataFactory.ucsStatus == "IN_GROUP_CALL"){
											arr.int_ui_type = 13;
											memArr.push(arr);
										}
										else{
											memArr.unshift(arr);
											memArr.push(addUser);
										}
										$scope.ConversationUsersData = memArr;
										return memArr;
									}
								});
							}
							else{
				
								var addUser = {};
								angular.copy(amoebaDataFactory.basicUserTemp, addUser);
								addUser.str_user_key.val = dummyName;
								addUser.int_ui_type = dummyType;
								var arr;
								var userpicture;
								arr= amoebaDataFactory.userInfoData;
								arr.str_user_number={val:arr.str_desk_phone1.val};
								arr.str_user_key ={val:arr.str_my_key};
								arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
								arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
								arr.int_ui_type = 1;
								if(typeof obj  != 'undefined'){
									obj.callStatus =0;
								}
								memArr.unshift(arr);
								memArr.push(addUser);
								//$scope.defaultData.length = 0;
								currentUserProfile = undefined;
								if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

								}
								else{
									var userpicture ={
										"str_picture_data":{val:null},
										"str_user_key":{val:null}
									};
									userpicture["str_user_key"].val = arr.str_my_key;
									userpicture["str_picture_data"].val = arr.str_picture_data.val;
									amoebaDataFactory.pictureData.push(userpicture);
								}
								$scope.ConversationUsersData = memArr;

								return memArr;
							}
						}
					}
				};

				function IsCallNumber(selectedphone,data){

					var bResult = false;
					if(angular.isDefined(data.str_desk_phone1) && data.str_desk_phone1.val != "" && data.str_desk_phone1.val != null && angular.isDefined(data.str_desk_phone1.val)){
						bResult = true;

					}
					if(angular.isDefined(data.str_cellular_phone) && data.str_cellular_phone.val != "" && data.str_cellular_phone.val != null && angular.isDefined(data.str_cellular_phone.val)){
						bResult = true;
					}
					if(angular.isDefined(data.str_home_telephone) && data.str_home_telephone.val != "" && data.str_home_telephone.val != null && angular.isDefined(data.str_home_telephone.val)){
						bResult = true;
					}
					if(angular.isDefined(data.str_office_telephone) && data.str_office_telephone.val != "" && data.str_office_telephone.val != null && angular.isDefined(data.str_office_telephone.val)){
						bResult = true;
					}
					return bResult;
				};




				$scope.$on('GROUP_CALL_STATUS', function (event, args) {
					amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "GroupCallStatus");
					var GroupCallMemberInfo = args.GroupCallMemberInfo;
					var userlist = $scope.ConversationUsersData;
					$scope.isStation = true;
					var length =0;
					if(GroupCallMemberInfo != null){
						if(GroupCallMemberInfo.hasOwnProperty('iConfMemberCount')){
							length = GroupCallMemberInfo.iConfMemberCount;
						}
						else{
							length = GroupCallMemberInfo.length;
						}
					}
					else{
						//length = GroupCallMemberInfo.length;
					}

					if(userlist != undefined  &&  GroupCallMemberInfo != undefined && userlist != null) { // BELOW IS ?????
						for (var i = 0; i < length; i++) {
							for (var j = 0; j < userlist.length; j++) {
								if(GroupCallMemberInfo[i]!= undefined){
									if (amoebaDataFactory.userInfoData.str_desk_phone1.val != userlist[j].str_user_number.val
										&& userlist[j].selectedPhone == GroupCallMemberInfo[i].strConfMemberTelNo && userlist[j].str_user_key.val != "add") {
										//console.log("confmemberstatus");
										if (GroupCallMemberInfo[i].iConfMemberState == 9) { // invite
											userlist[j].callStauts = 1;
											userlist[j].selectedtype = "MD1-userCard type_2";
											userlist[j].showNum = false;
											userlist[j].isStation= true;
											userlist[j].isNumDrop = false;
											userlist[j].isnew =0;
											if(amoebaDataFactory.bIsMasterMute) {
												userlist[j].onmute = false;
												userlist[j].mute = false;
											}
											break;
										}
										else if(GroupCallMemberInfo[i].iConfMemberState == 6){  // conference
											userlist[j].isnew =0;
											userlist[j].callStauts = 0;
											userlist[j].selectedtype = "MD1-userCard type_5";
											amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG,"bmastermute");
											amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG,amoebaDataFactory.bIsMasterMute);

											if(amoebaDataFactory.bIsMasterMute){
												userlist[j].onmute = true;
												userlist[j].mute = false;
											}
											//userlist[j].onmute = true; // edit by hycha .. for master can mute attendee.
											//userlist[j].showOut = true;
											userlist[j].showNum = false;

											userlist[j].isStation= true;
											userlist[j].isNumDrop = false;
											amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "GroupCallMemberconnected");
											amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, userlist[j]);
											break;
										}
										else if(GroupCallMemberInfo[i].iConfMemberState == 8){ // conf on mute
											userlist[j].isnew =0;
											userlist[j].callStauts = 0;
											userlist[j].selectedtype = "MD1-userCard type_5";
											if(amoebaDataFactory.bIsMasterMute) {
												userlist[j].onmute = true;
												userlist[j].mute = true;
											}
											//userlist[j].onmute = true; // edit by hycha
											//userlist[j].showOut = true;
											userlist[j].showNum = false;

											userlist[j].isStation= true;
											userlist[j].isNumDrop = false;
											amoebaDataFactory.printTrace("confmembermute");
											amoebaDataFactory.printTrace(userlist[j].onmute);
											break;
										}	
										else{ // out
											userlist[j].isnew =0;
											userlist[j].callStauts = 0;
											userlist[j].selectedtype = "MD1-userCard type_5";
											userlist[j].onmute = false;
											userlist[j].showNum = false;
											userlist[j].isStation= true;
											userlist[j].isNumDrop = false;

											break;
										}
									}
								}
							}
						}
					}
				});

				$scope.$on("$viewContentLoaded", function(event){ // 0224 hyosung
					$timeout(function () {
					
						var contactUser = amoebaDataFactory.mainCtrlScope.contactUser;
						if($scope.ConversationUsersData != undefined){
							for(var j =0 ; j <$scope.ConversationUsersData.length; j++){
								for(var k in contactUser){
									if($scope.ConversationUsersData[j].str_user_key.val == contactUser[k].str_user_key.val){
										$scope.ConversationUsersData[j].str_phone_status.val = contactUser[k].str_phone_status.val;
										$scope.ConversationUsersData[j].str_im_status.val = contactUser[k].str_im_status.val;
									
									}
								}
							}
						}
						$scope.$broadcast('GROUP_CALL_STATUS', {"GroupCallMemberInfo":amoebaDataFactory.GroupCallMemberlist});
					},1000);
				});

				$scope.$on("PRESENCE_NOTIFY_IND", function(event){ // 0224 hyosung
					$timeout(function () {
						var contactUser = amoebaDataFactory.mainCtrlScope.contactUser;
						if($scope.ConversationUsersData != undefined){
							for(var j =0 ; j <$scope.ConversationUsersData.length; j++){
								for(var k in contactUser){
									if($scope.ConversationUsersData[j].str_user_key.val == contactUser[k].str_user_key.val){
										if(contactUser[k].str_user_key.val == "401"){
											//amoebaDataFactory.printTrace("newuserpresence");
											//amoebaDataFactory.printTrace(contactUser[k].str_phone_status.val);
											//amoebaDataFactory.printTrace($scope.ConversationUsersData[j].str_phone_status.val);
										}
										$scope.ConversationUsersData[j].str_phone_status.val = contactUser[k].str_phone_status.val;
										$scope.ConversationUsersData[j].str_im_status.val = contactUser[k].str_im_status.val;
										
									}
								}
							}
						}
					},1000);
				});

				$scope.ConversationUsersData = $scope.conversationUserList();

				$scope.multiSelection = function(){
					$scope.$emit("addConversationUser", {"isCall" : true});
				};
				
				$scope.$on("updateCallUserList", function(event, args){
					if(angular.isDefined(args.profile)){
						currentUserProfile = args.profile;
					} else {
						currentUserProfile = undefined;
					}
					$scope.ConversationUsersData = $scope.conversationUserList();
				});

				$scope.$on("UPDATE_CALL_USER_LIST", function(event, args){
					var callinguserlist = args.userlist.strary_conv_members_userkey;
					//console.log("updatecalluserlist");
					//console.log(callinguserlist);
					var userlist = $scope.ConversationUsersData;
					var realmember =[];
					//console.log(amoebaDataFactory.userInfoData.str_my_key);
					for(var i in userlist){
						//console.log(userlist[i].str_user_key.val);
						if(userlist[i].str_user_key.val == "add" || userlist[i].str_user_key.val == amoebaDataFactory.userInfoData.str_my_key){
							realmember.push(userlist[i]);
						}
						if(userlist[i].str_user_key.val != amoebaDataFactory.userInfoData.str_my_key){
							if (isUser(callinguserlist, userlist[i].str_user_key.val)) {
								realmember.push(userlist[i]);
							}
						}

						$scope.ConversationUsersData = realmember;
					
					}

					//console.log("lastmember");
					//console.log(realmember);
					
				});

				function isUser(callinguserlist, str_user_key){
					var bResult = false;
					for(var i in callinguserlist){

						if(callinguserlist[i] == str_user_key){
							bResult = true;
							break;
						}
					}
					return bResult;

				}

//////////////////////////////////user add start////////////////////////////////////////////////////////////////
				//선택해제
				$scope.unSelect = function(user){
					//console.log("newuser");
					//console.log(user);
					if(user.isnew == 1){
						//console.log("newunselecgetuser");
						$scope.$emit("unselectDeleteUser", {data : user});
						return;
					}
					if(amoebaDataFactory.ucsStatus == "OUT_GROUP_CALL"){
						$scope.factory.removeMember(user).then(function(item){
							if(item != false){
								//console.log(user);
								//console.log("removemembertrue");
								$scope.factory.broadcastUIEvent("OUT_GROUP_CALL_MEMBER",{"userlist":item});
								$scope.$emit("unselectDeleteUser", {data : user});
							}
						});
					}
					else{
						$scope.$emit("unselectDeleteUser", {data : user});
					}
				};

				$scope.$on("updategroupcalllist", function(event, args){
					var conversationlist = args.data;
					var callinguserlist=[];
					var userlist=[];
					var myInfo = amoebaDataFactory.userInfoData;
					for(var i in conversationlist){
						if(conversationlist[i].selectedPhone != "" && conversationlist[i].selectedPhone != myInfo.selectedPhone){
							callinguserlist.push(conversationlist[i].selectedPhone);
							userlist.push(conversationlist[i].str_user_key.val);
						}
					}
					if(callinguserlist.length == 0){

					}
					//console.log("currentconversationlistafterupdategroupcall");
					//console.log(amoebaDataFactory.currentConversationData);
					amoebaDataFactory.currentConversationData.strary_conv_members_number = callinguserlist;
					amoebaDataFactory.currentConversationData.strary_conv_members_userkey = userlist;
					// 그룹콜 시 Task 영역으로 가기 위한 객체
					amoebaDataFactory.mainCtrlScope.groupCallingData = {};
					angular.copy(amoebaDataFactory.currentConversationData, amoebaDataFactory.mainCtrlScope.groupCallingData);
				});

				//mainCtrl에서 선택
				$scope.$on("selectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					var user = args.user;
					userSelected(id, groupKey,user);
				});
				
				//mainCtrl에서 그룹 모두 선택
				$scope.$on("isAllCheck", function(event, args){
					var targat;
					var check; 
					var data = args.list;
					var isCheck = args.check;
					var list = []; 
					angular.copy($scope.ConversationUsersData, list);
					
					if(isCheck){
						target = data;
						check = list;
					} else {
						target = list;
						check = data;
					}
					
					for(var i = 0; i < check.length; i++){
						for(var j in target){
							if(check[i].str_user_key.val == target[j].str_user_key.val){
								target.splice(j, 1);
								break;
							}
						}
					}
				
					for(var i in target)
					{
						target[i].isnew = 1;
					}
					
					$scope.ConversationUsersData.length = 0;
					if(isCheck){
						$scope.ConversationUsersData = target.concat(check);
					} else {
						$scope.ConversationUsersData = target;
					}
				});
				
				//mainCtrl에서 선택 해제
				$scope.$on("unselectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					userUnselected(id, groupKey);
				});
				
				//선택해제
				function userUnselected(id, groupKey) {
					var data = $scope.ConversationUsersData;
					if(data.length == 0) return;
					
					for(var i in data){
						if(data[i].str_user_key.val == id){
							data.splice(i, 1);
							break;
						}
					}
					
				}
				
				//선택
				function userSelected(id, groupKey, user) {
					var all = amoebaDataFactory.contactUserData;
					var result = false;
		
					if(user.str_user_key.val == id){
						user.int_ui_type = addUserType;
						user.callStatus = 0;
								
						var check = false;
						for(var j in $scope.ConversationUsersData){

							if($scope.ConversationUsersData[j].str_user_key.val == id){
								//console.log("userincluded");
								//console.log($scope.ConversationUsersData[j].selectedPhone);
								check = true;
								//$scope.ConversationUsersData[j].isnew =1;
							}
						}
						if(check == false){
						
							user.isnew =1;
							//console.log(user);
							user.isPrivate = false;
							user.showNum = true;
							user.isDrop = false;
									
							var id = user.str_user_key.val;
									
							if(id.charAt(0) == "p"){
								user.int_ui_type =14;
								user.isStation= true;
								user.selectedPhone= user.str_office_telephone.val;
								user.isNumDrop = false;
								user.isNumSelect = false;
										
							}
							else{
								user.int_ui_type =3;
								user.selectedtype ="MD1-userCard type_3";
								user.selectedPhone = user.str_desk_phone1.val;
							}

							user.is_confmember_mute ={val:0};
							user.conumber=amoebaDataFactory.getCoNumber();
							$scope.ConversationUsersData.splice($scope.ConversationUsersData.length - 1, 0,user);
						}
					}
				};
				
				$scope.selectUserFunc = function(data){
					if(!angular.isDefined(data.callCheck)){
						data.callCheck = true;
					} else {
						data.callCheck = !data.callCheck;
					}
				};
				
				$scope.addUserGroup = function(){
					//console.log("콜 컨트롤러 addUserGroup");
					$scope.resetDialText();   // add(11.16)
					$scope.resetContactText(); // add(11.16) hycha
					amoebaDataFactory.showgroupCallbtn = false;
					var conversationData = $scope.ConversationUsersData;
			
					var flag = true;

					conversationData[0].memInfo = {"number": [], "userkey": []};
					for(var i = 0; i < conversationData.length; i++){
						if(angular.isDefined(conversationData[i].selectedPhone)){
							conversationData[0].memInfo.number.push(conversationData[i].selectedPhone);
						} else {
							conversationData[0].memInfo.number.push(conversationData[i].str_user_number.val);
						}
						conversationData[0].memInfo.userkey.push(conversationData[i].str_user_key.val);
					}
					
					if(amoebaDataFactory.ucsStatus =="CALL_ING" && amoebaDataFactory.currentPage == 23){
						$scope.$emit("callOnAgain", {"data" : conversationData});
					}
					else {
						if(conversationData.length > 1){
							//console.log("calluserlist");
							//console.log(conversationData);
							if(!CallNumberExisted(conversationData)){
								amoebaDataFactory.showMainFail("CallNuberNotExisted");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
							if(!CheckDuplicatedNumber(conversationData)){
								amoebaDataFactory.showMainFail("DuplicatedNumberExistd");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
							if(!CheckCONumberExisted(conversationData)){
								amoebaDataFactory.showMainFail("CONumberNotExisted");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
			
							
							if(conversationData.length >= 32)
							{
								amoebaDataFactory.showMainFail("lang_group_call_over_count");
								amoebaDataFactory.showgroupCallbtn = true;
							}
							else
							{
								conversationData[conversationData.length -1].selectedtype = "MD1-userCard type_11";
								$scope.$emit("inviteToCallGroup", {"data" : conversationData});
							}
						}
						else {
							$scope.$emit("defaultCall", {"data" : conversationData[0], "number" : conversationData[0].selectedPhone})
						}
					}
				};
				
				$scope.$on("addNewPrivateUser", function(event, args){
					var number = args.data;
					userPrivateSelected(number);
				});

				function CheckCONumberExisted(memberinfo){
					var isCO=true;

					for (var i = 0; i < memberinfo.length; i++)
					{
						if(memberinfo[i].int_ui_type == 14 && memberinfo[i].isStation == false){   //
							if(!angular.isDefined(memberinfo[i].conumber)){
								isCO = false;
							}
							else{
								if(memberinfo[i].conumber == ""){
									isCO = false;
								}
							}
							break;
						}
					}
					return isCO;
				}

				/*function CheckNewNumberExisted(memberinfo){
					var groupcalluserlist = amoebaDataFactory.GroupCallMemberlist;
					for(var j in memberinfo){
						for(var i in groupcalluserlist) {
							if (memberinfo[i].selectedPhone == groupcalluserlist) {
								if (memberinfo[i].isnew == 1) {
									isNew = true;
									//newMember.push(memberinfo[i]);
								}
							}
						}
					}
					
					return isNew;

				};*/

				//}

				function CallNumberExisted(memberinfo){
					var bResult = true;
					//console.log("callnumberlist");
					//console.log(memberinfo);
					for(var i =0; i < memberinfo.length; i++){
						if((memberinfo[i].selectedPhone == "" || memberinfo[i].selectedPhone == null )  && memberinfo[i].str_user_key.val != "add"  && memberinfo[i].str_user_key.val != "dummy"){
							bResult= false;
							break;
						}

					}
					return bResult;
				}

				function CheckDuplicatedNumber(memberinfo){
					var isUnique=true

					for (var i = 0; i < memberinfo.length; i++)
					{
						for (var j = 0; j < memberinfo.length; j++)
						{
							if (i != j)
							{
								if (memberinfo[i].selectedPhone == memberinfo[j].selectedPhone)
								{
									isUnique=false;
								}
							}
						}
					}
					return isUnique;
				};
				
				function userPrivateSelected(number) {
					var data = {};
					angular.copy(amoebaDataFactory.basicUserTemp, data);
					//data.str_desk_phone1.val = number;
					data.str_user_number.val = number;
					data.str_user_key.val = "phoneUser";
					data.str_first_name.val = number;
					data.int_ui_type = 14;
					data.isnew=1;
					//data.isStation = false;
					data.conumber=amoebaDataFactory.getCoNumber();
					$scope.ConversationUsersData.splice($scope.ConversationUsersData.length - 1, 0, data);
					//checkPrivate();
				}
				
				function checkPrivate(){
					var data = $scope.ConversationUsersData;
					$scope.isPrivate = false;
					for(var no =0; no < data.length; no++){
						var id = data[no].str_user_key.val;
						if(id.charAt(0) == "p"){
							$scope.isPrivate = true;
						}
					};
				}

				$scope.$on("PRESENCE_NOTIFY_IND", function(event, args){
					var stPresenceData = args;
					var data = $scope.ConversationUsersData;

					if(data === undefined){
						return;
					}
					else{
						if(data.length === undefined){
							return;
						}
					}

					for(var k =0; k < data.length; k++)
					{
						if(data[k].str_user_key.val ==stPresenceData.strMemberKey)
						{
							if(stPresenceData.iMemberIMStatus != null)
							{
								data[k].str_im_status.val = stPresenceData.iMemberIMStatus;
							}
							if(stPresenceData.iMemberPhoneStatus != null)
							{
								data[k].str_phone_status.val = stPresenceData.iMemberPhoneStatus;
							}

						}
					}
				});

				$scope.$on('CHANGE_TO_GROUP_CALL', function(event, args){

					var strMasterNumber = args.strMasterNumber;
					var iLoginMode = amoebaDataFactory.loginInfo.int_license_type.val; // 0: premium , 1: standard
					var allUser = amoebaDataFactory.contactUserData;
					var ConversationData ={};
					var memArr = [];
					angular.copy(amoebaDataFactory.basicCTemp, ConversationData);
					ConversationData.strary_conv_members_number.push(strMasterNumber);
				
					if(amoebaDataFactory.currentPage == 21){
						defaultUser = 2;
						addUserType = 2;
						dummyType = 11;
						dummyName = "add";
					} else  if(amoebaDataFactory.currentPage == 23){
						defaultUser = 2;
						addUserType = 2;
						dummyType = 10;
						dummyName = "dummy";
					} else {
				
						defaultUser = 2;
						addUserType = 2;
						dummyType = 11;
						dummyName = "add";
					
					}

					if(iLoginMode == 1) {
						var flag = false;

						for (var i =0; i < allUser.length; i++) {
							if (allUser[i].str_user_number.val == strMasterNumber) {
								var obj = {}
								angular.copy(allUser[i], obj);
								obj.str_user_number.val = strMasterNumber;
								obj.int_ui_type = 1;
								obj.check = true;
								obj.callStatus = 0;
								//obj.isnew = 1;   // for groupcall
								memArr.push(obj);
								flag = true;
								break;
							}
						}

						if (!flag) {
							var obj = {};
							angular.copy(amoebaDataFactory.basicUserTemp, obj);
							obj.str_user_number.val =  strMasterNumber;
							obj.int_ui_type = 1;
							obj.str_first_name.val = strMasterNumber;
							obj.check = true;
							obj.callStatus = 0;
							//obj.isnew = 1;  // for groupcall
							memArr.push(obj);
						}

						angular.copy(memArr, $scope.defaultData);
						$scope.$emit("callUserSet", {data :  $scope.defaultData});
						//var myData = [];
						var addUser = {};
						angular.copy(amoebaDataFactory.basicUserTemp, addUser);

						addUser.str_user_key.val = dummyName;
						addUser.int_ui_type = dummyType;
						
						var arr;
						arr= amoebaDataFactory.userInfoData;
						arr.str_user_number={val:arr.str_desk_phone1.val};
						arr.str_user_key ={val:arr.str_my_key};
						arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
						arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
						arr.int_ui_type = 13;
						if(typeof obj  != 'undefined')
						{
							obj.callStatus = 1;
						}

						memArr.push(arr);
						memArr.push(addUser);
						$scope.defaultData.length = 0;
						currentUserProfile = undefined;
						if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

						}
						else{
							var userpicture ={
								"str_picture_data":{val:null},
								"str_user_key":{val:null}
							};
							userpicture["str_user_key"].val = arr.str_my_key;
							userpicture["str_picture_data"].val = arr.str_picture_data.val;
							amoebaDataFactory.pictureData.push(userpicture);
						}
						
						return memArr;
					}
					else if(iLoginMode == 0){
						amoebaDataFactory.getUserInfoFromNumber(strMasterNumber).then(function(item){
							if(item != false){
								for(var i in item){
									item.int_ui_type = 1;
									item.check = true;
									item.callStatus = 0;
								}
								
								amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "userlist");
								amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, item);
								memArr = item;
								angular.copy(memArr, $scope.defaultData);

								//var myData = [];
								var addUser = {};
								angular.copy(amoebaDataFactory.basicUserTemp, addUser);

								addUser.str_user_key.val = dummyName;
								addUser.int_ui_type = dummyType;
								var arr;

								arr= amoebaDataFactory.userInfoData;
								arr.str_user_number={val:arr.str_desk_phone1.val};
								arr.selectedPhone = {val:arr.str_desk_phone1.val};
								arr.str_user_key ={val:arr.str_my_key};
								arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
								arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val}
								arr.int_ui_type = 13;
								if(typeof obj  != 'undefined')
								{
									obj.callStatus = 1;
								}

								memArr.push(arr);
								memArr.push(addUser);
								$scope.defaultData.length = 0;
								currentUserProfile = undefined;
								if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

								}
								else{
									var userpicture ={
										"str_picture_data":{val:null},
										"str_user_key":{val:null}
									};
									userpicture["str_user_key"].val = arr.str_my_key;
									userpicture["str_picture_data"].val = arr.str_picture_data.val;
									amoebaDataFactory.pictureData.push(userpicture);
								}

								$scope.ConversationUsersData = memArr;
								return memArr;
							}
						});
					}
				});

//////////////////////////////////user add end////////////////////////////////////////////////////////////////
				// 콜 중 유저 리스트 스크롤
	       		$scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
       					updateOnContentResize: true
       				},
					axis:'y',
					setWidth: '100%',
       				setHeight: $(this).parent().height(),
       				scrollInertia: 500
	       		}
			}
////////////////////////////////////////////////////////////////////		app end
		]
	);
});
