/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'createConversationCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("createConversationCtrl");

////////////////////////////////////////////////////////////////// app start
//////////////////////////////conversation user start////////////////////////////////////
				$scope.service = amoebaService;
				$scope.factory = amoebaDataFactory;
				$scope.dummy = {};
				angular.copy(amoebaDataFactory.basicUserTemp, $scope.dummy);

				$scope.dummy.str_user_key.val="dummy";
				//기준			
				$scope.ConversationUsersData = [$scope.dummy];
				//추가될 유저수
				$scope.totalNum = 0;

				amoebaDataFactory.createConversationCtrl = $scope;
				$scope.$watch('ConversationUsersData', function() {
					$scope.totalNum = $scope.ConversationUsersData.length - 1;
				}, true);
				
				$scope.unSelect = function(user){
					
					$scope.$emit("unselectDeleteUser", {data : user});
				};

				$scope.$on("isAllCheck", function(event, args){
					var targat;
					var check; 
					var data = args.list;
					var isCheck = args.check;
					var list = [];
					angular.copy($scope.ConversationUsersData, list);
					
					var arr = [];
					var flag;
					
					angular.forEach(list, function(user){
						flag = false;
						angular.forEach(data, function(addUser, index){
							if(!flag){
								if(user.str_user_key.val == addUser.str_user_key.val){
									if(isCheck){
										data.splice(index, 1);
										flag = true;
									}
								}
							}
						})
					});
					
					angular.forEach(data, function(add){
						var id = add.str_user_key.val;
						var groupKey = add.int_group_id.val;;
						if(isCheck){
							//userSelected(id, groupKey);
							userSelected(id, groupKey, add);
						} else {
							userUnselected(id, groupKey,add);
							//userSelected(id, groupKey, add);
						}
					});
				});
				
				$scope.$on("addNewPrivateUser", function(event, args){
					var number = args.data;
					userPrivateSelected(number);
				});
				
				$scope.$on("selectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					var user = args.user;
					userSelected(id, groupKey, user);
				});
				
				$scope.$on("unselectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					userUnselected(id, groupKey);
				});
				
				function userUnselected(id, groupKey) {
					
					var data = $scope.ConversationUsersData;
					
					if(data.length == 0) return;
					
					for(var i=0; i < data.length; i++){
						
						if(data[i].str_user_key.val == id){
							data.splice(i, 1);
							break;
						}
					}
					checkPrivate();
					checkUCSUser();
				}
				
				function userPrivateSelected(number) {
					var data = {};
					angular.copy(amoebaDataFactory.basicUserTemp, data);
					amoebaDataFactory.getUserInfoFromNumber(number).then(function(item){
						if(item != false)
						{
							console.log("phoneuser1");
							console.log(item);
							console.log(data);
							data.str_user_number.val = number;
							data.str_user_key.val = item[0].str_user_key;
							data.str_first_name.val = item[0].str_first_name;
							data.int_ui_type = 3;
							data.int_user_type.val = item[0].int_user_type;
							data.conumber=amoebaDataFactory.getCoNumber();
							$scope.ConversationUsersData.unshift(data);
						}
						else
						{
							data.str_user_number.val = number;
							data.str_user_key.val = "phoneUser";
							data.str_first_name.val = number;
							data.int_ui_type = 3;
							data.conumber=amoebaDataFactory.getCoNumber();
							$scope.ConversationUsersData.unshift(data);

						}
						checkPrivate();
						checkUCSUser();
					});
				}
				
				function userSelected(id, groupKey, user) {
					var all = amoebaDataFactory.contactUserData;
					var data = $scope.ConversationUsersData;
					//var all = amoebaDataFactory.allUserData;
					var result = false
					//data = user;
					for(var no = 0; no < 2; no++){
						if(user.str_user_key.val == id){
							user.int_ui_type = 3;

							var check = false;
							for(var j = 0; j < data.length; j++){
								if(data[j].str_user_key.val == id){
									check = true;
								}
							}

							if(check == false){
								data.unshift(user);
								user.isnew =1;
								user.is_confmember_mute ={val:0};
								user.conumber=amoebaDataFactory.getCoNumber();
								user.isStation = true;
								user.selectedPhone = user.str_desk_phone1.val;
								user.showNum = true;
								user.isDrop = false;
								//user.isNumDrop = false;
								//console.log("selecteduser");
								//console.log(user);
							}

							result = true;
							break;
						}
						if(result){
							break;
						}
						else {
							//data = all;
						}
					}
					checkPrivate();
					checkUCSUser();
				}
				
				function checkPrivate(){
					var data = $scope.ConversationUsersData;
					$scope.isPrivate = false;
					for(var no = 0; no < data.length; no++){
						var id = data[no].str_user_key.val;
						if(id.charAt(0) == "p"){
							$scope.isPrivate = true;
							data[no].int_ui_type =14;
							data[no].int_user_type.val = 3;
							data[no].isNumDrop = false;
							data[no].isNumSelect = false;
						
						}
					};
				}
				
				function checkUCSUser(){
					var data = $scope.ConversationUsersData;
					$scope.isUCSUser = true;
					for(var no =0; no < data.length; no++){
						//var id = data[no].str_user_key.val;
						if(data[no].int_user_type != undefined){
							if(data[no].int_user_type.val == 2 || data[no].int_user_type.val == 3){
								$scope.isUCSUser = false;
							}
						}

					};
					return $scope.isUCSUser;
				}

				function resetMem(){
					$scope.ConversationUsersData.length = 0;
					$scope.ConversationUsersData.push($scope.dummy);
					$scope.isPrivate = false;
				}
				
				// IM 생성
				$scope.startIm = function(){
					if(!checkUCSUser()){
						amoebaDataFactory.showMainFail("SelectedNonUCSUser");
						return;
					}
					var conversationData = $scope.ConversationUsersData;
					//conversationData.splice(conversationData.length -1, 1);
					angular.copy(conversationData, amoebaDataFactory.addUserData);
					amoebaDataFactory.currentConversationData = undefined;

					//conversation 추가시 1 : 1이라면  기존껄로, 아니라면 새로 생성
					if(conversationData.length == 1){
						for(var i =0; i < amoebaDataFactory.conversationData.length; i++){
							if(amoebaDataFactory.conversationData[i].str_conv_member_userkey.val == $scope.ConversationUsersData[0].str_user_key.val){
								amoebaDataFactory.currentConversationData = amoebaDataFactory.conversationData[i];
								amoebaDataFactory.addUserData.length = 0;
							}
						}
					}
					if(conversationData.length > 50)
					{
						amoebaDataFactory.showMainFail("lang_group_chat_over_count");
						return;

					}
					for(var i=0; i< conversationData.length; i++){
						conversationData[i].isnew =1;
					}
					$scope.$emit("createConversation", {"data" : conversationData, "bool": false});
					resetMem();
					
				};
				
				// 전화 시작

				var timer = null;
				$scope.startCall = function(){
					$scope.resetDialText();
					$scope.resetContactText(); // add(11.15) hycha
					//console.log("startCall");
					//console.log(timer);
					clearTimeout(timer);
					timer = setTimeout($scope.delayed_startCall, 200);
					//console.log(timer);
				};

				$scope.delayed_startCall = function(){
					//console.log("delayed_startCall");
					var conversationData = $scope.ConversationUsersData;				

					// 1:1 전화라면
					if(conversationData.length == 2){
						
						//console.log("start one groupcall");
						if(conversationData.length == 1){
							for(var i =0; i < amoebaDataFactory.conversationData.length; i++){
								if(amoebaDataFactory.conversationData[i].str_conv_member_userkey.val == $scope.ConversationUsersData[0].str_user_key.val){
									amoebaDataFactory.currentConversationData = amoebaDataFactory.conversationData[i];
									amoebaDataFactory.addUserData.length = 0;
								}
							}
						}
						var number = $scope.ConversationUsersData[0].selectedPhone;
						$scope.ConversationUsersData[0].isnew=0;
						if($scope.ConversationUsersData[0] != "")
						{
							amoebaDataFactory.MakeCall(number);
						}
						else
						{
							amoebaDataFactory.showMainFail("lang_call_number_not_selected");
						}
					}
					else{
						//console.log("calluserlistnumber");
						//console.log(conversationData);
						if(!CallNumberExisted(conversationData)){
							amoebaDataFactory.showMainFail("CallNuberNotExisted");
							return;
						}
						if(!CheckDuplicatedNumber(conversationData)){
							amoebaDataFactory.showMainFail("DuplicatedNumberExistd");
							return;
						}
						if(!CheckCONumberExisted(conversationData)){
							amoebaDataFactory.showMainFail("CONumberNotExisted");
							return;
						}

						//console.log("startinvitegroupcall");
						if(conversationData.length > 32)
						{
							amoebaDataFactory.showMainFail("lang_group_call_over_count");

						}
						else
						{
							$scope.$emit("startInviteGroupCall", {"data" : conversationData});
						}
					}
				};


				function CallNumberExisted(memberinfo){
					var bResult = true;
					for(var i=0; i < memberinfo.length; i++){
						if((memberinfo[i].selectedPhone == "" || memberinfo[i].selectedPhone == null )  && memberinfo[i].str_user_key.val != "dummy"){
							bResult= false;
							break;
						}

					}
					return bResult;
				}

				function CheckCONumberExisted(memberinfo){
					var isCO=true;

					for (var i = 0; i < memberinfo.length; i++)
					{
						if(memberinfo[i].int_ui_type == 14 && memberinfo[i].isStation == false){   //
							if(!angular.isDefined(memberinfo[i].conumber)){
								isCO = false;
							}
							else{
								if(memberinfo[i].conumber == ""){
									isCO = false;
								}
							}
							break;
						}
					}
					return isCO;
				};

				function CheckDuplicatedNumber(memberinfo){
					var isUnique=true

					for (var i = 0; i < memberinfo.length; i++)
					{
						for (var j = 0; j < memberinfo.length; j++)
						{
							if (i != j)
							{
								if ((memberinfo[i].selectedPhone == memberinfo[j].selectedPhone) && memberinfo[i].selectedPhone != "" &&  memberinfo[j].selectedPhone != "")
								{
									isUnique=false;
								}
							}
						}
					}
					return isUnique;
				}
				
				// 컨버세이션 생성 영역 유저 리스트 스크롤
	       		$scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
       					updateOnContentResize: true
       				},
							axis:'y',
       				setWidth: '100%',
       				setHeight: $(this).parent().height(),
       				scrollInertia: 500
	       		}
			}
//////////////////////////////delete user end////////////////////////////////////
//////////////////////////////////////////////////////////////////app end
		]
	);
});
