/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'userlistCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("userlistCtrl");

				$scope.factory = amoebaDataFactory;
				amoebaDataFactory.userlistCtrlscope = $scope;

				$scope.userListTitle = $scope.factory.global.lang_user_list;
				$scope.btnName = $scope.factory.global.lang_invite_groupim;
				
				if(!amoebaDataFactory.mainCtrlScope.addConvUserlist){
					$scope.userListTitle =$scope.factory.global.lang_calluser_list;
					$scope.btnName =  $scope.factory.global.lang_invite_groupcall;
				}

				if(amoebaDataFactory.loginInfo.int_license_type.val == 1)
				{
					$scope.btnName = $scope.factory.global.lang_invite_groupcall;
				}

				$scope.ConversationUsersData = [];
				$scope.totalNum;
				$scope.defaultData = [];
				
//				var defaultUserType = 3;
//				var addUserType = 3;
				var dummyType = 10;
				var dummyName = "dummy";

				var iLoginMode = amoebaDataFactory.loginInfo.int_license_type.val;
				$scope.iLoginMode = iLoginMode;
				if(amoebaDataFactory.currentConversationData.bool_is_group.val == true)
				{
					$scope.totalNum = amoebaDataFactory.currentConversationData.strary_conv_members_userkey.length +1;
				}
				else
				{
					$scope.totalNum = 2;
				}

				$scope.$watch('ConversationUsersData', function() {
					if(typeof $scope.ConversationUsersData != 'undefined')
					{

						$scope.totalNum = $scope.ConversationUsersData.length - 1;
					}

				}, true);
				
				$scope.conversationUserList = function(){
					var iLoginMode = amoebaDataFactory.loginInfo.int_license_type.val; // 0: premium , 1: standard
					if($scope.ConversationUsersData != undefined)
					{
						$scope.ConversationUsersData.length = 0;
					}
					var allUser = amoebaDataFactory.contactUserData;
					var current = amoebaDataFactory.currentConversationData;
					var contact = amoebaDataFactory.contactUserData;
					var memNum;
					var memUsers;
					var memArr = [];

					if(current.strary_conv_members_userkey.length > 0){  // for 1:N IM
						memNum = current.strary_conv_members_number;
						memUsers = current.strary_conv_members_userkey;
					} else {
						memNum = [];
						memUsers = [];
						memNum.push(current.str_conv_member_number.val);
						memUsers.push(current.str_conv_member_userkey.val);
					}

					for(var i in memUsers)
					{
						if(memUsers[i] == amoebaDataFactory.userInfoData.str_my_key)
						{
							memUsers.splice(i,1);
						}
					}
					if(iLoginMode == 1)
					{
						for(var j = 0; j < memUsers.length; j++){
							var flag = false;
							for(var i in allUser){
								if(allUser[i].str_user_key.val == memUsers[j]){
									var obj = {}
									angular.copy(allUser[i], obj);
									obj.str_user_number.val = memNum[j];
									obj.int_ui_type = 13;
									memArr.push(obj);
									flag = true;
									break;
								}
							}

							if(!flag){
								var obj = {};
								angular.copy(amoebaDataFactory.basicUserTemp, obj);
								obj.str_user_number.val = memNum[j];
								obj.str_first_name.val = memNum[j];
								obj.str_user_key.val = memUsers[j]; // by hyosung
								obj.check = true;
								obj.int_ui_type = 13;
								memArr.push(obj);
							}
						}
						angular.copy(memArr, $scope.defaultData);
						amoebaService.checkedDimData(allUser, $scope.defaultData);
						amoebaService.checkedDimData(contact, $scope.defaultData);
						//var myData = [];
						var addUser = {};
						angular.copy(amoebaDataFactory.basicUserTemp, addUser);
						if(amoebaDataFactory.currentPage == 20){
							addUser.str_user_key.val = "dummy";
							addUser.int_ui_type = 10;

						}
						else if(amoebaDataFactory.currentPage == 23){
							addUser.str_user_key.val = "add";
							addUser.int_ui_type = 11;
						}
						else {

							addUser.str_user_key.val = "add";
							addUser.int_ui_type = 11;
							$scope.btnName = $scope.factory.global.lang_invite_groupcall;
						}

						var arr;
						arr= amoebaDataFactory.userInfoData;
						arr.str_user_number={val:arr.str_desk_phone1.val};
						arr.str_user_key ={val:arr.str_my_key};
						arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
						arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val};
						arr.int_ui_type = 1;

						if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

						}
						else{
							var userpicture ={
								"str_picture_data":{val:null},
								"str_user_key":{val:null}
							};
							userpicture["str_user_key"].val = arr.str_my_key;
							userpicture["str_picture_data"].val = arr.str_picture_data.val;
							amoebaDataFactory.pictureData.push(userpicture);
						}
						memArr.unshift(arr);
						if(amoebaDataFactory.currentPage == 13 && amoebaDataFactory.ucsStatus == "OUT_CALL" && amoebaDataFactory.ucsStatus == "OUT_GROUP_CALL"){

						}
						else {

						}
						$scope.defaultData.length = 0;
						$scope.ConversationUsersData = memArr;
						//console.log("conversationuserdata");
						//console.log(memArr);
						return memArr;
					}
					else if(iLoginMode ==0)
					{
						var userlist =[];
						angular.copy(memUsers,userlist);
						for(var i in userlist)
						{
							if(userlist[i] == "NoUserKey" || userlist[i] == "dummy" || userlist[i] == amoebaDataFactory.userInfoData.str_my_key || userlist[i] == "")
							{
								userlist.splice(i,1);
							}
						}
						if(userlist.length >0)
						{
							amoebaDataFactory.getSomeUserInfo(userlist).then(function(item) {
								if (item != false) {
									for (var i in item) {
										for (var j in memUsers) {
											if (item[i].str_user_key.val == memUsers[j]) {
												item[i].int_ui_type = 13;

											}
										}
									}
									amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, "userlist");
									amoebaDataFactory.TRACE.printTrace(amoebaDataFactory.TRACE.TRACE_LEVEL.DEBUG, item);
									memArr = item;
									angular.copy(memArr, $scope.defaultData);
									amoebaService.checkedDimData(allUser, $scope.defaultData);
									amoebaService.checkedDimData(contact, $scope.defaultData);
									var myData = [];
									var addUser = {};
									angular.copy(amoebaDataFactory.basicUserTemp, addUser);
									if(amoebaDataFactory.currentPage == 20){

										addUser.str_user_key.val = "dummy";
										addUser.int_ui_type = 10;

									} else if(amoebaDataFactory.currentPage == 23){

										addUser.str_user_key.val = "add";
										addUser.int_ui_type = 11;
									}
									else {

										addUser.str_user_key.val = "add";
										addUser.int_ui_type = 11;

									}

									var arr;


									arr= amoebaDataFactory.userInfoData;
									arr.str_user_number={val:arr.str_desk_phone1.val};
									arr.selectedPhone=arr.str_desk_phone1.val;
									arr.str_user_key ={val:arr.str_my_key};
									arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
									arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val};
									arr.int_ui_type = 1;
									arr.callStatus = 1;
									if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

									}
									else{
										var userpicture ={
											"str_picture_data":{val:null},
											"str_user_key":{val:null}
										};
										userpicture["str_user_key"].val = arr.str_my_key;
										userpicture["str_picture_data"].val = arr.str_picture_data.val;
										amoebaDataFactory.pictureData.push(userpicture);
									}
									memArr.unshift(arr);
									if(amoebaDataFactory.currentPage == 13 && amoebaDataFactory.ucsStatus == "OUT_CALL" || iLoginMode == 1){

									} else {
										memArr.push(addUser);
									}
									$scope.defaultData.length = 0;
									$scope.ConversationUsersData = memArr;
									return memArr;
								}
								else{

									
								}

							});
						}
						else{
							if(memUsers[0] == "NoUserKey"){
								for(var j = 0; j < memUsers.length; j++){

									var obj = {};
									angular.copy(amoebaDataFactory.basicUserTemp, obj);
									obj.str_user_number.val = memNum[j];
									obj.str_first_name.val = memNum[j];
									obj.str_user_key.val ="NoUserKey";
									obj.check = true;
									obj.int_ui_type = 13;
									memArr.push(obj);

								}
							}
							angular.copy(memArr, $scope.defaultData);
							amoebaService.checkedDimData(allUser, $scope.defaultData);
							amoebaService.checkedDimData(contact, $scope.defaultData);
							//var myData = [];
							var addUser = {};
							angular.copy(amoebaDataFactory.basicUserTemp, addUser);
							if(amoebaDataFactory.currentPage == 20){

								addUser.str_user_key.val = "dummy";
								addUser.int_ui_type = 10;

							} else if(amoebaDataFactory.currentPage == 23){

								addUser.str_user_key.val = "add";
								addUser.int_ui_type = 11;
							}
							else {

								addUser.str_user_key.val = "add";
								addUser.int_ui_type = 11;

							}
							//var myData = [];
							var addUser = {};
							angular.copy(amoebaDataFactory.basicUserTemp, addUser);
							if(amoebaDataFactory.currentPage == 20){

								addUser.str_user_key.val = "dummy";
								addUser.int_ui_type = 10;

							} else if(amoebaDataFactory.currentPage == 23){

								addUser.str_user_key.val = "add";
								addUser.int_ui_type = 11;
							}
							else {

								addUser.str_user_key.val = "add";
								addUser.int_ui_type = 11;

							}
							var arr;
							arr= amoebaDataFactory.userInfoData;
							arr.str_user_number={val:arr.str_desk_phone1.val};
							arr.str_user_key ={val:arr.str_my_key};
							arr.str_im_status ={val:amoebaDataFactory.myStatus.str_im_status.val};
							arr.str_phone_status ={val:amoebaDataFactory.myStatus.str_phone_status.val};
							arr.int_ui_type = 1;
							if(UCAPP.UC.DATA.Contact.IsPictureExisted(arr.str_user_key.val)){

							}
							else{
								var userpicture ={
									"str_picture_data":{val:null},
									"str_user_key":{val:null}
								};
								userpicture["str_user_key"].val = arr.str_my_key;
								userpicture["str_picture_data"].val = arr.str_picture_data.val;
								amoebaDataFactory.pictureData.push(userpicture);
							}
							memArr.unshift(arr);
							if(amoebaDataFactory.currentPage == 13 && amoebaDataFactory.ucsStatus == "OUT_CALL" || iLoginMode == 1){

							} else {
								memArr.push(addUser);
							}
							$scope.defaultData.length = 0;
							$scope.ConversationUsersData = memArr;
							return memArr;
						}
					}
				};
				
				$scope.ConversationUsersData = $scope.conversationUserList();
				checkUCSUser();
				$scope.multiSelection = function(){
					$scope.$emit("addConversationUser", {"isCall" : false});
				};
				
				$scope.$on("updateUserList", function(event, args){
//					var name = args.name;
					$scope.ConversationUsersData = $scope.conversationUserList();
				});
////////////////////////////////user add start////////////////////////////////////////////////////////////////
				//선택해제
				$scope.unSelect = function(user){
					
					$scope.$emit("unselectDeleteUser", {data : user});
				};
				//mainCtrl에서 선택
				$scope.$on("selectedUser", function(event, args){
					var id = args.id;
					var groupKey = args.groupKey;
					var user = args.user;
					userSelected(id, groupKey, user);
				});
				
				//mainCtrl에서 그룹 모두 선택
				$scope.$on("isAllCheck", function(event, args){
					var targat;
					var check; 
					var data = args.list;
					var isCheck = args.check;
					var list = []; 
					angular.copy($scope.ConversationUsersData, list);
					
					if(isCheck){
						target = data;
						check = list;
					} else {
						target = list;
						check = data;
					}
					
					for(var i = 0; i < check.length; i++){
						for(var j in target){
							if(check[i].str_user_key.val == target[j].str_user_key.val){
								target.splice(j, 1);
								break;
							}
						}
					}
					// by hyeonyeong cha
					for(var i in target)
					{
						target[i].isnew = 1;
					}
					$scope.ConversationUsersData.length = 0;
					if(isCheck){
						$scope.ConversationUsersData = target.concat(check);
					} else {
						$scope.ConversationUsersData = target;
					}
				});

				//mainCtrl에서 선택 해제
				$scope.$on("unselectedUser", function(event, args){
					
					var id = args.id;
					var groupKey = args.groupKey;
					userUnselected(id, groupKey);
				});
				
				//선택해제
				function userUnselected(id, groupKey) {
					var data = $scope.ConversationUsersData;
					if(data.length == 0) return;
					
					for(var i in data){
						if(data[i].str_user_key.val == id){
							data.splice(i, 1);
							break;
						}
					}
					checkUCSUser();
				}
				
				//선택
				function userSelected(id, groupKey ,user) {
					//var user = amoebaDataFactory.contactUserData;
					var all = amoebaDataFactory.contactUserData;
					var result = false
					//data = user;
					for(var no = 0; no < 2; no++){

						if(user.str_user_key.val == id){
							user.int_ui_type = 4;
								
							var check = false;
							for(var j in $scope.ConversationUsersData){
								if($scope.ConversationUsersData[j].str_user_key.val == id){
									check = true;
								}
							}
								
							if(check == false){
								if(id.charAt(0) == "p"){
									user.int_ui_type =14;
									user.isStation= true;
									user.selectedPhone= user.str_office_telephone.val;
									user.isNumDrop = false;
									user.isNumSelect = false;

								}
								else{
									user.selectedPhone = user.str_desk_phone1.val;
									user.int_ui_type =3;
									user.selectedtype ="MD1-userCard type_3";
								}
								//console.log("userlistselected");
								//console.log(user);
								user.conumber=amoebaDataFactory.getCoNumber();;
								user.isnew = 1;
								user.is_confmember_mute ={val:0};
								user.isDrop = false;
								user.showNum = true;
								$scope.ConversationUsersData.splice($scope.ConversationUsersData.length - 1, 0, user);
							}

							result = true;
							break;
						}

						if(result){
							break;
						} else {

						}
					}

					checkPrivate();
					checkUCSUser();
				}
				
				$scope.selectUserFunc = function(data){
					data.check = !data.check;
					$scope.$emit("selectUser", {"data" : data, "check" : data.check});
				};

				$scope.addUserGroup = function(){
					//console.log("유저 컨트롤러 addUserGroup");
					
					var allUser = amoebaDataFactory.contactUserData;
					var conversationData = $scope.ConversationUsersData;
					var count = 0;

					for( var i in conversationData){
						if(conversationData[i].isnew == 1){
							count++;
						}
					}
					//console.log(conversationData);

					if((amoebaDataFactory.mainCtrlScope.addConvUserlist == false && amoebaDataFactory.ucsStatus == "OUT_GROUP_CALL")  ||
						(amoebaDataFactory.mainCtrlScope.addConvUserlist == false && amoebaDataFactory.ucsStatus == "CALL_ING"))
					{
						
						//console.log("전화중이고 인바이트 그룹콜");

						var stArycalluserlist=[];
						var callinguser;
						var mynumber = amoebaDataFactory.userInfoData.str_desk_phone1.val;
						angular.copy(conversationData, stArycalluserlist);


						if(amoebaDataFactory.callviewInfo != null){
							if(amoebaDataFactory.callviewInfo.str_user_number != null){
								callinguser = amoebaDataFactory.callviewInfo.str_user_number.val;
							}
						}


						for(i = stArycalluserlist.length -1; i >=0; i -=1){
							if(stArycalluserlist[i].selectedPhone === callinguser || stArycalluserlist[i].selectedPhone === mynumber || stArycalluserlist[i].selectedPhone === ""){
								stArycalluserlist.splice(i,1);
							}
						}
						
						if(stArycalluserlist.length >0){
							angular.copy(conversationData, amoebaDataFactory.addUserData);
							if(!CallNumberExisted(conversationData)){
								amoebaDataFactory.showMainFail("CallNuberNotExisted");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
							if(!CheckDuplicatedNumber(conversationData)){
								amoebaDataFactory.showMainFail("DuplicatedNumberExistd");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
							if(!CheckCONumberExisted(conversationData)){
								amoebaDataFactory.showMainFail("CONumberNotExisted");
								amoebaDataFactory.showgroupCallbtn = true;
								return;
							}
							$scope.$emit("inviteToCallGroup", {"data" : conversationData});
						}
						else{
							amoebaDataFactory.showMainFail("lang_call_number_not_selected");
						}
					}
					// 전화 상태가 아니면
					else{

						//console.log(amoebaDataFactory.currentConversationData);

						// 1:1방 상태이면 그룹방을 생성한다
						if(amoebaDataFactory.currentConversationData.bool_is_group.val == false){
							
							//console.log("전화중아니고 1:1이라 그룹방 생성");
							//console.log("addusernum");
							if(!checkUCSUser()){
								amoebaDataFactory.showMainFail("SelectedNonUCSUser");
								//amoebaDataFactory.mainCtrlScope.addConvUserlist = false;
								return;
							}

							//console.log(count);
							var IMuserlist =[];
							for( var i in conversationData){
								if(conversationData[i].str_user_key.val.charAt(0) != "p"){
									IMuserlist.push(conversationData[i]);
									//count++;
								}
							}
							for( var i in conversationData){
								if(conversationData[i].str_user_key.val.charAt(0) != "p" && conversationData[i].isnew == 1){
									//IMuserlist.push(conversationData[i]);
									count++;
								}
							}

							if(count > 0){
								angular.copy(IMuserlist, amoebaDataFactory.addUserData);
								$scope.$emit("createConversation", {"data" : IMuserlist, "bool": false});
							} else {
								amoebaDataFactory.addUserData.length = 0;
								amoebaDataFactory.showMainFail("MemberNotSelected");
								amoebaDataFactory.mainCtrlScope.isUserList=false;
								amoebaDataFactory.showgroupCallbtn = false;
								//amoebaDataFactory.mainCtrlScope.addConvUserlist = false;
								$scope.ConversationUsersData[$scope.ConversationUsersData.length -1].str_user_key.val ="add";
								$scope.ConversationUsersData[$scope.ConversationUsersData.length -1].int_ui_type =11;
								$scope.ConversationUsersData[$scope.ConversationUsersData.length -1].selectedtype ="MD1-userCard type_11";
								return;
								
							}
						}
						// 현재 그룹 IM방이면 초대를 한다
						else{
							//console.log("전화중아니고 그룹방이라 초대");
							if(!checkUCSUser()){
								amoebaDataFactory.showMainFail("SelectedNonUCSUser");
								//amoebaDataFactory.mainCtrlScope.addConvUserlist = false;
								return;
							}

							var arr = [];
							for(var no in conversationData){
								if(conversationData[no].hasOwnProperty('isnew')){
									if(conversationData[no].isnew == 1){ // by hycha
										arr.push(conversationData[no]);
									}
								}
								
							}

							//console.log(arr);
							for(var i in arr){
								if(arr[i].str_user_key.val.charAt(0) == "p"){
									arr.splice(i,1);
								}
							}
							if(arr.length >0){  // new member existed
								//console.log("groupcallornot");
								amoebaDataFactory.mainCtrlScope.addConvUserlist = false; // add userlist mode 초기화
								$scope.$emit("inviteToGroup", {"data" : arr});
							}
							else{
								//console.log("existedchattingroom");
								amoebaDataFactory.showMainFail("MemberNotSelected");
								amoebaDataFactory.showgroupCallbtn = true;

							}
						}
					}
				};

				function CallNumberExisted(memberinfo){
					var bResult = true;
					for(var i in memberinfo){
						if((memberinfo[i].selectedPhone == "" || memberinfo[i].selectedPhone == null )  && memberinfo[i].str_user_key.val != "dummy"){
							bResult= false;
							break;
						}

					}
					return bResult;
				}
				function CheckDuplicatedNumber(memberinfo){
					var isUnique=true;

					for (var i = 0; i < memberinfo.length; i++)
					{
						for (var j = 0; j < memberinfo.length; j++)
						{
							if (i != j)
							{
								if (memberinfo[i].selectedPhone == memberinfo[j].selectedPhone)
								{
									isUnique=false;
								}
							}
						}
					}
					return isUnique;
				}

				function CheckCONumberExisted(memberinfo){
					var isCO=true;

					for (var i = 0; i < memberinfo.length; i++)
					{
						if(memberinfo[i].int_ui_type == 14 && memberinfo[i].isStation == false){   //
							if(!angular.isDefined(memberinfo[i].conumber)){
								isCO = false;
							}
							else{
								if(memberinfo[i].conumber == ""){
									isCO = false;
								}
							}
							break;
						}
					}
					return isCO;
				};

				$scope.$on("addNewPrivateUser", function(event, args){
					var number = args.data;
					userPrivateSelected(number);
				});
				
				function userPrivateSelected(number) {
					var data = {};
					angular.copy(amoebaDataFactory.basicUserTemp, data);
					//data.str_desk_phone1.val = number;
					data.str_user_number.val = number;
					data.str_user_key.val = "phoneUser";
					data.str_first_name.val = number;
					data.int_ui_type = 3;
					data.conumber=amoebaDataFactory.getCoNumber();
					$scope.ConversationUsersData.splice($scope.ConversationUsersData.length - 1, 0, data);

					if(iLoginMode == 0)
					{
						checkPrivate();
						checkUCSUser();
					}

				}
				
				function checkPrivate(){
					var data = $scope.ConversationUsersData;
					$scope.isPrivate = false;
					for(no in data){
						var id = data[no].str_user_key.val;
						if(id.charAt(0) == "p"){
							$scope.isPrivate = true;
							data[no].int_ui_type =14;
						}
					}
				}
				function checkUCSUser(){
					var data = $scope.ConversationUsersData;
					$scope.isUCSUser = true;
					for(var no in data){
						var id = data[no].str_user_key.val;
						if(data[no].int_user_type != undefined){
							if(data[no].int_user_type.val == 3 || data[no].int_user_type.val == 2){
								$scope.isUCSUser = false;
							}
						}

					}
					return $scope.isUCSUser;
				}

				$scope.$on("PRESENCE_NOTIFY_IND", function(event, args){
					var stPresenceData = args;
					for(var k  in $scope.ConversationUsersData)
					{
						if($scope.ConversationUsersData[k].str_user_key.val ==stPresenceData.strMemberKey)
						{
							if(stPresenceData.iMemberIMStatus != null)
							{
								$scope.ConversationUsersData[k].str_im_status.val = stPresenceData.iMemberIMStatus;
							}
							if(stPresenceData.iMemberPhoneStatus != null)
							{
								$scope.ConversationUsersData[k].str_phone_status.val = stPresenceData.iMemberPhoneStatus;
							}

						}
					}
				});

				$scope.$on("$viewContentLoaded", function(event){ // 0224 hyosung
					$timeout(function () {
						amoebaDataFactory.printTrace("calluserlistctrlscopepresence");
						var contactUser = amoebaDataFactory.mainCtrlScope.contactUser;
						if($scope.ConversationUsersData != undefined){
							for(var j =0 ; j <$scope.ConversationUsersData.length; j++){
								for(var k in contactUser){
									if($scope.ConversationUsersData[j].str_user_key.val == contactUser[k].str_user_key.val){
										$scope.ConversationUsersData[j].str_phone_status.val = contactUser[k].str_phone_status.val;
										$scope.ConversationUsersData[j].str_im_status.val = contactUser[k].str_im_status.val;
									}
								}
							}
						}
					},1000);
				});
				

				$scope.openProfile = function(data){
					//console.log("openProfile");
					//console.log(data);

					if(amoebaDataFactory.getCurrentState() != 'main.userlist'){
						return;
					}
					$scope.$emit("openChatProfile", {"id" : data.str_user_key.val});
				};
////////////////////////////////user add end////////////////////////////////////////////////////////////////				
				
				// 유저 리스트 편집 영역 스크롤
	       		$scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
       					updateOnContentResize: true
       				},
					axis:'y',
					setWidth: '100%',
       				setHeight: $(this).parent().height(),
       				scrollInertia: 500
	       		}
			}
////////////////////////////////////////////////////////////////////		app end
		]
	);
});
